/////所有模块列表
var all_module = {
	'SaleOrderCreate': {
		'data_href': '/erp_business/erp_business_sales_order_history.html',
		'data_permission': 'SALE.SALEORDER_CREATE.VIEW',
		'icon_class': 'ddh-icon-business_sales_order',
		'img_name': 'module_sale_order@3x.png',
		'show_name': '销售订单',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '销售订单、预售单历史',
		'add_feature': true,
		'add_data_href': '/erp_business/erp_business_sales_order_add.html',
		'add_data_permission': 'SALE.SALEORDER_CREATE.SAVE',
		'parent_module': 'Business'
	},
	'SaleCreate': {
		'data_href': '/erp_business/erp_business_sales_history.html',
		'data_permission': 'SALE.SALE_CREATE.VIEW',
		'icon_class': 'ddh-icon-business_sales_document',
		'img_name': 'module_sale@3x.png',
		'show_name': '销售单',
		'has_little_data': true,
		'data_refresh_data': 1,
		'sub_title_html': '最近销售额：',
		'sub_title_html_alt': '销售一单，就记一单', //辅助副标题，针对有has_little_data属性的
		'add_feature': true,
		'add_data_href': '/erp_business/erp_business_sales_add.html',
		'add_data_permission': 'SALE.SALE_CREATE.ACCOUNTING||SALE.SALE_CREATE.SAVE',
		'parent_module': 'Business'
	},
	'RetailCreate': {
		'data_href': '/erp_business/erp_business_retail_history.html',
		'data_permission': 'SALE.RETAIL_CREATE.VIEW',
		'icon_class': '',
		'img_name': 'module_retail@3x.png',
		'show_name': '零售单',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '零售单历史',
		'add_feature': true,
		'add_data_href': '/erp_business/erp_business_retail_add.html',
		'add_data_permission': 'SALE.RETAIL_CREATE.ACCOUNTING',
		'parent_module': 'Business'
	},
	'SaleReturnCreate': {
		'data_href': '/erp_business/erp_business_sales_return_history.html',
		'data_permission': 'SALE.SALERETURN_CREATE.VIEW',
		'icon_class': 'ddh-icon-business_sales_refund_document',
		'img_name': 'module_sale_return@3x.png',
		'show_name': '销售退货单',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '销售退货单历史',
		'add_feature': true,
		'add_data_href': '/erp_business/erp_business_sales_return_add.html',
		'add_data_permission': 'SALE.SALERETURN_CREATE.ACCOUNTING',
		'parent_module': 'Business'
	},
	'SaleDetail': {
		'data_href': '/erp_business/erp_business_sale_detail_list.html',
		'data_permission': 'SALE.SALE_DETAILLIST.VIEW',
        'icon_class': 'ddh-icon-data_contacts',
        'img_name': 'module_sale_detail_list@3x.png',
        'show_name': '销售明细表',
        'has_little_data': false,
        'data_refresh_data': '',
        'sub_title_html': '销售明细',
        'add_feature': false,
        'parent_module': 'Business'
    },
	'PurchaseOrderCreate': {
		'data_href': '/erp_business/erp_business_purchase_order_history.html',
		'data_permission': 'PURCHASE.PURCHASEORDER_CREATE.VIEW',
		'icon_class': 'ddh-icon-business_purchase_order',
		'img_name': 'module_purchase_order@3x.png',
		'show_name': '采购订单',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '采购订单历史',
		'add_feature': true,
		'add_data_href': '/erp_business/erp_business_purchase_order_add.html',
		'add_data_permission': 'PURCHASE.PURCHASEORDER_CREATE.SAVE',
		'parent_module': 'Business'
	},
	'PurchaseCreate': {
		'data_href': '/erp_business/erp_business_purchase_history.html',
		'data_permission': 'PURCHASE.PURCHASE_CREATE.VIEW',
		'icon_class': 'ddh-icon-business_purchase_document',
		'img_name': 'module_purchase@3x.png',
		'show_name': '采购单',
		'has_little_data': true,
		'data_refresh_data': 2,
		'sub_title_html': '最近采购金额：',
		'sub_title_html_alt': '有货才能销售，快采购吧',
		'add_feature': true,
		'add_data_href': '/erp_business/erp_business_purchase_add.html',
		'add_data_permission': 'PURCHASE.PURCHASE_CREATE.ACCOUNTING',//||Purchase.PurchaseCreate.Save
		'parent_module': 'Business'
	},
	'PurchaseReturnedCreate': {
		'data_href': '/erp_business/erp_business_purchase_return_history.html',
		'data_permission': 'PURCHASE.PURCHASERETURN_CREATE.VIEW',
		'icon_class': 'ddh-icon-business_purchase_refund_document',
		'img_name': 'module_purchase_return@3x.png',
		'show_name': '采购退货单',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '采购退货单历史',
		'add_feature': true,
		'add_data_href': '/erp_business/erp_business_purchase_return_add.html',
		'add_data_permission': 'PURCHASE.PURCHASERETURN_CREATE.ACCOUNTING',
		'parent_module': 'Business'
	},
	'PurchaseDetail': {
		'data_href': '/erp_business/erp_business_purchase_detail_list.html',
		'data_permission': 'PURCHASE.PURCHASE_DETAILLIST.VIEW',
        'icon_class': 'ddh-icon-data_contacts',
        'img_name': 'module_purchase_detail_list@3x.png',
        'show_name': '采购明细表',
        'has_little_data': false,
        'data_refresh_data': '',
        'sub_title_html': '采购明细',
        'add_feature': false,
        'parent_module': 'Report'
    },
	'StocktakingCreate': {
		'data_href': '/erp_business/erp_business_stocktaking_list.html',
		'data_permission': 'STOCKTAKING.STOCKTAKING_CREATE.VIEW',
		'icon_class': 'ddh-icon-business_inventory',
		'img_name': 'module_stocktaking@3x.png',
		'show_name': '库存盘点',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '盘点商品库存数量',
		'add_feature': true,
		'add_data_href': '/erp_business/erp_business_stocktaking_add.html',
		'add_data_permission': 'STOCKTAKING.STOCKTAKING_CREATE.ACCOUNTING',//||Stocktaking.StocktakingCreate.Save
		'parent_module': 'Business'
	},
	'TransferCreate': {
		'data_href': '/erp_business/erp_business_stock_transfer_list.html',
		'data_permission': 'STOCKTAKING.TRANSFER_CREATE.VIEW',
		'icon_class': 'ddh-icon-business_inventory_search',
		'img_name': 'module_stock_transfer@3x.png',
		'show_name': '同价调拨单',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '商品库存周转、调拨',
		'add_feature': true,
		'add_data_href': '/erp_business/erp_business_stock_transfer_add.html',
		'add_data_permission': 'STOCKTAKING.TRANSFER_CREATE.ACCOUNTING||STOCKTAKING.TRANSFER_CREATE.SAVE',
		'parent_module': 'Business'
	},
	'TransferAdjustCreate': {
		'data_href': '/erp_business/erp_business_stock_transfer_adjust_list.html',
		'data_permission': 'STOCKTAKING.TRANSFERADJUST_CREATE.VIEW',
		'icon_class': 'ddh-icon-business_inventory_search',
		'img_name': 'module_stock_transfer_adjust@3x.png',
		'show_name': '变价调拨单',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '商品库存周转、变价调拨',
		'add_feature': true,
		'add_data_href': '/erp_business/erp_business_stock_transfer_adjust_add.html',
		'add_data_permission': 'STOCKTAKING.TRANSFERADJUST_CREATE.ACCOUNTING||STOCKTAKING.TRANSFERADJUST_CREATE.SAVE',
		'parent_module': 'Business'
	},
	'StockOtherInCreate': {
		'data_href': '/erp_business/erp_business_stock_other_in_list.html',
		'data_permission': 'STOCKTAKING.OTHER_STOCKIN_CREATE.VIEW',
		'icon_class': '',
		'img_name': 'module_stock_other_in@2x.png',
		'show_name': '其他入库单',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '其他入库',
		'add_feature': true,
		'add_data_href': '/erp_business/erp_business_stock_other_in_add.html',
		'add_data_permission': 'STOCKTAKING.OTHER_STOCKIN_CREATE.ACCOUNTING',
		'parent_module': 'Business'
	},
	'StockOtherOutCreate': {
		'data_href': '/erp_business/erp_business_stock_other_out_list.html',
		'data_permission': 'STOCKTAKING.OTHER_STOCKOUT_CREATE.VIEW',
		'icon_class': '',
		'img_name': 'module_stock_other_out@2x.png',
		'show_name': '其他出库单',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '其他出库',
		'add_feature': true,
		'add_data_href': '/erp_business/erp_business_stock_other_out_add.html',
		'add_data_permission': 'STOCKTAKING.OTHER_STOCKOUT_CREATE.ACCOUNTING',
		'parent_module': 'Business'
	},
	'StockCostAdjustCreate': {
		'data_href': '/erp_business/erp_business_stock_cost_adjust_list.html',
		'data_permission': 'STOCKTAKING.COSTADJUSTMENT_CREATE.VIEW',
		'icon_class': '',
		'img_name': 'module_stock_cost_adjust@3x.png',
		'show_name': '成本调价单',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '商品库存成本调价',
		'add_feature': true,
		'add_data_href': '/erp_business/erp_business_stock_cost_adjust_add.html',
		'add_data_permission': 'STOCKTAKING.COSTADJUSTMENT_CREATE.ACCOUNTING',
		'parent_module': 'Business'
	},
	'ReportSerialNoList': {
		'data_href': '/erp_business/erp_business_stocktaking_sn_list.html',
		'data_permission': 'STOCKTAKING.REPORT_SERIALNOLIST.VIEW',
		'icon_class': 'ddh-icon-sn',
		'img_name': 'module_serial_query@3x.png',
		'show_name': '序列号查询',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '序列号历史跟踪',
		'add_feature': false,
		'add_data_href': '',
		'add_data_permission': '',
		'parent_module': 'Business'
	},
	'FinanceIncomeList': {
		'data_href': '/erp_finance/erp_finance_income_cost_list.html',
		'data_permission': 'FINANCE.FINANCE_INCOMELIST.VIEW',
		'icon_class': 'ddh-icon-bill_daily',
		'img_name': 'module_income_cost@3x.png',
		'show_name': '日常收支',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '日常收支记录',
		'add_feature': true,
		'add_data_href': '/erp_finance/erp_finance_income_cost_add.html',
		'add_data_permission': 'FINANCE.FINANCE_INCOMELIST.ACCOUNTING',
		'parent_module': 'Finance'
	},
	'FinanceInOutItemList': {
		'data_href': '/erp_finance/erp_finance_income_cost_type_list.html',
		'data_permission': 'FINANCE.FINANCE_INOUTITEMLIST.VIEW',
		'icon_class': 'ddh-icon-bill_revenue_management',
		'img_name': 'module_income_cost_type@3x.png',
		'show_name': '收支项目管理',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '日常收支分类管理',
		'add_feature': true,
		'add_data_href': '/erp_finance/erp_finance_income_cost_type_add.html',
		'add_data_permission': 'FINANCE.FINANCE_INOUTITEMLIST.ACCOUNTING',
		'parent_module': 'Finance'
	},
	'FinanceList': {
		'data_href': '/erp_finance/erp_finance_contacts_fund_records.html',
		'data_permission': 'FINANCE.FINANCE_LIST.VIEW',
		'icon_class': 'ddh-icon-bill_receivable',
		'img_name': 'module_customer_fund@3x.png',
		'show_name': '往来应收应付',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '资金往来业务产生的应收、应付',
		'add_feature': true,
		'add_data_href': '/erp_finance/erp_finance_contacts_fund_add.html',
		'add_data_permission': 'FINANCE.FINANCE_LIST.ACCOUNTING',
		'parent_module': 'Finance'
	},
	'FinanceFundFlowList': {
		'data_href': '/erp_finance/erp_finance_fund_flow_list.html',
		'data_permission': 'FINANCE.FINANCE_FUNDFLOWLIST.VIEW',
		'icon_class': 'ddh-icon-bill_capital_flow',
		'img_name': 'module_fund_flow@3x.png',
		'show_name': '资金流水',
		'has_little_data': true,
		'data_refresh_data': '3',
		'sub_title_html': '最近一笔:资金流水',
		'sub_title_html_alt': '资金流水记录',
		'add_feature': false,
		'add_data_href': '',
		'add_data_permission': '',
		'parent_module': 'Finance'
	},
	'AccountTranList': {
		'data_href': '/erp_finance/erp_finance_account_tran_list.html',
		'data_permission': 'FINANCE.ACCOUNTTRAN_LIST.VIEW',
		'icon_class': 'ddh-icon-bill_account_transfer',
		'img_name': 'module_account_transfer@3x.png',
		'show_name': '账户转账',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '账户款项流转',
		'add_feature': true,
		'add_data_href': '/erp_finance/erp_finance_account_tran_add.html',
		'add_data_permission': 'FINANCE.ACCOUNTTRAN_LIST.ACCOUNTING',
		'parent_module': 'Finance'
	},
	'BaseInfoProduct': {
		'data_href': '/erp_basedata/product_list.html',
		'data_permission': 'BASEINFO.BASEINFO_PRODUCT.VIEW',
		'icon_class': 'ddh-icon-data_contacts',
		'img_name': 'module_product_list@3x.png',
		'show_name': '商品列表',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '商品名称、售价、规格、库存、分类',
		'add_feature': true,
		'add_data_href': '/erp_basedata/product_info.html?pageTypes=add',
		'add_data_permission': 'BASEINFO.BASEINFO_PRODUCT.ACCOUNTING',
		'parent_module': 'Basedata'
	},
	'BaseInfoProductUnit': {
		'data_href': '/erp_basedata/product_unit_list.html',
		'data_permission': 'BASEINFO.BASEINFO_PRODUCTUNIT.VIEW',
		'icon_class': 'ddh-icon-data_unit',
		'img_name': 'module_product_unit@3x.png',
		'show_name': '商品单位',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '商品单位管理',
		'add_feature': true,
		'add_data_href': '/erp_basedata/product_unit_info.html?pageTypes=add',
		'add_data_permission': 'BASEINFO.BASEINFO_PRODUCTUNIT.ACCOUNTING',
		'parent_module': 'Basedata'
	},
	'BaseInfoProductCategory': {
		'data_href': '/erp_basedata/product_category.html',
		'data_permission': 'BASEINFO.BASEINFO_PRODUCTCATEGORY.VIEW',
		'icon_class': 'ddh-icon-data_classify',
		'img_name': 'module_product_category@3x.png',
		'show_name': '商品分类',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '商品分类管理',
		'add_feature': false,
		'add_data_href': '',
		'add_data_permission': '',
		'parent_module': 'Basedata'
	},
	'BaseInfoProductProp': {
		'data_href': '/erp_basedata/product_prop_list.html',
		'data_permission': 'BASEINFO.BASEINFO_PRODUCTPROP.VIEW',
		'icon_class': 'ddh-icon-data_property',
		'img_name': 'module_product_property@3x.png',
		'show_name': '商品属性',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '商品属性管理',
		'add_feature': false,
		'add_data_href': '',
		'add_data_permission': '',
		'parent_module': 'Basedata'
	},
	'BaseInfoContacts': {
		'data_href': '/erp_basedata/contacts_list.html',
		'data_permission': 'BASEINFO.BASEINFO_CONTACTS.VIEW',
		'icon_class': 'ddh-icon-data_contacts',
		'img_name': 'module_baseinfo_contacts@3x.png',
		'show_name': '往来单位',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '我的客户与供货商',
		'add_feature': true,
		'add_data_href': '/erp_basedata/contacts_info.html?pageType=add',
		'add_data_permission': 'BASEINFO.BASEINFO_CONTACTS.ACCOUNTING',
		'parent_module': 'Basedata'
	},
    'BaseInfoContactsCategory': {
        'data_href': '/erp_basedata/contacts_category.html',
        'data_permission': 'BASEINFO.BASEINFO_CONTACTS.VIEW',
        'icon_class': 'ddh-icon-data_contacts',
        'img_name': 'data_manclassify@3x.png',
        'show_name': '往来单位分类',
        'has_little_data': false,
        'data_refresh_data': '',
        'sub_title_html': '往来单位分类管理',
        'add_feature': false,
        'parent_module': 'Basedata'
    },
	'BaseInfoAccount': {
		'data_href': '/erp_basedata/account_list.html',
		'data_permission': 'BASEINFO.BASEINFO_ACCOUNT.VIEW',
		'icon_class': 'ddh-icon-data_settlement',
		'img_name': 'module_baseinfo_accounts@3x.png',
		'show_name': '结算账户',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '用于财务对账的经营账户',
		'add_feature': true,
		'add_data_href': '/erp_basedata/account_info.html?pageTypes=add',
		'add_data_permission': 'BASEINFO.BASEINFO_ACCOUNT.ACCOUNTING',
		'parent_module': 'Basedata'
	},
	'BaseInfoWarehouse': {
		'data_href': '/erp_basedata/warehouse_manage.html',
		'data_permission': 'BASEINFO.BASEINFO_WAREHOUSE.VIEW',
		'icon_class': 'ddh-icon-data_warehouse',
		'img_name': 'module_baseinfo_warehouse@3x.png',
		'show_name': '仓库管理',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '日常贮存商品的仓库信息',
		'add_feature': true,
		'add_data_href': '/erp_basedata/warehouse_info.html?pageTypes=add',
		'add_data_permission': 'BASEINFO.BASEINFO_WAREHOUSE.Accounting',
		'parent_module': 'Basedata'
	},
	'BaseInfoIniStock': {
		'data_href': '/erp_basedata/init_list.html',
		'data_permission': 'BASEINFO.BASEINFO_INISTOCK.VIEW',
		'icon_class': 'ddh-icon-data_initial_query',
		'img_name': 'module_baseinfo_initdata@3x.png',
		'show_name': '期初信息',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '开账以前的基础数据建立',
		'add_feature': false,
		'add_data_href': '',
		'add_data_permission': '',
		'parent_module': 'Basedata'
	},
	'SaleReportList': {
		'data_href': '/erp_report/report_sale_index.html',
		'data_permission': 'REPORT.SALEREPORT_LIST.VIEW',
		'icon_class': 'ddh-icon-report_sales',
		'img_name': 'module_report_sale@3x.png',
		'show_name': '销售报表',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '销售数据展示与分析',
		'add_feature': false,
		'add_data_href': '',
		'add_data_permission': '',
		'parent_module': 'Report'
	},
	'PurchaseReportList': {
		'data_href': '/erp_report/report_purchase_index.html',
		'data_permission': 'REPORT.PURCHASEREPORT_LIST.VIEW',
		'icon_class': 'ddh-icon-report_purchasing',
		'img_name': 'module_report_purchase@3x.png',
		'show_name': '采购报表',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '采购数据展示与分析',
		'add_feature': false,
		'add_data_href': '',
		'add_data_permission': '',
		'parent_module': 'Report'
	},
	'ProductStockList': {
		'data_href': '/erp_report/report_product_warehouse_list.html',
		'data_permission': 'REPORT.PRODUCTSTOCK_LIST.VIEW',
		'icon_class': 'ddh-icon-report_inventory',
		'img_name': 'module_report_stock@3x.png',
		'show_name': '库存状况',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '快速查看商品库存信息',
		'add_feature': false,
		'add_data_href': '',
		'add_data_permission': '',
		'parent_module': 'Report'
	},
	'ReportManagementConditionReport': {
		'data_href': '/erp_report/report_management_condition_index.html',
		'data_permission': 'REPORT.REPORT_MANAGEMENTCONDITIONREPORT.VIEW',
		'icon_class': 'ddh-icon-report_operating_status',
		'img_name': 'module_report_business@3x.png',
		'show_name': '经营状况表报告',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '当前经营状况数据与分析',
		'add_feature': false,
		'add_data_href': '',
		'add_data_permission': '',
		'parent_module': 'Report'
	},
	'ReportProfitReport': {
		'data_href': '/erp_report/report_profit_index.html',
		'data_permission': 'REPORT.REPORT_PROFITREPORT.VIEW',
		'icon_class': 'ddh-icon-report_profit',
		'img_name': 'module_report_profit@3x.png',
		'show_name': '利润报表',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '业务利润数据报表查看',
		'add_feature': false,
		'add_data_href': '',
		'add_data_permission': '',
		'parent_module': 'Report'
	},
	'PerformanceReportList': {
		'data_href': '/erp_report/report_performance_index.html',
		'data_permission': 'REPORT.PERFORMANCEREPORT_LIST.VIEW',
		'icon_class': 'ddh-icon-report_achievement',
		'img_name': 'module_report_achievement@3x.png',
		'show_name': '业绩报表',
		'has_little_data': false,
		'data_refresh_data': '',
		'sub_title_html': '业绩数据展示与分析',
		'add_feature': false,
		'add_data_href': '',
		'add_data_permission': '',
		'parent_module': 'Report'
	},
    'QueryBillDraftPagination': {
        'data_href': '/erp_report/report_billdraft_list.html',
        'data_permission': 'REPORT.BILLREPORT_DRAFT.VIEW',
        'icon_class': 'ddh-icon-report_achievement',
        'img_name': 'module_report_draft@3x.png',
        'show_name': '单据草稿',
        'has_little_data': false,
        'data_refresh_data': '',
        'sub_title_html': '查看所有单据草稿',
        'add_feature': false,
        'add_data_href': '',
        'add_data_permission': '',
        'parent_module': 'Report'
    },
    'QueryBillCentrePagination': {
        'data_href': '/erp_report/report_billcentre_list.html',
        'data_permission': 'REPORT.BILLREPORT_CENTRE.VIEW',
        'icon_class': 'ddh-icon-report_achievement',
        'img_name': 'module_report_documentcenter@3x.png',
        'show_name': '单据中心',
        'has_little_data': false,
        'data_refresh_data': '',
        'sub_title_html': '查看所有单据',
        'add_feature': false,
        'add_data_href': '',
        'add_data_permission': '',
        'parent_module': 'Report'
    },
    'DistributionManage': {
		'data_href': '/mall_index/mall_index.html',
		'data_permission': 'DISTRIBUTION.DISTRIBUTION_MANAGE.VIEW',
		'icon_class': '',
		'img_name': 'mall_manage@2x.png',
		'show_name': '商城管理后台',
		'has_little_data': false,
		'data_refresh_data': "",
		'sub_title_html': '商城版后台管理',
		'add_feature': false,
		'add_data_href': '/mall_index/mall_index.html',
		'add_data_permission': '',
		'data_specialize_version': '220',//指定软件购买版本
		'parent_module': 'Business'
	}
};

///父级分类
var parent_module_show_name = {
	'Business': '做业务',
	'Finance': '管账目',
	'Basedata': '建资料',
	'Report': '查报表',
	'SystemHelp': '帮助中心'
}

///首页默认显示模块列表
var default_modules = {
	"SaleCreate": {
		"name": "SaleCreate"
	},
	"PurchaseCreate": {
		"name": "PurchaseCreate"
	},
	"BaseInfoContacts": {
		"name": "BaseInfoContacts"
	},
	"StocktakingCreate": {
		"name": "StocktakingCreate"
	}
};
