var check4UpdateFinishCallback;

//检测更新
function check4update(callback) {
	check4UpdateFinishCallback = callback;
	if(window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}
}

function test(wgtVer) {
	sendConfigRequest({
		'requestUri': '/version/check?id=' + wgtVer,
		'requestType': 'get',
		'requestShowLoading': false,
		'requestSuccessCallback': function(data, status, xhr) {
			console.log("JSON.stringify(data)" + JSON.stringify(data));
			if(!data.success) {
				console.log('无升级');
				return
			}
			if(data.data) {
				downloadUploadWgtFile(data.data);
			}
		},
		'requestFailCallback': function(xhr, type, errorThrown) {}
	});
}

function plusReady() {
	// 获取本地应用资源版本号
	plus.runtime.getProperty(plus.runtime.appid, function(inf) {
		wgtVer = inf.version; // '1.0.1';
		var os = '';
		if(mui.os.ios) {
			os = 'ios';
		} else if(mui.os.android) {
			os = 'android';
		}
		console.log(plus.runtime.version + '------' + JSON.stringify(inf));
		sendConfigRequest({
			'requestUri': '/version/check',
			'requestData': {
				'id': wgtVer,
				'os': os,
				'appVer': plus.runtime.version
			},
			'requestType': 'get',
			'requestShowLoading': false,
			'requestSuccessCallback': function(data, status, xhr) {
				console.log("JSON.stringify(data)" + JSON.stringify(data));
				if(!data.success) {
					console.log('无升级');
					check4UpdateFinishCallback ? check4UpdateFinishCallback() : '';
					return
				}
				var message = '检测到应用资源更新，是否下载更新包？';
				if(data.data.description) {
					message = data.data.description;
				}
				var btns = [];
				var yesFunction;
				var type = data.data.updateType;
				var size = formatNumWithDigit(Number(data.data.size) / (1024 * 1024));
				if(type == 'res_general') {
					btns = ['更新(' + size + 'M)', '取消'];
					yesFunction = function() {
						downloadUploadWgtFile(data.data.resourceUrl);
					}
				} else if(type == 'app_general') {
					btns = ['升级', '取消'];
					yesFunction = function() {
						location.href = data.data.appUrl;
					}
				} else if(type == 'res_force') {
					btns = ['立即更新(' + size + 'M)'];
					yesFunction = function() {
						downloadUploadWgtFile(data.data.resourceUrl);
					}
				} else {
					btns = ['立即升级'];
					yesFunction = function() {
						location.href = data.data.appUrl;
					}
				}
				document.querySelector('head').innerHTML += '<style>.custom-layer-content .layui-m-layercont{padding:10px !important} .layui-m-layerchild h3{border-bottom: 1px solid #D0D0D0;}</style>';
				var layerIndex = layer.open({
					title: '应用升级',
					content: '<div style="text-align:left;font-size:15px;height:260px;overflow: scroll;">' + message + '</div>',
					shadeClose: false,
					className: 'custom-layer-content',
					btn: btns,
					yes: function() {
						if(yesFunction) {
							yesFunction();
						}
						layer.close(layerIndex);
					},
					no: function() {
						mui.toast("已取消升级");
						if(check4UpdateFinishCallback) {
							check4UpdateFinishCallback();
						}
					}
				});
			},
			'requestFailCallback': function(xhr, type, errorThrown) {
				if(check4UpdateFinishCallback) {
					check4UpdateFinishCallback();
				}
			}
		});
	});
}

function validateFileAccessPrivilege() {

}

/**
 * 下载升级包
 * @param {Object} wgtUrl
 */
function downloadUploadWgtFile(wgtUrl) {
	var downloadPath = '_doc/update/';
	var wgtName = wgtUrl.substring(wgtUrl.lastIndexOf('/') + 1, wgtUrl.length);
	///////////////删除已有的文件
	deleteWgtFile(downloadPath + wgtName);
	var timer, waitingObj;
	console.log("wgtUrl" + JSON.stringify(wgtUrl));
	var download = plus.downloader.createDownload(wgtUrl, {
		filename: "_doc/update/"
	}, function(d, status) {
		if(status == 200) {
			waitingObj.setTitle('下载完成，正在校验文件...');
			setTimeout(function() {
				plus.io.resolveLocalFileSystemURL(d.filename, function(entry /*DirectoryEntry|FileEntry*/ ) {
					entry.file(function(file) {
						waitingObj.close();
						if(file.size != d.totalSize) {
							mui.confirm('文件校验失败，是否重新下载？', function(e) {
								if(e.index == 1) {
									//location.reload();
									downloadUploadWgtFile(wgtUrl)
								} else {
									if(check4UpdateFinishCallback) {
										check4UpdateFinishCallback();
									}
								}
							}, '友情提示', ['取消', '确定']);
							return;
						}
						installWgt(d.filename); // 安装wgt包
					}, function(e2) {
						waitingObj.close();
						console.log("解析文件失败: " + e2.message);
					});
				}, function(e) {
					waitingObj.close();
					console.log("打开文件失败: " + e.message);
				});
			}, 1000);
			clearInterval(timer);
		} else {
			console.log("下载wgt失败！");
			plus.nativeUI.alert("下载wgt失败！");
		}
	});

	download.addEventListener("statechanged", function(_download, status) {
		switch(_download.state) {
			case 2:
				waitingObj = plus.nativeUI.showWaiting('正在下载资源...0%\n下载过程中请勿退出App，避免下载中断');
				break;
			case 3:
				plus.io.resolveLocalFileSystemURL(downloadPath + wgtName, function(entry /*DirectoryEntry|FileEntry*/ ) {
					entry.file(function(file) {
						if(_download.state == 4) {
							return;
						}
						//console.log('_download.state:' + _download.state + ',file.size:' + file.size)
						var result = numberFormat(file.size * 100 / _download.totalSize, 0);
						if(result <= 100) {
							waitingObj.setTitle('正在下载资源...' + result + '%\n下载过程中请勿退出App，避免下载中断');
						}
					}, function(e2) {
						console.log("解析文件失败: " + e2.message);
					});
				}, function(e) {
					console.log("打开文件失败: " + e.message);
				});
				break;
			default:
				break;
		}
	}, false);
	download.start(); //开始下载
}

// 更新应用资源
function installWgt(path) {
	plus.nativeUI.showWaiting("安装中...");
	plus.runtime.install(path, {}, function() {
		plus.nativeUI.closeWaiting();
		deleteWgtFile(path);
		console.log("安装wgt文件成功！");
		plus.nativeUI.alert("应用资源更新完成，请退出APP后重新打开！", function() {
			deleteWgtFile(path);
			plus.nativeUI.showWaiting('正在加载……');
			setTimeout(function() {
				plus.nativeUI.closeWaiting();
				if(mui.os.android) {
					plus.runtime.quit(); //Android手机终止应用
				} else if(mui.os.ios) {
					//plus.runtime.restart();//苹果手机暂时重加载
					//使用插件终止APP
					plus.H5BridgeFunctions.PluginExitApp({}, function(data) {}, function(error) {
						console.log(JSON.stringify(error["message"]) + ",code:" + error["code"]);
					});
				}
			}, 1000);
		});
	}, function(e) {
		plus.nativeUI.closeWaiting();
		console.log("安装wgt文件失败[" + e.code + "]：" + e.message);
		plus.nativeUI.alert("安装wgt文件失败[" + e.code + "]：" + e.message, function() {
			deleteWgtFile(path);
			setTimeout(function() {
				if(check4UpdateFinishCallback) {
					check4UpdateFinishCallback();
					//plus.runtime.restart();
				}
			}, 1000);
		});
	});
}

function deleteWgtFile(path) {
	plus.io.resolveLocalFileSystemURL(path, function(entry) {
		entry.remove(function(e) {
			console.log("删除成功");
		}, function(e) {
			console.log("删除失败");
		});
	});
}