    /**
 * Created by 0000 on 2017/4/14.
     * 目前发现IOS的 webview中不支持indexedDB
 */

function openDB (dbObj,callback) {
    var version=dbObj.version || 1;
    var request=window.indexedDB.open(dbObj.name,version);
    request.onsuccess=function(e){//成功
        console.log("window.indexedDB.open.onsuccess");
        dbObj.db=e.target.result;
        if (callback != null) {
            callback(1,dbObj,e);
        }

    };
    request.onerror=function(e){//失败
        console.log("window.indexedDB.open.onerror");
        console.log(e.currentTarget.error.message);
        if (callback != null) {
            callback(2,dbObj,e);
        }
    };

    request.onupgradeneeded=function(e){//版本变化或没有数据库
        console.log("window.indexedDB.open.onupgradeneeded");
        console.log('DB version changed to '+version);
        if (dbObj.callback != null) {
            dbObj.callback(e);
        }
        if (callback != null) {
            callback(3,dbObj,e);
        }
    };
}
function closeDB(db){
    if(db!=null){
        db.close();
    }

}
function deleteDB(name){
    window.indexedDB.deleteDatabase(name);
}
function addData(db,storeName,datas){
    // console.log("addData storeName:"+storeName);
    var transaction=db.transaction(storeName,'readwrite');
    var store=transaction.objectStore(storeName);
    for(var i=0;i<datas.length;i++){
        store.add(datas[i]);
        // console.log(store.add(datas[i]));
    }
}
function getDataByValue(db,storeName,callback,value){
    var transaction=db.transaction(storeName,'readwrite');
    var store=transaction.objectStore(storeName);
    if(store!=null){
        if (value != null) {
            var request=store.get(value);
            request.onsuccess=function(e){
                var item=e.target.result;
                // console.log(item);
                if (callback != null) {
                    callback(item);
                }
            };
        }else {
            // try {
            //     var request=store.getAll();
            //     request.onsuccess=function(e){
            //         console.log(e.target.result);
            //         if (callback != null) {
            //             callback(e);
            //         }
            //     };
            // }catch (e){
            //     console.log(e);
            // }
            var request2=store.openCursor();
            request2.onsuccess=function(e){
                // console.log(e.target.result);
                var cursor=e.target.result;
                if (callback != null) {
                    callback(cursor);
                }
                if(cursor){

                    // console.log(cursor.key);
                    // var currentStudent=cursor.value;
                    // console.log(currentStudent);
                    cursor.continue();

                    // console.log(cursor.continue());
                    // while (cursor.continue()){
                    //     var currentStudent=cursor.value;
                    //     console.log(currentStudent);
                    // }
                }

            };
            request2.onerror = function(e) {
                console.log('opencursor error');
            };
        }
    }


}
function updateDataByKey(db,storeName,value){
    var transaction=db.transaction(storeName,'readwrite');
    var store=transaction.objectStore(storeName);
    var request=store.get(value);
    request.onsuccess=function(e){
        var student=e.target.result;
        student.age=35;
        store.put(student);
    };
}
function deleteDataByKey(db,storeName,value){
    var transaction=db.transaction(storeName,'readwrite');
    var store=transaction.objectStore(storeName);
    store.delete(value);
}
function clearObjectStore(db,storeName){
    var transaction=db.transaction(storeName,'readwrite');
    var store=transaction.objectStore(storeName);
    store.clear();
}
var erpDB={
    name:'erpDB',
    version:1,
    StoreNames:["ProvinceList","CityList","CountyList"],
    db:null,
    callback:function (e) {
        var db=e.target.result;
        for (var i=0;i<this.StoreNames.length;i++){
            if(db.objectStoreNames.contains(this.StoreNames[i])){
                db.deleteObjectStore(this.StoreNames[i]);
            }
            // if(!db.objectStoreNames.contains(this.StoreNames[i])){
                db.createObjectStore(this.StoreNames[i],{keyPath:"Code"});
            // }
        }
    }
};
function open_erpDB(callback){
    openDB(erpDB,callback);
}