//存储业务相关的公共回调函数
////////
/**
 * 通用请求方法：不建议外部文件直接
 * @param {Object} _requestUri
 * @param {Object} _callback
 * @param {Object} _queryJson
 * @param {Object} _requestType
 */
function __common_request(_requestUri, _callback, _queryJson, _requestType) {
	if(!_callback || !_requestUri) {
		mui.alert('参数不正确');
		return;
	}
	sendConfigRequest({
		'requestUri': _requestUri,
		'requestType': _requestType ? _requestType : 'GET',
		'requestShowLoading': true,
		'requestData': _queryJson ? _queryJson : {},
		'requestSuccessCallback': function(data, status, xhr) {
			if(!data.success) {
				mui.toast(data.message);
				return
			}
			 _callback(data);
			//_callback instanceof Array?_callback[0](data):_callback(data);
		},
		'requestFailCallback': function(xhr, type, errorThrown) {
			//_callback instanceof Array && _callback.length>1?_callback[1]():null;
		}
	});
}
/**
 *
 * @param {String} itemFlag
 *
 * [Description("销售时检查最低售价")] SaleCheckMinPrice,
 * [Description("销售时自动补齐实收金额")] SaleAutoPostTotal ,
 * [Description("启用采购税率支持")]EnableInputTax,
 * [Description("启用销售税率支持")]EnableOutPutTax ,
 * [Description("采购税率")]InputTax,
 * [Description("销售税率")]OutPutTax,
 * [Description("是否开帐")]IsOpenAccount,
 * [Description("开帐时间")]openaccountdate,
 * [Description("订单汇商户ID")]DDHMerchantId,
 * [Description("订单汇商户用户名")]DDHAccount
 * [Description("是否开启序列号")]EnableSeriesno
 * [Description("数量小数位数")]qtydigit
 * [Description("单价小数位数")]pricedigit
 * @param {Object} callback
 */
function getSysConfigValue(itemFlag, callback) {
	var queryJson = {
		"configName": itemFlag
	};
	__common_request('/sysConfigs/detail', callback, queryJson);
}

/**
 * 获取业务配置的信息
 * @param {Object} callback  回调
 */
function getSysConfig(callback) {
	var queryJson = {};
	__common_request('/sysConfigs', callback, queryJson);
}
/**
 * 获取仓库列表，不分页
 * @param {Object} callback：回调
 */
function getWarehouseList(callback) {
	__common_request('/baseinfo/warehouse/getList',callback)
}


/**
 * 获取员工列表（经手人，制单人）
 * @param {Object} callback 回调
 */
function getEmployeeInfoList(callback) {
	__common_request('/employees',callback)
}

/**
 * 获取结算账户列表
 * @param {Object} callback 回调
 */
function getAccountList(callback) {
	__common_request('/baseinfo/account/getList',callback)
}

/**
 * 检查账号服务是否过期
 * @param {Object} callback 回调
 * 校验账户过期的公共函数
 * @param {Object} callback 账户正常的回调
 */
function validateAccount(callback) {
	__common_request('/company/checkServicIsEexpire',function(data){
		if(data.success && !data.data){
			callback();
		}else{
			mui.alert('产品已过期，请登录订单汇官网续费，感谢您的使用！');
		}
	});
}
/**
 * 获取最新登录信息(权限、有效期)
 * @param callback1
 * @param callback2
 */
function refreshTicket(callback1,callback2) {
	sendConfigRequest({
		'requestUri': '/company/refreshTicket',
		'requestType': 'get',
		'requestShowLoading': true,
//					'requestData': requestData,
		'getDataFromAPICallback': function(Data, Success,Message, Code) {
			if(Success) {
				var strUser = Data.loginUserContent;
				if(strUser != null) {
					if(typeof strUser === 'object') {
						strUser[_SESSION_KEY]=Data[_SESSION_KEY];
						strUser[_CREATETIME]=Data[_CREATETIME];
						strUser[_EXPIREDATE]=Data[_EXPIREDATE];
					}
					var userCur=app_userManage.getUserInfo_fromLocalStorage();
					mui.extend(userCur, strUser);
					app_userManage.setUserInfo_toLocalStorage(userCur,true);
				}
				if(callback1&&(typeof callback1 == "boolean"||callback1(Data))){

				}
			}else {
				if(callback2&&(typeof callback2 == "boolean"||callback2())){
					if (Message != null) {
						mui.toast(Message);
					}
				}
			}
		},
		'requestFailCallback': function(xhr, type, errorThrown) {
			if(callback2&&(typeof callback2 == "boolean"||callback2())){

			}
		}
	});
}
/**
 *查询公司信息
 * @param callback1
 * @param callback2 失败回调,返回true=后续统一处理
 * @constructor
 */
function GetCompanyInfo(callback1,callback2) {
	sendConfigRequest({
		'requestUri': '/company',
		'requestType': 'get',
//					'requestData':requestData,
		'getDataFromAPICallback': function (data,Success,Message,Code) {
			// console.log("Success:"+Success);
			if(Success){
				if(data!=null){
					app_userManage.setUserProperty_toLocalStorage(_CompanyInfo,data);
					if(callback1&&(typeof callback1 == "boolean"||callback1(data))){

					}
				}
			}else{
				if(callback2&&(typeof callback2 == "boolean"||callback2())){
					if (Message != null) {
						mui.toast(Message);
					}
				}

			}
			return false;
		},
		'manageCode': true,
		'showMessageType': 4,
		'requestFailCallback': function (xhr, type, errorThrown) {
			if(callback2&&(typeof callback2 == "boolean"||callback2())){

			}
		}
	});
}
/**
 * 获取小数点位数设置的回调
 * @param {Object} callback 回调
 */
function getNumberDigitSetting(callback) {
	getSysConfig(function(data){
		var result = {};
		result["qtydigit"] = 2;
		result["pricedigit"] = 2;
		for (var i = 0; i < data.data.length; i++) {
			if(data.data[i]["name"] == "qtydigit".toLowerCase()){
				result["qtydigit"] = Number(data.data[i]["value"]);
			}else if(data.data[i]["name"] == "pricedigit".toLowerCase()){
				result["pricedigit"] = Number(data.data[i]["value"]);
			}
		}

		callback(result);
	});
}

/**
 * 获取单据详情，打印时使用
 * @param {Object} _requestUri
 * @param {Object} _callback
 * @param {Object} _queryJson
 * @param {Object} _requestType
 */
function getBillDetail(_requestUri, _callback, _queryJson, _requestType){
	__common_request(_requestUri,function(data){
		if(data.success && data.data != null){
			_callback(data);
		}else{
			mui.alert('获取单据详情失败！');
		}
	},_queryJson,_requestType);
}
/**
 * 获取往来单位资料
 * @param {Object} _contactId
 * @param {Object} _callback
 * @param {Object} _queryJson
 */
function getContactInfo(_contactId, _callback, _queryJson){
	__common_request("/contacts/"+_contactId,function(data){
		if(data.success && data.data != null){
			_callback(data);
		}else{
			mui.alert('获取往来单位资料失败！');
		}
	},_queryJson,"GET");
}

/**
 *
 * @param {Object} _productId	商品ID
 * @param {Object} _wareId		仓库ID
 * @param {Object} _callback		回调函数
 */
function getProductWareStockInfo(_productId,_warehouseId,_callback){
	__common_request("/product/getProductStockInfo?productId="+_productId+"&warehouseId="+_warehouseId,function(data){
		if(data.success && data.data != null && _callback){
			_callback(data);
		}else{
			mui.alert('获取库存资料失败！');
		}
	},"","GET");
}
