///////////////////////////////////
////////首页模块管理/////////////////

/**
 * 获取首页模块列表
 * @param {Object} callbackFn 回调函数
 */
function updateLatestModules(callbackFn) {
	sendConfigRequest({
		'requestUri': '/home/getAppConfigValue',
		'requestType': 'get',
		'requestShowLoading': true,
		'requestData': {},
		'requestSuccessCallback': function(data, status, xhr) {
			if(!data.success) {
				mui.toast(data.message);
				return
			}
			if(data.data) {
				//mui.alert(data.data); 
				localStorage.setItem('ddh_index_module', data.data);
				callbackFn?callbackFn():'';
			}
		},
		'requestFailCallback': function(xhr, type, errorThrown) {}
	});
}

/**
 * 更新首页模块列表
 */
function setModules(jsonDataString) {
	sendConfigRequest({
		'requestUri': '/home/saveOrUpdateAppConfigValue',
		'requestType': 'post',
		'requestShowLoading': true,
		'requestContentType': _requestDataType_json,
		'requestData': {
			configValue: jsonDataString
		},
		'requestSuccessCallback': function(data, status, xhr) {
			if(!data.success) {
				mui.toast(data.message);
				return
			}
		},
		'requestFailCallback': function(xhr, type, errorThrown) {}
	});
}