//////////////////////////处理系统的消息模块
/**
 * 消息监听
 */
function pushListener() {
	plus.push.addEventListener("click", function(msg) {
		//alert('click' + JSON.stringify(msg));
		//只需要处理iOS即可，iOS消息中心点击
		if(mui.os.ios) {
			var payload = msg.payload;
			if(payload) {
				handleMessageType(payload.type, payload.refBillId, payload.textContent);
			}
		}

	}, false);
	// 监听在线消息事件
	plus.push.addEventListener("receive", function(msg) {
		//alert('receive:'+JSON.stringify(msg))
		if(mui.os.ios) { //iOS增加蜂鸣和振动
			plus.device.vibrate(); //设备振动默认为500ms,仅iPhone设备支持，iPad和iTouch设备不支持
			plus.device.beep(); //发出蜂鸣声
			var payloadObj = msg.payload;
			handleMessageType(payloadObj.type, payloadObj.refBillId, payloadObj.textContent);
		} else if(mui.os.android) {
			var payloadObj = JSON.parse(msg.payload);
			handleMessageType(payloadObj.type, payloadObj.refBillId, payloadObj.textContent);
		}
		//后期增加收到消息后的通用处理，例如改变消息角标数量等

	}, false);
}

/**
 * 弹窗处理
 * @param type 消息类型
 * @param refBillId 引用编号
 * @param message  消息体
 * @param messageId 消息ID
 */
function handleMessageType(type, refBillId, message, messageId) {
	var btn = ['忽略'];
	var targetUrl; //目标URL
	switch(parseInt(type)) {
		case 101: // 订单相关
			if(authorityCheckUpdated('Order.Order.list')) {
				targetUrl = __PAGE_ROOT_PATH + 'pages/mall_index/mall_index.html?target=message';
				btn.push('前往');
			}
			break;
		case 102: // 退货单相关
			if(authorityCheckUpdated('Order.Return.list')) {
				targetUrl = __PAGE_ROOT_PATH + 'pages/mall_index/mall_index.html?target=message';
				btn.push('前往');
			}
			break;
		case 201: // 收款单相关
			if(authorityCheckUpdated('Finance.Receive.list')) {
				targetUrl = __PAGE_ROOT_PATH + 'pages/mall_index/mall_index.html?target=message';
				btn.push('前往');
			}
			break;
		case 203: // 销售返点
			console.log('销售返点')
			mui.toast('该功能暂未开通，敬请期待')
			break;
		case 1: //公告
			targetUrl = __PAGE_ROOT_PATH + 'pages/erp_message/erp_message_index.html';
			btn.push('立即查看');
			break;
		case 2: //erp销售订单
			targetUrl = __PAGE_ROOT_PATH + 'pages/erp_business/erp_business_sales_order_detail.html?id='+refBillId;
			btn.push('立即查看');
			break;
		default:
			break;
	}
	if(btn.length == 2 && targetUrl) {
		mui.confirm(message, '', btn, function(e) {
			if(e.index == 1) {
				openNewPage(targetUrl);
			}
		});
	}
}
