// 数字正则表达式
var __NUMBER_PATTERN_STRING = "^[0-9]*[1-9][0-9]*$"; //匹配正浮点数
var __INTERGER_PATTERN_STRING = "^\d{5,40}$"; //匹配m-n位数字

// var _tel_v = /^\d{8,11}$/; //账号验证
// var _tel_v = /^(13[0-9]|15[012356789]|17[0135678]|18[0-9]|14[579])[0-9]{8}$/; //账号验证
var _tel_v = /^1\d{10}$/; //账号验证
var _pas_v = /^\S{6,20}$/; //密码验证(6-20位)
var _msg_v = /^\S{4,6}$/; //验证码验证
var _name_v = /^\S+$/; //商户名验证
var _Nub = /^\d+$/; //整数验证
var _empty = /^\S+$/; //非空验证
var _Nub2 = /^\d{1,8}$/; //数字验证
var _Nub3 = /^\d{1,6}$/; //数字验证
var _Nub_decimal = /^[2-4]{1,6}$/; //小数点位数设置验证(0至4位)
var _NubAbove0 = /^[1-9]{1}[0-9]{0,7}$/; //大于0的整数
var _Nub_positive = /(^[\d]{0,9}(\.[\d]+)?$)|(^[\d]{0,9}$)/; //非负数,低于10亿
var _Nub_positive_1 = /(^[\d]+(\.[\d]{0,1})?$)|(^[\d]{0,9}$)/; //非负数,低于10亿,最多1位小数
var _Nub_positive_2 = /(^[\d]+(\.[\d]{0,2})?$)|(^[\d]{0,9}$)/; //非负数,低于10亿,最多两位小数
var _Nub_positive_3 = /(^[\d]+(\.[\d]{0,3})?$)|(^[\d]{0,9}$)/; //非负数,低于10亿,最多3位小数

var _user_name_v = /^\w*[a-zA-Z]\w*$/; //登录账号验证
var _user_name_showstr = "账号必须是字母或字母和数字的组合";

var _money = /^([0-9]+|[0-9]{1,3}(,[0-9]{3})*)(\.[0-9]{1,2})?$/; //金额验证
var _moneyAbove0 = /^([0-9]{1,8})(\.[0-9]{1,2})?$/; //金额验证
var _moneyAbove0_null = /(^([0-9]{1,9})(\.[0-9]{1,2})?$)|(^[\d]{1,9}$)/; //非负数,低于10亿,最多两位小数
var _discount = /^(0)(\.[0-9]{1,6})?$/; //折扣(0-1,最多的两位小数)
var _tax = /^([0-9]{1,2})(\.[0-9]{1,2})?$/; //税率(0-100,最多的2位小数)
// var _emptyMaxLength50=/^\S{1,50}$/; //非空验证
/*str为要去除空格的字符串*/
var _str_blank1 = /\s+/g; //  去除所有空格
var _str_blank2 = /(^\s+)|(\s+$)/g; //去除两头空格
var _str_blank3 = /^\s*/; //去除左空格
var _str_blank4 = /(\s*$)/g; //去除右空格
/**
 * 取出字符串空格
 * @param str
 * @param is_global 去除所有空格标志
 * @returns {*}
 */
function trim(str, is_global) {
	var result;
	if(str != null) {
		if(typeof str == "string") {
			if(is_global != null && is_global.toLowerCase() == "g") {
				result = str.replace(_str_blank1, "");
			} else {
				result = str.replace(_str_blank2, "");
			}
		} else {
			result = str;
		}

	} else {
		result = "";
	}

	return result;
}

/**
 *
 * @param url 跳转到指定的页面
 */
function toUrl(url) {
	if(url.indexOf("?") >= 0) {
		url += "&time=" + new Date().getTime();
	} else {
		url += "?time=" + new Date().getTime();
	}
	location.href = encodeURI(encodeURI(url));
}

function getServerBaseRoot() {
	return "http://" + window.document.location.host;
}
/**
 * 改变控件透明度
 * @param obj
 * @param str
 */
function setOpacity_restore(obj, opacity) {
	obj.style.opacity = opacity;
	setTimeout(function() {
		obj.style.opacity = 1;
	}, 500);
}
/**
 * 给控件添加按下样式 app_press
 * @param view
 */
function set_press_style(view) {
	view.addEventListener("touchstart", function(e) {
		e.srcElement.classList.add("app_press");
		//console.log(e);
	});
	view.addEventListener("touchend", function(e) {
		e.srcElement.classList.remove("app_press");
		//console.log(e);
	});
	view.addEventListener("touchcancel", function(e) {
		e.srcElement.classList.remove("app_press");
		//console.log(e);
	});
}
/**
 * 保存字符串到local
 * @param key
 * @param str
 */
function saveStrToLocal(key, str) {
	if(str != null && str != undefined) {
		localStorage.setItem(key, str);
	}
}
/**
 * 从Local获取JSON对象
 * @param key
 * @returns JSON对象
 */
function getJSONfromLocal(key) {
	try {
		return JSON.parse(localStorage.getItem(key));
	} catch(e) {
		return null;
	}
}
/**
 * 保存字符串到Session
 * @param key
 * @param str
 */
function saveStrToSession(key, str) {
	if(str != null && str != undefined) {
		if(typeof(str) != "string") {
			str = JSON.stringify(str);
		}
		sessionStorage.setItem(key, str);
	}
}
/**
 * 从Session获取JSON对象
 * @param key
 * @returns JSON对象
 */
function getJSONfromSession(key) {
	try {
		return JSON.parse(sessionStorage.getItem(key));
	} catch(e) {
		return null;
	}
}

/**
 * 获取页面跳转时的请求参数
 * @param 参数名称
 * @returns {*} 参数值
 */
function getRequestParams(paramName) {
	var url = location.href;
	var paraString = url.substring(url.indexOf("?") + 1, url.length).split("&");
	var paraObj = {}
	for(i = 0; j = paraString[i]; i++) {
		paraObj[j.substring(0, j.indexOf("=")).toLowerCase()] = j.substring(j.indexOf("=") + 1, j.length);
	}
	var returnValue = paraObj[paramName.toLowerCase()];
	if(typeof(returnValue) == "undefined") {
		return "";
	} else {
		return returnValue;
	}
}

/**
 *
 * @returns {日期yyyy-MM-dd}
 */
function getStrDateFormatStrDate(_date, hideYear, showS) {
	var strDate = "";
	try {
		var strDate2 = _date.replace(/-/g, "/");
		var date = new Date(strDate2); //new Date(_date);
		if(date != null && date != undefined && typeof(date) != "undefined") {
			var seperator1 = "-";
			var month = date.getMonth() + 1;
			var strD = date.getDate();
			if(month >= 1 && month <= 9) {
				month = "0" + month;
			}
			if(strD >= 0 && strD <= 9) {
				strD = "0" + strD;
			}
			if(hideYear) {
				strDate = month + seperator1 + strD;
			} else {
				strDate = date.getFullYear() + seperator1 + month + seperator1 + strD;
			}
			if(showS) {
				strDate += " " + date.getHours() + ":" + date.getMinutes() + ":" + date.getSeconds()
			}
		} else {
			if(hideYear && showS) {
				strDate = _date.substr(4, (_date.length - 5));
			} else if(hideYear && !showS) {
				strDate = _date.substr(4, 5);
			} else if(!hideYear && showS) {
				strDate = _date;
			} else {
				strDate = _date.substr(0, 10);
			}
		}

	} catch(e) {

	}
	return strDate;
}

/**
 * 获取当前时间
 * @returns {日期yyyy-MM-dd hh:mm:ss}
 * @param {Object} withHMS:是否返回时分秒
 */
function getNowFormatDate(withHMS) {
	var date = new Date();
	var seperator1 = "-";
	var month = date.getMonth() + 1;
	var strDate = date.getDate();
	if(month >= 1 && month <= 9) {
		month = "0" + month;
	}
	if(strDate >= 0 && strDate <= 9) {
		strDate = "0" + strDate;
	}
	var result = date.getFullYear() + seperator1 + month + seperator1 + strDate;
	if(withHMS) {
		var seperator2 = ":";
		result += " " + (date.getHours() < 10 ? "0" + date.getHours() : date.getHours()) + seperator2 +
			(date.getMinutes() < 10 ? "0" + date.getMinutes() : date.getMinutes()) + seperator2 +
			(date.getSeconds() < 10 ? "0" + date.getSeconds() : date.getSeconds());
	}
	return result;
}
/**
 * 时间转化为字符串
 * @param date
 * @param withHMS
 * @returns {string}
 */
function getStringFromDate(date,withHMS) {
	date=date ==null? new Date():date;
	var seperator1 = "-";
	var month = date.getMonth() + 1;
	var strDate = date.getDate();
	if(month >= 1 && month <= 9) {
		month = "0" + month;
	}
	if(strDate >= 0 && strDate <= 9) {
		strDate = "0" + strDate;
	}
	var result = date.getFullYear() + seperator1 + month + seperator1 + strDate;
	if(withHMS) {
		var seperator2 = ":";
		result += " " + (date.getHours() < 10 ? "0" + date.getHours() : date.getHours()) + seperator2 +
			(date.getMinutes() < 10 ? "0" + date.getMinutes() : date.getMinutes()) + seperator2 +
			(date.getSeconds() < 10 ? "0" + date.getSeconds() : date.getSeconds());
	}
	return result;
}
/**
 * 字符串转化为时间
 * @param {Object} dateString:标准格式 1990-02-05 12:09:25 可以没有时分秒，但一定要有年月日
 */
function getDateFromString(dateString) {
	var parts = dateString.split(' ');
	if(parts.length < 1) {
		return null;
	}
	var part1 = parts[0].split('-');
	if(part1.length != 3) {
		return null;
	}
	var d = new Date(part1[0], part1[1] - 1, part1[2]);
	if(parts[1] && d) {
		var part2 = parts[1].split(':');
		if(part2) {
			d.setHours(part2[0]);
			d.setMinutes(part2[1]);
			d.setSeconds(part2[2]);
		}
	}
	return d;
}
/**
 * 比较日期大小
 * @param date1
 * @param date2
 * @returns {string}
 */
function compDate(date1,date2) {
	var a = Date.parse(date1) - Date.parse(date2);
	// console.log("a:"+a);
	if (a < 0) {
		// console.log("date1小!");
	} else if (a > 0) {
		// console.log("date1大!");
	} else if (a == 0) {
		// console.log("时间相等!");
	} else {
		return 'exception';
	}
	return a;
}
/**
 * 货币格式化
 * @param 货币值，字符串或者数值
 * @returns {string}
 */
function currencyFormatter(num) {
	var sign = "";
	if(isNaN(num)) {
		num = 0;
	}
	if(num < 0) {
		sign = "-";
	}
	var strNum = num + "";
	var arr1 = strNum.split(".");
	var hasPoint = false; //是否有小数部分
	var piontPart = ""; //小数部分
	var intPart = strNum; //整数部分
	if(arr1.length >= 2) {
		hasPoint = true;
		piontPart = arr1[1];
		intPart = arr1[0];
	}

	var res = ''; //保存添加逗号的部分
	var intPartlength = intPart.length; //整数部分长度
	var maxcount = Math.ceil(intPartlength / 3); //整数部分需要添加几个逗号
	for(var i = 1; i <= maxcount; i++) //每三位添加一个逗号
	{
		var startIndex = intPartlength - i * 3; //开始位置
		if(startIndex < 0) //开始位置小于0时修正为0
		{
			startIndex = 0;
		}
		var endIndex = intPartlength - i * 3 + 3; //结束位置
		var part = intPart.substring(startIndex, endIndex) + ",";
		res = part + res;
	}
	res = res.substr(0, res.length - 1); //去掉最后一个逗号
	if(hasPoint) {
		return "¥" + sign + res + "." + piontPart;
	} else {
		return "¥" + sign + res;
	}
}

function DX(n) {
	if(!/^(0|[1-9]\d*)(\.\d+)?$/.test(n))
		return "数据非法";
	var unit = "千百拾亿千百拾万千百拾元角分",
		str = "";
	n += "00";
	var p = n.indexOf('.');
	if(p >= 0)
		n = n.substring(0, p) + n.substr(p + 1, 2);
	unit = unit.substr(unit.length - n.length);
	for(var i = 0; i < n.length; i++)
		str += '零壹贰叁肆伍陆柒捌玖'.charAt(n.charAt(i)) + unit.charAt(i);
	return str.replace(/零(千|百|拾|角)/g, "零").replace(/(零)+/g, "零").replace(/零(万|亿|元)/g, "$1").replace(/(亿)万|壹(拾)/g, "$1$2").replace(/^元零?|零分/g, "").replace(/元$/g, "元整");
}
/**
 * 正则校验
 * @param re
 * @param s
 * @param msg
 * @returns {boolean}
 */
function testRegExp(re, s, msg) {
	if(s == null || trim(s) == "") {
		mui.toast("请输入" + msg);
	} else {
		s = trim(s);
		if(re.test(s)) {
			return true;
		} else {
			if(msg != null) {
				mui.toast("请输入正确格式的" + msg);
			}
			return false;
		}
	}

}
/**
 * 校验金额
 * @param s 待校验值
 * @param msg 提示关键信息
 * @param maxLeng 最大位数
 * @param isNegative 是否可以为负数 true=可以为负数
 * @param isNoDecimals 是否没有(1-2位)小数,true=没有小数
 * @returns {boolean}
 */
function testRegExpMoney(s, msg, maxLeng, isNegative, isNoDecimals) {
	if(maxLeng != null) {
		// var regExp=/^([0-9]{1,maxLeng})(\.[0-9]{1,2})?$/;
		var regExp;
		if(isNegative) {
			if(isNoDecimals) {
				regExp = eval("/^(-)?(\\d{1," + maxLeng + "})$/");
			} else {
				regExp = eval("/^(-)?(\\d{1," + maxLeng + "})(\\.\\d{1,2})?$/");
			}

		} else {
			if(isNoDecimals) {
				regExp = eval("/^(\\d{1," + maxLeng + "})$/");
			} else {
				regExp = eval("/^(\\d{1," + maxLeng + "})(\\.\\d{1,2})?$/");
			}

		}
		if(regExp.test(s)) {
			return true;
		} else {
			if(msg != null) {
				var maxInt = "";
				for(var i = 0; i < maxLeng; i++) {
					maxInt += "0";
				}
				var msgIsNoDecimals = ",最多两位小数";
				if(isNoDecimals) {
					msgIsNoDecimals = "整数";
				}
				if(isNegative) {
					mui.toast("请输入正确格式的" + msg + "(±1" + maxInt + "之内" + msgIsNoDecimals + ")");
				} else {
					mui.toast("请输入正确格式的" + msg + "(小于1" + maxInt + msgIsNoDecimals + ")");
				}

			}
			return false;
		}
	} else {
		if(_moneyAbove0.test(s)) {
			return true;
		} else {
			if(msg != null) {
				mui.toast("请输入正确格式的" + msg + "(1亿以内,最多两位小数)");
			}
			return false;
		}
	}

}
/**
 *
 * @param s
 * @param maxL
 * @param msg
 * @param minL 最小值<=0时,允许S为空
 * @returns {boolean}
 */
function testRegExpMaxLength(s, maxL, msg,minL) {
	if(s == null || trim(s) == "") {
		if(minL==null||minL >0) {
			if(msg != null ) {
				if(msg.indexOf("请输入")==0){
					msg=msg.substr(3);
				}
				mui.toast("请输入" + msg);
			}
			return false;
		}else {
			return true;
		}

	} else {
		if(s.length <= maxL) {
			return true;
		} else {
			if(msg != null) {
				if(msg.indexOf("请输入")==0){
					msg=msg.substr(3);
				}
				mui.toast("请输入正确格式的" + msg + "(最多" + maxL + "个字)");
			} else {
				mui.toast("最多" + maxL + "个字");
			}

			return false;
		}
	}
}
/**
 * 为空或小于最大长度
 * @param s
 * @param maxL
 * @param msg
 * @returns {boolean}
 */
function testMaxLength(s, maxL, msg) {
	if(s != null) {
		if(s.length <= maxL) {
			return true;
		} else {
			if(msg != null) {
				mui.toast("请输入正确格式的" + msg + "(最多" + maxL + "个字)");
			} else {
				mui.toast("最多" + maxL + "个字");
			}
			return false;
		}
	} else {
		return true;
	}
}
/**
 * 批量检查带必填标志([data-required])的输入或设置项是否都已有满足要求的值
 * @param node
 * @returns {boolean} true =满足要求
 */
function test_required_child(node) {
	var node_cur=node!=null?node:document;
	var requires =node_cur.querySelectorAll(("[data-required]"));
	for (var i=0;i<requires.length;i++){
		var value="未找到的节点类型";
		var maxlength=requires[i].getAttribute("data-maxlength");
		var minlength=requires[i].getAttribute("data-minlength");
		if("DIV SPAN LABEL H1 H2 H3 H4 H5".indexOf(requires[i].nodeName)>=0){
			value=getText(requires[i].innerText);

		}else if("INPUT".indexOf(requires[i].nodeName)>=0){
			value=getText(requires[i].value);
		}
		if(value!="未找到的节点类型"){
			if(maxlength!=null){
				if (!testRegExpMaxLength(value,maxlength, requires[i].getAttribute("data-required"),minlength)) {
					requires[i].focus();
					return false;
				}
			}else {
				if(value==""){
					mui.toast(requires[i].getAttribute("data-required"));
					requires[i].focus();
					return false;
				}
			}

		}

	}
	return true;
}
/**
 *
 * @param param
 * @returns {string} 变量的类型
 */
function getParamType(param) {
	var type = ((_t = typeof(param)) == "object" ? Object.prototype.toString.call(param).slice(8, -1) : _t).toLowerCase();
	return type;
}
function deletePropertyInvalid (obj,value_delete) {//删除无效数据
    if(obj!=null){
        for (var key in obj) {
            if(obj[key]===null){
                console.log("delete:"+obj[key]);
                delete obj[key];
            }
        }
        if(value_delete!==null&&value_delete!==undefined){
            for (var key in obj) {
                if(obj[key]==value_delete){
                    console.log("delete:"+obj[key]);
                    delete obj[key];
                }
            }
        }
    }
    return obj;
}
/**
 * 获取样式属性
 * @param obj
 * @param attr
 * @returns {*}
 */
function getStyle(obj, attr) {
	if(obj.currentStyle) {
		return obj.currentStyle[attr];
	} else {
		// console.log(document.defaultView.getComputedStyle(obj, null));
		return document.defaultView.getComputedStyle(obj, null)[attr];
	}
}
/**
 *
 * @param a 尺寸
 * @returns 像素为单位的值
 */
function getpx(a) {
	try {
		var type = getParamType(a);
		if(type == null || type == "undefined" || a == "auto") {
			a = 0;
		} else if(type == "number") {
			//return a;
		} else if(type == "string") {
			var re = a.lastIndexOf("rem");
			if(re >= 0) {
				a = a.substring(0, re) * 20;
			} else {
				var p = a.lastIndexOf("px");
				if(p > 0) {
					a = a.substring(0, p);
				} else {
					//a = a;
				}
			}
		}

		return parseFloat(a);
	} catch(e) {
		return 0;
	}

}
/**
 * 获取数据类型
 * @param v
 * @returns {string}
 */
function getType(v) {
	return Object.prototype.toString.call(v);
}

function getNumFromStr(str) {
	var num = 0;
	if(str == null || str == "NaN") {} else {
		try {
			num = parseFloat(str);
		} catch(e) {
			console.error(e);
			num = 0;
		}
	}

	return num;
}
/**
 * 设置文字
 * @param view
 * @param text
 */
function setText(view, text, def) {
	if(view != null) {
		text = getText(text, def);
		view.innerHTML = text;
	}
}

function setValue(view, text, def) {
	if(view != null) {
		text = getText(text, def);
		view.value = text;
	}
}
/**
 * 获取innerHTML
 * @param view
 * @param def 默认值
 * @param deleteFF 是否取出前后空格
 * @returns {*}
 */
function getData_value(view, def, deleteFF) {
	var result = def;
	if(view != null) {
		result = view.value;
		if(deleteFF) {
			result = trim(result);
		}
	}
	return result;
}
/**
 * 获取innerHTML
 * @param view
 * @param def 默认值
 * @param deleteFF 是否取出前后空格
 * @returns {*}
 */
function getData_text(view, def, deleteFF) {
	var result = def;
	if(view != null) {
		result = view.innerHTML;
		if(deleteFF) {
			result = trim(result);
		}
	}
	return result;
}
/**
 * 防止null
 * @param str
 * @returns {*}
 */
function getText(str, def) {
	if(str == null || str == "NaN" || str == "undefined" || str == "") {
		if(def != null) {
			str = def;
		} else {
			str = "";
		}

	}
	return str;
}
/**
 * 时间间隔计算(间隔天数)
 * @param startDate
 * @param endDate
 * @returns {number}
 * @constructor
 */
function getDateDiff(startDate, endDate) {
	var startTime = new Date(Date.parse(startDate.replace(/-/g, "/"))).getTime();
	var endTime = new Date(Date.parse(endDate.replace(/-/g, "/"))).getTime();
	var dates = Math.abs((startTime - endTime)) / (1000 * 60 * 60 * 24);
	return dates;
}
/**
 * 清除缓存
 */
function app_clear_session_local() {
	sessionStorage.clear();
	localStorage.clear();
}

/**
 * 获取项目根路径
 * @returns {string}
 */
function getAppPath() {
	////获取当前网址，如： http://localhost:8080/ems/Pages/Basic/Person.jsp
	//var curWwwPath = window.document.location.href;
	////获取主机地址之后的目录，如： /ems/Pages/Basic/Person.jsp
	//var pathName = window.document.location.pathname;
	//var pos = curWwwPath.indexOf(pathName);
	////获取主机地址，如： http://localhost:8080
	//var localhostPath = curWwwPath.substring(0, pos);
	////获取带"/"的项目名，如：/ems
	//var projectName = pathName.substring(0, pathName.substr(1).indexOf('/') + 1);
	////return(localhostPath + projectName);
	//if (curWwwPath.indexOf('localhost') >= 0){
	//  return(localhostPath + projectName+'/app');
	//}else {
	//  return(localhostPath);
	//}
	var current_href = location.href;
	var protocol = location.protocol;
	var host = location.host;
	var docRoot = '/app';
	var appRootPath = protocol + '//' + host;
	if(current_href.indexOf('localhost') >= 0) {
		appRootPath += '/qyzw' + docRoot
	} else if(current_href.indexOf('192.168.7.69') >= 0) {
		appRootPath += docRoot;
	}
	return appRootPath
}
//阻塞事件派分
function app_stopPropagation() {
	//阻止冒泡调用parent
	var e = (event) ? event : window.event;
	if(window.event) { //IE
		e.cancelBubble = true;
	} else { //FF
		e.stopPropagation();
	}
}
/**
 * 阻止子控件回调事件
 * @param view
 */
function app_stopPropagation_children(view) {
	//var children = view.children();
	var children = view.childNodes;
	children = del_ff(children);
	mui.each(children, function(index, item) {
		item.onclick = function(e) {
			app_stopPropagation();
		};
		//item.on("click",function(e){
		//  app_stopPropagation();
		//});
	});
}

/**
 * 获取两个日期的近似差值
 * @param startDate 起始日
 * @param endDate   结束日
 */
function dateGetDiffDays(startDate, endDate) {
	return Math.floor((endDate.getTime() - startDate.getTime()) / (24 * 60 * 60 * 1000));
}

/*滚动到头部*/
var scrolldelay;

function pageScroll() {
	//把内容滚动指定的像素数（第一个参数是向右滚动的像素数，第二个参数是向下滚动的像素数）
	window.scrollBy(0, -100);
	//延时递归调用，模拟滚动向上效果
	scrolldelay = setTimeout('pageScroll()', 10);
	//获取scrollTop值，声明了DTD的标准网页取document.documentElement.scrollTop，否则取document.body.scrollTop；因为二者只有一个会生效，另一个就恒为0，所以取和值可以得到网页的真正的scrollTop值
	var sTop = document.documentElement.scrollTop + document.body.scrollTop;
	//判断当页面到达顶部，取消延时代码（否则页面滚动到顶部会无法再向下正常浏览页面）
	if(sTop == 0) clearTimeout(scrolldelay);
}

/**
 * 数组是否包含 值
 * @param arr
 * @param obj
 * @param querytype 是否匹配类型
 * @param key 如果是对象的属性,则对比属性=key的值
 * @returns {boolean}
 */
function contains(arr, obj, querytype, key) {
	//console.log("arr:"+arr);
	//console.log("arr instanceof Array:"+arr instanceof Array);
	if(arr != null && arr instanceof Array) {
		var i = arr.length;
		while(i--) {
			if(key != null) {
				if(querytype) {
					if(arr[i][key] === obj) {
						return true;
					}
				} else {
					if(arr[i][key] == obj) {
						return true;
					}
				}

			} else {
				if(querytype) {
					if(arr[i] === obj) {
						return true;
					}
				} else {
					if(arr[i] == obj) {
						return true;
					}
				}

			}
		}
	}
	return false;
}

/**
 * 如果数组包含该元素，返回下标
 * @param arr
 * @param val
 * @returns {number}
 */
function arr_indexOf(arr, val) {
	if(arr != null && arr instanceof Array) {
		for(var i = 0; i < arr.length; i++) {
			if(arr[i] == val) return i;
		}
	}

	return -1;
};
/**
 *  删除数组中的元素
 * @param arr
 * @param obj
 * @returns {Array.<T>}
 */
function removeInArr(arr, obj) {
	for(var i = 0; i < arr.length; i++) {
		if(arr[i] == obj) {
			return arr.splice(i, 1);
		}
	}
}

/**
 * s节点数组中的换行符
 * @param elem
 */
function del_ff(elems) {
	var elems_New = new Array();
	for(var i = 0; i < elems.length; i++) {
		if(!(elems[i].nodeName == "#text" && !/\s/.test(elems.nodeValue)) && elems[i].nodeName != "#comment") {
			elems_New[elems_New.length] = elems[i]
		}
	}
	return elems_New;
}
/**
 *  获取所有兄弟节点
 * @param elem
 * @returns {Array}
 */
function getElems_Brother(elem) {
	var elems_New = new Array();
	if(elem != null) {
		var elems = elem.parentNode.childNodes;
		for(var i = 0; i < elems.length; i++) {
			if(!(elems[i].nodeName == "#text" && !/\s/.test(elems.nodeValue)) && elem !== elems[i]) {
				elems_New[elems_New.length] = elems[i]
			}
		}
	}
	return elems_New;
}
/**
 * 获取所有子节点
 * @param elem
 * @returns {Array}
 */
function getElems_childNodes(elem) {
	var childs = elem.childNodes;
	if(childs != null && childs.length > 0) {
		return del_ff(childs);
	} else {
		return null;
	}
}
/**
 * 获取父节点
 * @param className 包含的class
 * @param maxCount 查询的最大层次数
 * @returns {*}
 */
function getParentNodeByClass(node, className, maxCount) {
	var ly_item = node;
	if(!maxCount) {
		maxCount = 20;
	}
	for(var i = 0; i < maxCount; i++) {
		if(ly_item.classList != null && ly_item.classList.contains(className)) {
			return ly_item;
		} else {
			ly_item = ly_item.parentNode;
		}
	}
	return null;
}

function setMaxWidth_childNodes(elem, count) {
	//console.log(" setMaxWidth_childNodes(elem,count)");
	var childs = getElems_childNodes(elem);
	if(childs != null && childs.length > 0) {
		for(var i = 0; i < childs.length; i++) {
			childs[i].style.maxWidth = "100%";
			if(count != null && !isNaN(count)) {
				if(count > 0) {
					setMaxWidth_childNodes(childs[i], count - 1);
				}
			} else {
				setMaxWidth_childNodes(childs[i]);
			}
		}
	}
}
/**
 * 获取页面名字
 * @param path
 * @returns {string}
 */
function getPageName(path) {
	return path.substring(path.lastIndexOf("/") + 1, path.lastIndexOf(".html"))
}

/**
 * 删除节点
 * @param _element
 */
function removeElement(_element) {
	if(_element != null) {
		var _parentElement = _element.parentNode;
		if(_parentElement) {
			_parentElement.removeChild(_element);
		}
	}

}
/**
 * html代码转换
 * @type {{htmlEncode: Function, htmlDecode: Function, htmlEncodeByRegExp: Function, htmlDecodeByRegExp: Function}}
 */
var HtmlUtil = {
	/*1.用浏览器内部转换器实现html转码*/
	htmlEncode: function(html) {
		//1.首先动态创建一个容器标签元素，如DIV
		var temp = document.createElement("div");
		//2.然后将要转换的字符串设置为这个元素的innerText(ie支持)或者textContent(火狐，google支持)
		(temp.textContent != undefined) ? (temp.textContent = html) : (temp.innerText = html);
		//3.最后返回这个元素的innerHTML，即得到经过HTML编码转换的字符串了
		var output = temp.innerHTML;
		temp = null;
		return output;
	},
	/*2.用浏览器内部转换器实现html解码*/
	htmlDecode: function(text) {
		//1.首先动态创建一个容器标签元素，如DIV
		var temp = document.createElement("div");
		//2.然后将要转换的字符串设置为这个元素的innerHTML(ie，火狐，google都支持)
		temp.innerHTML = text;
		//3.最后返回这个元素的innerText(ie支持)或者textContent(火狐，google支持)，即得到经过HTML解码的字符串了。
		var output = temp.innerText || temp.textContent;
		temp = null;
		return output;
	},
	/*3.用正则表达式实现html转码*/
	htmlEncodeByRegExp: function(str) {
		var s = "";
		if(str.length == 0) return "";
		s = str.replace(/&/g, "&amp;");
		s = s.replace(/</g, "&lt;");
		s = s.replace(/>/g, "&gt;");
		s = s.replace(/ /g, "&nbsp;");
		s = s.replace(/\'/g, "&#39;");
		s = s.replace(/\"/g, "&quot;");
		return s;
	},
	/*4.用正则表达式实现html解码*/
	htmlDecodeByRegExp: function(str) {
		var s = "";
		if(str.length == 0) return "";
		s = str.replace(/&amp;/g, "&");
		s = s.replace(/&lt;/g, "<");
		s = s.replace(/&gt;/g, ">");
		s = s.replace(/&nbsp;/g, " ");
		s = s.replace(/&#39;/g, "\'");
		s = s.replace(/&quot;/g, "\"");
		return s;
	}
};
/*字符串转dom对象(整个dom)*/
(function(DOMParser) {
	"use strict";

	var
		DOMParser_proto = DOMParser.prototype,
		real_parseFromString = DOMParser_proto.parseFromString;

	// Firefox/Opera/IE throw errors on unsupported types
	try {
		// WebKit returns null on unsupported types
		if((new DOMParser).parseFromString("", "text/html")) {
			// text/html parsing is natively supported
			return;
		}
	} catch(ex) {}

	DOMParser_proto.parseFromString = function(markup, type) {
		if(/^\s*text\/html\s*(?:;|$)/i.test(type)) {
			var
				doc = document.implementation.createHTMLDocument("");
			if(markup.toLowerCase().indexOf("'") > -1) {
				doc.documentElement.innerHTML = markup;

			} else {
				doc.body.innerHTML = markup;
			}
			return doc;
		} else {
			return real_parseFromString.apply(this, arguments);
		}
	}
}(DOMParser));

function getElementFromString(html) {
	var parser = new DOMParser();
	return parser.parseFromString(html, "text/html");

}

function parseStringToHTML(text) {
	var i, a = document.createElement("div"),
		b = document.createDocumentFragment();
	a.innerHTML = text;
	while(i = a.firstChild) {
		b.appendChild(i);
	}
	return b;
}
/**
 * 获取浏览器类型
 * @returns {*}
 */
function getBrowserType() {
	var userAgent = navigator.userAgent; //取得浏览器的userAgent字符串
	if(userAgent.match(/iPhone|iPod/i) != null) {
		//iphone代码
		return "iPhone";
	} else if(userAgent.match(/Android/i) != null) {
		//android代码
		return "Android";
	} else if(userAgent.match(/iPad/i) != null) {
		//ipad代码
		return "iPad";
	}
	var isOpera = userAgent.indexOf("Opera") > -1;
	if(isOpera) {
		return "Opera"
	}; //判断是否Opera浏览器
	if(userAgent.indexOf("Firefox") > -1) {
		return "FF";
	} //判断是否Firefox浏览器
	if(userAgent.indexOf("Chrome") > -1) {
		return "Chrome";
	}
	if(userAgent.indexOf("Safari") > -1) {
		return "Safari";
	} //判断是否Safari浏览器
	if(userAgent.indexOf("compatible") > -1 && userAgent.indexOf("MSIE") > -1 && !isOpera) {
		return "IE";
	}; //判断是否IE浏览器

}
// Converts image to canvas; returns new canvas element
function convertImageToCanvas(image) {
	var canvas = document.createElement("canvas");
	canvas.width = image.width;
	canvas.height = image.height;
	canvas.getContext("2d").drawImage(image, 0, 0);
	return canvas;
}
// Converts canvas to an image
function convertCanvasToImage(canvas) {
	var image = new Image();
	image.src = canvas.toDataURL("image/png");
	return image;
}
/**
 * 根据selector选择器 添加统一点击样式
 * @param selector
 */
function auto_tap_style(selector) {
	var selectorCur = selector;
	if(selectorCur == null) {
		selectorCur = ".auto_app_tap_style";
	}
	mui("body").on("touchstart", selectorCur, function(e) {
		// console.log(this);
		if(this.classList != null) {
			this.classList.add("app_tap_style");
		} else {
			this.className = "app_tap_style";
		}
	});
	mui("body").on("touchend", selectorCur, function(e) {
		// console.log(this);
		this.classList.remove("app_tap_style");
	});
	mui("body").on("touchcancel", selectorCur, function(e) {
		this.classList.remove("app_tap_style");
	});
}

//对象、数组克隆
function deepClone(obj) {
	var result;
	var oClass = isClass(obj);
	if(oClass === "Object") {
		result = {};
	} else if(oClass === "Array") {
		result = [];
	} else {
		return obj;
	}
	for(var key in obj) {
		var copy = obj[key];
		if(isClass(copy) == "Object") {
			result[key] = arguments.callee(copy); //递归调用
		} else if(isClass(copy) == "Array") {
			result[key] = arguments.callee(copy);
		} else {
			result[key] = obj[key];
		}
	}
	return result;
}

/**
 * 解构赋值 arguments.length>=2
 * @returns {any}
 */
function assignment() {
    for (var key1 in arguments[0]) {
        // console.log(key1+":"+arguments[0][key1]);
        for (var i=1; i<arguments.length; i++) {
            // console.log(arguments[i]);
            for (var key2 in arguments[i]) {
                if(key1==key2){
                    arguments[0][key1]=arguments[i][key2]
                }
            }
        }
    }
    // console.log(arguments[0]);
    return arguments[0];
}
//判断对象的数据类型
function isClass(o) {
	if(o === null) return "Null";
	if(o === undefined) return "Undefined";
	return Object.prototype.toString.call(o).slice(8, -1);
}


//删除emoji表情
function deleteEmoji(str) {
	var reg = /[\uD83C|\uD83D|\uD83E][\uDC00-\uDFFF][\u200D|\uFE0F]|[\uD83C|\uD83D|\uD83E][\uDC00-\uDFFF]|[0-9|*|#]\uFE0F\u20E3|[0-9|#]\u20E3|[\u203C-\u3299]\uFE0F\u200D|[\u203C-\u3299]\uFE0F|[\u2122-\u2B55]|\u303D|[\A9|\AE]\u3030|\uA9|\uAE|\u3030/gi;
	if (reg.test(str)) {
		mui.toast('您输入的信息中含有特殊字符，已为您移除')
        str = str.replace(reg, "")
    }
    return str
}

//删除textarea的emoji表情
document.querySelector('body').addEventListener('change', function(e) {
	var tar = e.target
	if (tar.nodeName.toLowerCase() =='textarea' || tar.nodeName.toLowerCase() =='input') {
		tar.value = deleteEmoji(tar.value)
	}
}, true)

/**
 * [showMultiUnits description] 根据选择的多单位展示库存数量
 * @author lucky
 * @param    {[array]}                 multiUnits 多单位数组
 * @param    {[number]}                 stockQty  基本单位对应的数量
 * @param    {[type]}                 selectedUnitId    
 */
function showMultiUnits(multiUnits, stockQty, selectedUnitId) {
	var stockQtyShow = '' //显示的库存数量
	var sortMultiUnits = [] //从大到小排序后的多单位数组
	var selectedURate //传入的selectedUnitId对应的uRate
	if (!multiUnits || multiUnits && multiUnits.length == 0) {
		return stockQty ? stockQty : 0
	}
	if (multiUnits && multiUnits.length > 0) {
		mui.each(multiUnits, function(i, v) {
			if (!selectedUnitId && v.uRate == 1) {
				selectedUnitId = v.unitId
			}
			if (stockQty == 0 && v.uRate == 1) {
				stockQtyShow = stockQty + v.unitName
			}
			sortMultiUnits.push(v)
		})
		sortMultiUnits = sortMultiUnits.sort(function(x, y) {//对多单位根据换算比例从大到小牌排序
      return y.uRate - x.uRate
		})
		if (stockQtyShow) {
			return stockQtyShow
		}
		for (var i = 0; i < sortMultiUnits.length; i++) {
			if (selectedUnitId == sortMultiUnits[i].unitId) {
				selectedURate = sortMultiUnits[i].uRate
				var k = i
				for (var j = 0; j < sortMultiUnits.length - k; j++) {
					var residual
					if (j == 0) {
						if (sortMultiUnits.length - k == 1) { //选择的为最小多单位
							return stockQtyShow = formatNumWithDigit(stockQty / selectedURate, qtyDigit) + sortMultiUnits[k].unitName
						}
						var rounding = Math.floor(stockQty / selectedURate) //取整
						if (rounding > 0) {
							stockQtyShow = rounding + sortMultiUnits[k].unitName
						}
						residual = formatNumWithDigit((stockQty * 10000) % (selectedURate * 10000) / 10000, qtyDigit) //*10000消除js精确度的影响
						if (j + k + 1 < sortMultiUnits.length) { 
							sortMultiUnits[j + k + 1].qty = residual //选择的单位不是最小单位时，在最小单位对象里缓存取整剩余的数量
						}
					} else {
						residual = sortMultiUnits[j + k].qty //获取次级单位里的剩余数量
						var rounding2
						if (j == sortMultiUnits.length - k - 1) {//循环到最小一级多单位
							rounding2 = formatNumWithDigit(residual / sortMultiUnits[j + k].uRate, qtyDigit)
						} else {
							rounding2 = Math.floor(residual / sortMultiUnits[j + k].uRate)
						}
						if (rounding2 > 0) {
							stockQtyShow += rounding2 + sortMultiUnits[j + k].unitName
						}
						if (j + k + 1 < sortMultiUnits.length) {
							sortMultiUnits[j + k + 1].qty = formatNumWithDigit((residual * 10000) % (sortMultiUnits[j + k].uRate * 10000) / 10000, qtyDigit)
						}
					}
				}
				return stockQtyShow
				break;
			}
		}
	}
}

