/**
 * Created by 0000 on 2017/6/26.
 */
//过滤器
// Vue.filter('uppercase', function(value) {
//     if (!value) { return ''}
//     value = value.toString()
//     return value.charAt(0).toUpperCase() + value.slice(1)
// });
// Vue.filter('getText', function(str, def) {
//     return getText(text,def);
// });
// Vue.filter('numberFormat', function (number, decimals, decPoint, thousandsSep) {
//     return numberFormat(number, decimals!=null?decimals:2, decPoint!=null?decPoint:'.', thousandsSep!=null?thousandsSep:',');
// });
var util_methods={
    /**
     * 设置picker默认显示的选择项
     * @author lucky
     * @DateTime 2019-01-07T16:32:07+0800
     * @param picker      picker实体
     * @param pickerList  picker选择项列表
     * @param text        需要设为默认的选择项 
     */
    setPickerDefault: function(picker, pickerList, text) {
        mui.each(pickerList, function(i, v) {
            if (v.text == text) {
                picker.pickers[0].setSelectedIndex(i);
            }
        })
    },
    /*新的权限判断*/
    authorityCheckUpdated: function(authorityString) {
        return authorityCheckUpdated(authorityString)
    },
    havePermission: function (obj) {
        // var havePermission=app_userManage.hasPermission(obj,false);
        // console.log("havePermission:"+havePermission);
        return app_userManage.hasPermission(obj,false);
    },
    hasAdminPurview: function () {//是否有管理员权限
        return app_userManage.hasAdminPermission();
    },
    isEmpty: function (text) {
        return getText(text)=="";
    },
    isContainEmpty:function (text) {//是否包含空null,或者空字符传,入参text可以是数组、字符串,包含返回true
        if(text instanceof Array){
            for(var i=0;i<text.length;i++){
                if(this.isEmpty(text[i])) {
                    return true;
                }
            }
            return false;
        }else  {
            return this.isEmpty(text);
        }

    },
    isContainValue: function (text) {//是否包含有效值(非null,空字符传),包含返回true
        if(text instanceof Array){
            for(var i=0;i<text.length;i++){
                if(!this.isEmpty(text[i])) {
                    return true;
                }
            }
            return false;
        }else {
            return !this.isEmpty(text);
        }
    },
    /**
     * @author 刘小丰
     * @param testObj 验证对象JSON字符串
     * {
     * "name":"名称",//提示名字
     * "isNotEmpty":true, //是否不能为空
     *  "maxLength":2 //最大长度2
     * "testStr":/^\S{6,12}$/,//需要满足的正则表达式
     * "testMsg":"0-100,最多的两位小数",//不满足的提示
     *  "isNumberFormat_fromSeting_qty":true,//是否建议小数位是否符合系统设置的数量小数位
     *  "sNumberFormat_fromSeting_price":true,//是否建议小数位是否符合系统设置的单价小数位
     * }
     * @param event 校验的控件监听的事件源,或者校验的控件
     */
    testValue: function (event) {//验证值是否符合规则
     console.log("testValue");
        if(!this.compositionsing){
            var success=true;
            var nodeDom=event instanceof Event?event.currentTarget:event;
            var testObj=nodeDom.getAttribute("data-test");
            var msg="";
            if(testObj!=null){
                if(typeof testObj === "string"){
                    testObj=JSON.parse(testObj);
                }
                var value;
                if(nodeDom.nodeName=="INPUT"||nodeDom.nodeName=="TEXTAREA"){
                    value=nodeDom.value;
                }else {
                    value=nodeDom.innerText;
                }
             // console.log("value:"+value);
                if(testObj.isNotEmpty&&(value==null||value.length==0)){
                    msg=(testObj.name!=null?testObj.name:"")+"不能为空";
                    success=false;
                }else if(!testObj.isNotEmpty&&(value==null||value.length==0)){
                    return  true;
                }else if(testObj.maxLength!=null&&value.length>testObj.maxLength){
                    msg=(testObj.name!=null?testObj.name:"")+"不能超过"+testObj.maxLength+"个字";
                    success=false;
                }else if(testObj.testStr!=null){
                    var reg = eval(testObj.testStr);
                    if(!reg.test(value)){
                        msg="请输入正确格式的"+(testObj.name!=null?testObj.name:"")+(testObj.testMsg!=null?"("+testObj.testMsg+")":"");
                        success=false;
                    }
                }
                if (success) {
                    if(testObj.isNumberFormat_fromSeting_qty){//如果限制数量小数位
                        if( typeof qtyDigit !== "undefined"){//没有加载digitSettings.js文件的页面即使调用本方法 也不使用设置的小数点位数
                            var reg = eval("/(^[\\d]{0,9}(\\.[\\d]{0,"+qtyDigit+"})?$)|(^[\\d]{0,9}$)/");
                            // var reg = eval(/(^[\d]+(\.[\d]{0,3})?$)|(^[\d]*$)/);
                            if(!reg.test(value)){
                                msg="请输入正确格式的"+(testObj.name!=null?testObj.name:"")+"(低于10亿,最多包含"+qtyDigit+"位小数)";
                                success=false;
                            }
                        }
                    }
                    if(testObj.sNumberFormat_fromSeting_price){//如果限制数量小数位
                        if( typeof priceDigit !== "undefined"){//没有加载digitSettings.js文件的页面即使调用本方法 也不使用设置的小数点位数
                            var reg = eval("/(^[\\d]{0,9}(\\.[\\d]{0,"+priceDigit+"})?$)|(^[\\d]{0,9}$)/");
                            // var reg = eval(/(^[\d]+(\.[\d]{0,3})?$)|(^[\d]*$)/);
                            if(!reg.test(value)){
                                msg="请输入正确格式的"+(testObj.name!=null?testObj.name:"")+"(低于10亿,最多包含"+priceDigit+"位小数)";
                                success=false;
                            }
                        }
                    }
                }
                if(testObj.msg!=null){
                    msg=testObj.msg;
                }
            }
            if(!success){
                mui.toast(msg);
                shine(nodeDom);
            }
            return  success;
        }

    },
    compositionstart: function (event) {//事件触发于一段文字的输入之前（类似于 keydown 事件，但是该事件仅在若干可见字符的输入之前，而这些可见字符的输入可能需要一连串的键盘操作、语音识别或者点击输入法的备选词）
        this.compositionsing=true;
        console.log("compositionstart");
    },
    compositionend: function (event) {
        this.compositionsing=false;
        console.log("compositionend");
    },
    /**
     * 页面跳转统一入口，自动保存页面数据
     * @param _Config 或 pageUrl
     * {
            'pageUrl': '',
            'extras': null,
            'createNew': false,
            'closeWebView': false,
            'popGesture': 'close'
        }
\     * @param extrasNext 传递的extras
     * @param autoDispose_Permissions 是否权限判断（预留字段）
     */
    openNewPage_saveData:function (_Config, extrasNext,autoDispose_Permissions) {
        var pageUrl="";//要跳转到的地址
        if(typeof(_Config) == "string"){
            pageUrl=_Config;
        }else if(typeof(_Config) == "object"){
            pageUrl=_Config.pageUrl;
            // autoDispose_Permissions==_Config.autoDispose_Permissions;
            // if(_Config.autoDispose_Permissions){
            //     autoDispose_Permissions=_Config.autoDispose_Permissions;
            // }
        }
        // if(autoDispose_Permissions&&app_userManage.getPermissions(true)<2){//如果需要判断权限
        //     return;
        // }
        if (typeof(Extras) !== "undefined"&&Extras !== null) {//当前页面的extras
            sessionStorageUtil.setItem(getPageExtrasName(), Extras);
            /*删除过期缓存*/
            var strExtras=sessionStorage.getItem("strExtras");
            if(strExtras!=null){
                sessionStorage.removeItem("strExtras");
            }else {
                strExtras = sessionStorageUtil.getItem("strExtras");
                if(strExtras!=null){
                    sessionStorageUtil.removeItem("strExtras");
                }
            }
        }
        sessionStorageUtil.removeItem(getPageExtrasName(pageUrl));//删除要跳转到的地址的缓存，防止上次异常退出时留下的缓存扰乱本次数据
        openNewPage(_Config,extrasNext);
    },
    deletePropertyInvalid:function (obj,value_delete) {//删除无效数据
        if(obj!=null){
            for (var key in obj) {
                if(obj[key]===null){
                    console.log("delete:"+obj[key]);
                    delete obj[key];
                }
            }
            if(value_delete!==null&&value_delete!==undefined){
                for (var key in obj) {
                    if(obj[key]==value_delete){
                        console.log("delete:"+obj[key]);
                        delete obj[key];
                    }
                }
            }
        }
        return obj;
    },
    numberFormat_fromSeting_qty: function (number, decimals, decPoint, thousandsSep) {
        // console.log("qtyDigit:"+qtyDigit);
        // console.log("priceDigit:"+priceDigit);
        if( typeof qtyDigit == "undefined"){//没有加载digitSettings.js文件的页面即使调用本方法 也不使用设置的小数点位数
            return numberFormat(number, decimals!=null?decimals:2, decPoint!=null?decPoint:'.', thousandsSep!=null?thousandsSep:',');
        }else {
            return numberFormat(number, qtyDigit, decPoint!=null?decPoint:'.', thousandsSep!=null?thousandsSep:',');
        }
    },
    numberFormat_fromSeting_price: function (number, decimals, decPoint, thousandsSep) {
        // console.log("qtyDigit:"+qtyDigit);
        // console.log("priceDigit:"+priceDigit);
        if( typeof priceDigit == "undefined"){//没有加载digitSettings.js文件的页面即使调用本方法 也不使用设置的小数点位数
            return numberFormat(number, decimals!=null?decimals:2, decPoint!=null?decPoint:'.', thousandsSep!=null?thousandsSep:',');
        }else {
            return numberFormat(number, priceDigit, decPoint!=null?decPoint:'.', thousandsSep!=null?thousandsSep:',');
        }
    },
    getImgPath: function (path,def) {
        if(getText(path)!=""){
            return path;
        }else {
            return def!=null?def:"../../img/default_picture.png";
        }

    },
};
var util_filters={
    showMultiUnits: function(multiUnits, stockQty, selectedUnitId) {
        return showMultiUnits(multiUnits, stockQty, selectedUnitId)
    },
    capitalize1: function (value) {
        if (!value) return '';
        value = value.toString();
        return value.charAt(0).toUpperCase() + value.slice(1)
    },
    getText: function (text,def) {
        return getText(text,def);
    },
    getJSONString: function (obj) {//对象转json字符串
        if(obj instanceof Object){
            return JSON.stringify(obj);
        }else {
            return "";
        }
    },
    getImgPath: function (path,def) {
        if(getText(path)!=""){
            return path;
        }else {
            return def!=null?def:"../../img/default_picture.png";
        }

    },
    numberFormat: function (number, decimals, decPoint, thousandsSep) {
        return numberFormat(number, decimals!=null?decimals:2, decPoint!=null?decPoint:'.', thousandsSep!=null?thousandsSep:',');
    },
    numberFormat_fromSeting_qty: function (number, decimals, decPoint, thousandsSep) {
        // console.log("qtyDigit:"+qtyDigit);
        // console.log("priceDigit:"+priceDigit);
        if( typeof qtyDigit == "undefined"){//没有加载digitSettings.js文件的页面即使调用本方法 也不使用设置的小数点位数
            return numberFormat(number, decimals!=null?decimals:2, decPoint!=null?decPoint:'.', thousandsSep!=null?thousandsSep:',');
        }else {
            return numberFormat(number, qtyDigit, decPoint!=null?decPoint:'.', thousandsSep!=null?thousandsSep:',');
        }
    },
    numberFormat_fromSeting_price: function (number, decimals, decPoint, thousandsSep) {
        // console.log("qtyDigit:"+qtyDigit);
        // console.log("priceDigit:"+priceDigit);
        if( typeof priceDigit == "undefined"){//没有加载digitSettings.js文件的页面即使调用本方法 也不使用设置的小数点位数
            return numberFormat(number, decimals!=null?decimals:2, decPoint!=null?decPoint:'.', thousandsSep!=null?thousandsSep:',');
        }else {
            return numberFormat(number, priceDigit, decPoint!=null?decPoint:'.', thousandsSep!=null?thousandsSep:',');
        }
    },
    getStrDateFormatStrDate: function (Date) {//格式化日期
        return getStrDateFormatStrDate(Date);
    },
};
var mixin = {
    methods: util_methods,
    filters: util_filters,
};
Vue.mixin(mixin);
/**
 * 获取页面数据
 */
function getData_cache() {
    /*如果页面没声明Extras全局变量，则声明*/
    var global = this;
    if (!global.Extras) {
        global.Extras = { };
    }
    var extras_cur=null;
    /*传入页面的数据*/
    if (mui.os.plus) {
        if (arguments[0]) {//避免重复调用
            var self = plus.webview.currentWebview();
            var strExtras = self.strExtras;
            if(strExtras!=null){
                extras_cur = JSON.parse(strExtras);
            }
        }
    } else {
        extras_cur =sessionStorageUtil.getItem(getPageExtrasName());//上次离开页面时的最新数据
        if(extras_cur==null){
            extras_cur= sessionStorageUtil.getItem("strExtras");//进入页面的数据
            if(extras_cur==null){
                extras_cur=sessionStorage.getItem("strExtras");//进入页面的数据（兼容老代码）
                if(extras_cur!=null){
                    extras_cur=JSON.parse(extras_cur);
                }
            }
        }
    }
    /*页面缓存的数据*/
    if(extras_cur!=null){
        Extras = extras_cur;
    }
}
/**
 * 获取页面缓存key
 * @returns {string}
 */
function getPageExtrasName(href) {
    if(href==null){
        href=window.location.href;
    }
    return href.substring(href.lastIndexOf("/")+1,href.lastIndexOf(".html"))+"_extras";
}

function shine(element,options) {
    var settings = mui.extend({}, {
        start: "#fff",
        color: "#fbb",
        step: 5,
        times: 2,
        length: 4,
        speed: 30
    }, options);
    var arrStart = settings.start.split("");
    var arrColor = settings.color.split("");
    var arrFinish = [];
    var i;

    for (i = 0; i < settings.step; ++i) {
        var newColor = arrStart[0];
        for (var j = 1; j < settings.length; ++j) {
            var l = parseInt(arrStart[j], 16);
            var m = parseInt(arrColor[j], 16);
            newColor += Math.floor(parseInt(l + (m - l) * i / settings.step, 10)).toString(16);
        }
        arrFinish.push(newColor);
    }

    for (i = 0; i < settings.times; ++i) {
        arrFinish = arrFinish.slice(0, arrFinish.length - 1).concat(arrFinish.concat([]).reverse());
    }

    var timer = setInterval(function () {
        if (!arrFinish.length) {
            clearInterval(timer);
            timer = 0;
        } else {
            element.style.backgroundColor= arrFinish.pop();
            console.log("element.style.backgroundColor:"+element.style.backgroundColor)
        }
    }, settings.speed);
};
