function createPrintData(module, type, details, config, otherConfig) {
	var createTplFuncs = createTplFuncCfg[module];
	if(!createTplFuncs) {
		return null;
	}
	switch(type) {
		case "58mm":
			return createTplFuncs["tpl_58mm"](details, config, otherConfig);
		case "80mm":
			return createTplFuncs["tpl_80mm"](details, config, otherConfig);
		case "PrickBase": //针式
			return createTplFuncs["tpl_prickbase"](details, config, otherConfig);
		case "tag": //标签
			break;
		default:
			break;
	}
}

//-----------销售
var create58PrintData_Sale = function(details, config, otherConfig) {
	var printDataArray = [];
	if(config["pageHead"]) {
		printDataArray.push({
			content: config["pageHead"],
			align: "center",
			fontSize: config["fontScale"] ? "middle" : "small"
		});
	}
	printDataArray.push({
		content: config["billName"],
		align: "center",
		fontSize: "middle"
	});
	printDataArray.push({
		type: "doubleLine"
	});
	printDataArray.push({
		content: details.customerName,
		fontSize: config["fontScale"] ? "middle" : "small"
	});
	if(config.showField.warehouseName && config.showField.warehouseName.value) {
		printDataArray.push({
			content: config.showField.warehouseName.text + "：" + details[config.showField.warehouseName.field],
		});
	}

	printDataArray.push({
		content: "经手人：" + details.employeeName,
	});
	printDataArray.push({
		content: "单号：" + details.no,
	});
	printDataArray.push({
		content: "日期：" + handleDate(details.businessDate), //使用预定义函数
	});
	printDataArray.push({
		type: "line"
	});

	//group
	printDataArray.push({
		"type": "group",
		"data": [{
				"width": 4,
				"content": "商品"
			},
			{
				"content": "数量",
				"width": 9,
				"align": "right"
			},
			{
				"content": "单位",
				"width": 6,
				"align": "right"
			},
			{
				"content": "单价",
				"width": 13,
				"align": "right"
			}
		]
	});
	var totalQty = 0; //总数量
	var items = details.details;
	for(var i = 0; i < items.length; i++) {
		printDataArray.push({
			type: "line"
		});
		totalQty += items[i].qty;
		var showName = items[i].name;
		if(config.showField.barcode && config.showField.barcode.value) {
			var barcode = (items[i]["barcode"] ? "/" + items[i]["barcode"] : "");
			showName = "【" + items[i]["no"] + barcode + "】" + items[i].name;
		}
		if(config.showField.propertySpec && config.showField.propertySpec.value) {
			items[i].specification ? (showName += ("/" + items[i].specification)) : "";
			items[i].property ? (showName += ("/" + items[i].property)) : "";
		}
		printDataArray.push({
			"content": showName
		});
		//group
		printDataArray.push({
			type: "group",
			data: [{
					"content": items[i].qty, //15字符
					"width": 13,
					"align": "right",
					"maxChar": 12 //12字符,留一个空格字符
				},
				{
					"content": items[i].unitName,
					"width": 6,
					"align": "right",
					"maxChar": 4
				},
				{
					"content": Number(numberFormat(items[i].price, priceDigit, ".", "")), //10字符,留一个空格字符
					"width": 13,
					"align": "right",
				}
			]
		});
		printDataArray.push({
			"type": "group",
			"data": [{
					"content": "小计金额",
					"width": 8
				},
				{
					"content": items[i].total, //8字符
					"width": 24,
					"align": "right"
				}
			]
		});
	}

	printDataArray.push({
		type: "doubleLine"
	});

	printDataArray.push({
		"type": "group",
		"data": [{
				"content": "合计",
				"width": 4
			},
			{
				"content": Number(numberFormat(totalQty, qtyDigit, ".", "")), //8字符
				"align": "center",
				"width": 15,
				"maxChar": 13
			},
			{
				"content": details.total,
				"align": "right",
				"width": 13
			}
		]
	});
	if(config.showField.discount && config.showField.discount.value) {
		var content = "";
		if(details.discountType == 1) {
			content = "折扣率：" + details.discountRate + "%";
		} else {
			content = "折扣额：" + details.discountTotal;
		}
		printDataArray.push({
			"content": content
		});
	}
	if(config.showField.taxTotal && config.showField.taxTotal.value) {
		printDataArray.push({
			"content": "折后税额：" + details.taxTotal
		});
	}
	if(config.showField.otherFee && config.showField.otherFee.value) {
		printDataArray.push({
			"content": "其他费用：" + details.otherFee
		});
	}
	if(config.showField.accountName && config.showField.accountName.value) {
		printDataArray.push({
			"content": "结算账户：" + details.accountName
		});
	}
	printDataArray.push({
		type: "line"
	});
	printDataArray.push({
		"content": "总计金额：" + details.realTotal
	});
	//判断单据类型
	var typeArr = details["no"].split("-");
	if(typeArr.length > 0 && typeArr[0].toUpperCase() === "XS") {
		printDataArray.push({
			"content": "实收金额：" + (details.postTotal ? details.postTotal : 0)
		});
	} else if(typeArr.length > 0 && typeArr[0].toUpperCase() === "XST") {
		printDataArray.push({
			"content": "实退金额：" + (details.postTotal ? details.postTotal : 0)
		});
	}

	if(config.showField.memo && config.showField.memo.value) {
		printDataArray.push({
			"content": "备注：" + (details.memo?details.memo:"无")
		});
	}
	if(config.showField.inputeName && config.showField.inputeName.value) {
		printDataArray.push({
			"content": "制单人：" + details.inputeName
		});
	}
	//联系人信息
	if(config.showField["contactInfo"] && config.showField["contactInfo"].value) {
		printDataArray.push({
			"content": "联系人：" + details[config.showField["contactInfo"].field]
		});
	}
	printDataArray.push({
		"content": "打印日期：" + getNowFormatDate(true) //使用预置函数tools.js
	});
	if(config["pageFooter"]) {
		printDataArray.push({
			content: config["pageFooter"],
			align: "center",
		});
	}
	var printData = {
		"printData": printDataArray
	};
	return printData;
};
var create80PrintData_Sale = function(details, config, otherConfig) {
	var printDataArray = [];
	if(config["pageHead"]) {
		printDataArray.push({
			content: config["pageHead"],
			align: "center",
			fontSize: config["fontScale"] ? "middle" : "small"
		});
	}
	printDataArray.push({
		content: config["billName"],
		align: "center",
		fontSize: "middle"
	});
	printDataArray.push({
		type: "doubleLine"
	});
	printDataArray.push({
		content: details.customerName,
		fontSize: config["fontScale"] ? "middle" : "small"
	});
	//group48个char
	printDataArray.push({
		"type": "group",
		"data": [{
				"width": 24,
				"content": "单号：" + details.no,
				"maxChar": 24
			},
			{
				"content": "经手人：" + details.employeeName,
				"width": 24,
			}
		]
	});
	var groupData = {
		"type": "group",
		"data": [{
			"width": 24,
			"content": "日期：" + handleDate(details.businessDate), //使用预定义函数
		}]
	};
	if(config.showField.warehouseName && config.showField.warehouseName.value) {
		groupData.data.push({
			"width": 24,
			"content": config.showField.warehouseName.text + "：" + details[config.showField.warehouseName.field],
		});
	}
	printDataArray.push(groupData);

	printDataArray.push({
		type: "line"
	});

	//group
	printDataArray.push({
		"type": "group",
		"data": [{
				"width": 4,
				"content": "商品"
			},
			{
				"content": "数量",
				"width": 10,
				"align": "right"
			},
			{
				"content": "单位",
				"width": 6,
				"align": "right"
			},
			{
				"content": "单价",
				"width": 14,
				"align": "center"
			},
			{
				"content": "小计",
				"width": 14,
				"align": "right"
			}
		]
	});

	var totalQty = 0; //总数量
	var items = details.details;
	for(var i = 0; i < items.length; i++) {
		printDataArray.push({
			type: "line"
		});
		totalQty += items[i].qty;
		var showName = items[i].name;
		if(config.showField.barcode && config.showField.barcode.value) {
			var barcode = (items[i]["barcode"] ? "/" + items[i]["barcode"] : "");
			showName = "【" + items[i]["no"] + barcode + "】" + items[i].name;
		}
		if(config.showField.propertySpec && config.showField.propertySpec.value) {
			items[i].specification ? (showName += ("/" + items[i].specification)) : "";
			items[i].property ? (showName += ("/" + items[i].property)) : "";
		}
		printDataArray.push({
			"content": showName
		});
		//group
		printDataArray.push({
			type: "group",
			data: [{
					"content": items[i].qty, //15字符
					"width": 14,
					"align": "right",
				},
				{
					"content": items[i].unitName,
					"width": 6,
					"align": "right",
					"maxChar": 5
				},
				{
					"content": Number(numberFormat(items[i].price, priceDigit, ".", "")), //11字符,留一个空格字符
					"width": 14,
					"align": "center",
					"maxChar": 13
				},
				{
					"content": items[i].total,
					"width": 14,
					"align": "right",
					//"maxChar": 12//最后一个可以换行
				}
			]
		});
	}

	printDataArray.push({
		type: "doubleLine"
	});

	printDataArray.push({
		"type": "group",
		"data": [{
				"content": "合计",
				"width": 4,
				"align": "left"
			},
			{
				"content": Number(numberFormat(totalQty, qtyDigit, ".", "")), //8字符
				"align": "center",
				"width": 16
			},
			{
				"width": 28,
				"content": details.total,
				"align": "right",
			}
		]
	});
	var groupData2 = {
		"type": "group",
		"data": []
	};
	if(config.showField.discount && config.showField.discount.value) {
		var content = "";
		if(details.discountType == 1) {
			content = "折扣率：" + details.discountRate + "%";
		} else {
			content = "折扣额：" + details.discountTotal;
		}
		groupData2.data.push({
			"width": 24,
			"content": content
		});
	}
	if(config.showField.taxTotal && config.showField.taxTotal.value) {
		groupData2.data.push({
			"width": 24,
			"content": "折后税额：" + details.taxTotal
		});
	}
	if(groupData2.data.length > 0) {
		printDataArray.push(groupData2);
	}
	var groupData3 = {
		"type": "group",
		"data": []
	};
	if(config.showField.otherFee && config.showField.otherFee.value) {
		groupData3.data.push({
			"width": 24,
			"content": "其他费用：" + details.otherFee
		});
	}
	if(config.showField.accountName && config.showField.accountName.value) {
		groupData3.data.push({
			"width": 24,
			"content": "结算账户：" + (details.accountName ? details.accountName : "")
		});
	}
	if(groupData3.data.length > 0) {
		printDataArray.push(groupData3);
	}
	printDataArray.push({
		type: "line"
	});

	var groupData4 = {
		"type": "group",
		"data": [{
			"width": 24,
			"content": "总计金额：" + details.realTotal
		}]
	};
	//判断单据类型
	var typeArr = details["no"].split("-");
	if(typeArr.length > 0 && typeArr[0].toUpperCase() === "XS") {
		groupData4.data.push({
			"width": 24,
			"content": "实收金额：" + (details.postTotal ? details.postTotal : 0)
		});
	} else if(typeArr.length > 0 && typeArr[0].toUpperCase() === "XST") {
		groupData4.data.push({
			"width": 24,
			"content": "实退金额：" + (details.postTotal ? details.postTotal : 0)
		});
	}
	printDataArray.push(groupData4);

	if(config.showField.memo && config.showField.memo.value) {
		printDataArray.push({
			"content": "备注：" + (details.memo?details.memo:"无")
		});
	}
	if(config.showField.inputeName && config.showField.inputeName.value) {
		printDataArray.push({
			"content": "制单人：" + details.inputeName
		});
	}
	//联系人信息
	if(config.showField["contactInfo"] && config.showField["contactInfo"].value) {
		printDataArray.push({
			"content": "联系人：" + details[config.showField["contactInfo"].field]
		});
	}
	printDataArray.push({
		"content": "打印日期：" + getNowFormatDate(true) //使用预置函数tools.js
	});
	if(config["pageFooter"]) {
		printDataArray.push({
			content: config["pageFooter"],
			align: "center",
		});
	}
	var printData = {
		"printData": printDataArray
	};
	return printData;

};
var createPrickBasePrintData_Sale = function(details, config, otherConfig) {
	var printDataArray = [];
	if(config["pageHead"]) {
		printDataArray.push({
			content: config["pageHead"],
			align: "center",
			fontSize: config["fontScale"] ? "middle" : "small"
		});
	}
	printDataArray.push({
		content: config["billName"],
		align: "center",
		fontSize: "middle"
	});

	var groupData = {
		type: "group",
		data: []
	};
	groupData.data.push({
		content: "往来单位：",
		align: "right",
		width: 10,
	});
	groupData.data.push({
		content: details.customerName,
		fontSize: config["fontScale"] ? "middle" : "small",
		width: 24,
	});
	groupData.data.push({
		content: "  经手人：",
		align: "right",
		width: 10
	});
	groupData.data.push({
		content: details.employeeName,
		width: 24
	});
	groupData.data.push({
		content: "业务日期：",
		align: "right",
		width: 10
	});
	groupData.data.push({
		content: handleDate(details.businessDate),
		width: 22
	});
	printDataArray.push(groupData);
	//一行就是一组
	groupData = {
		type: "group",
		data: []
	};
	groupData.data.push({
		content: "单号    ：",
		align: "right",
		width: 10
	});
	groupData.data.push({
		content: details.no,
		width: 24
	});

	if(config.showField.inputeName && config.showField.inputeName.value) { //选择了制单人
		groupData.data.push({
			content: "  制单人：",
			width: 10,
			align: "right",
		});
		groupData.data.push({
			content: details.inputeName,
			width: 24,
		});
		groupData.data.push({
			content: "制单日期：",
			width: 10,
			align: "right",
		});
		groupData.data.push({
			content: details.createDate,
			width: 22,
		});
		printDataArray.push(groupData);

		if(config.showField.warehouseName && config.showField.warehouseName.value) {
			//一行就是一组
			groupData = {
				type: "group",
				data: []
			};
			groupData.data.push({
				content: config.showField.warehouseName.text + "：",
				align: "right",
				width: 10
			});
			groupData.data.push({
				content: details[config.showField.warehouseName.field],
				width: 90
			});
			printDataArray.push(groupData);
		}
	} else { //未选择制单人
		if(config.showField.warehouseName && config.showField.warehouseName.value) { //选择仓库
			groupData.data.push({
				content: config.showField.warehouseName.text + "：",
				align: "right",
				width: 10
			});
			groupData.data.push({
				content: details[config.showField.warehouseName.field],
				width: 56
			});
		}
		printDataArray.push(groupData);
	}

	//table
	var typeTableData = {
		type: "table",
		columnWidthRatio: [6, 46, 12, 10, 12, 14], //总数小于100，并且每一项最好为偶数
		data: [
			[{
				content: "序号"
			}, {
				content: "商品名称"
			}, {
				content: "数量"
			}, {
				content: "单位"
			}, {
				content: "单价"
			}, {
				content: "小计"
			}]
		]
	};
	var mutableWidthRatio = []; //可变列宽-标题部分
	var mutableTableData = []; //可变列数据-标题部分
	if(config.showField.barcode && config.showField.barcode.value) {
		mutableWidthRatio.push(14);
		mutableTableData.push({
			content: "编号/条码"
		});
	}
	if(config.showField.serial && config.showField.serial.value) {
		mutableWidthRatio.push(12);
		mutableTableData.push({
			content: "序列号"
		});
	}
	if(mutableWidthRatio.length > 0 && mutableWidthRatio.length == mutableTableData.length) {
		var usedLength = 0;
		for(var p = 0; p < mutableWidthRatio.length; p++) {
			usedLength += mutableWidthRatio[p];
			typeTableData.columnWidthRatio.splice((2 + p), 0, mutableWidthRatio[p]);
			typeTableData.data[0].splice((2 + p), 0, mutableTableData[p]);
		}
		typeTableData.columnWidthRatio[1] = 46 - usedLength;
	}
	//商品备注
	if(config.showField.productMemo && config.showField.productMemo.value) {
		typeTableData.columnWidthRatio.push(10);
		typeTableData.data[0].push({
			content: "商品备注"
		});
		typeTableData.columnWidthRatio[1] -= 10;
	}
	//一单多仓库
	if(config.showField.warehouseName && config.showField.warehouseName.value && otherConfig && otherConfig["enableMultiWarehouse"]) {
		typeTableData.columnWidthRatio = typeTableData.columnWidthRatio.slice(0, 2).concat(10, typeTableData.columnWidthRatio.slice(2, typeTableData.columnWidthRatio.length));
		typeTableData.data[0] = typeTableData.data[0].slice(0, 2).concat({content: config.showField.warehouseName.text}, typeTableData.data[0].slice(2, typeTableData.data[0].length));
		typeTableData.columnWidthRatio[1] -= 10;
	}

	var items = details.details;
	for(var i = 0; i < items.length; i++) {
		var rowData = [];
		rowData.push({
			content: (i + 1) + ""
		}); //序号
		var showName = items[i].name;
		if(config.showField.propertySpec && config.showField.propertySpec.value) {
			items[i].specification ? (showName += ("/" + items[i].specification)) : "";
			items[i].property ? (showName += ("/" + items[i].property)) : "";
		}
		rowData.push({
			content: showName + ""
		}); //名称
		if(config.showField.barcode && config.showField.barcode.value) {
			//编号、条形码
			var showNoAndBarcode = "";
			showNoAndBarcode = items[i]["no"];
			showNoAndBarcode += (items[i]["barcode"] ? "/" + items[i]["barcode"] : "/-");
			rowData.push({
				content: showNoAndBarcode
			});
		}
		//序列号
		if(config.showField.serial && config.showField.serial.value) {
			var serialString = "";
			var snList = items[i][config.showField.serial.field];
			for(var o = 0; snList && o < snList.length; o++) {
				if(snList[o]["snNo"]) {
					serialString += snList[o]["snNo"] + ",";
				}
			}
			serialString.length > 0 ? serialString = serialString.substr(0, serialString.length - 1) : "";
			rowData.push({
				content: serialString
			});
		}
		//数量
		rowData.push({
			content: items[i].qty + ""
		});
		//单位
		rowData.push({
			content: items[i].unitName + ""
		});
		//单价
		rowData.push({
			content: Number(numberFormat(items[i].price, priceDigit, ".", "")) + ""
		});
		//小计
		rowData.push({
			content: items[i].total + ""
		});
		//商品备注
		if(config.showField.productMemo && config.showField.productMemo.value) {
			rowData.push({
				content: items[i][config.showField.productMemo.field]
			});
		}
		//一单多仓库
		if(config.showField.warehouseName && config.showField.warehouseName.value && otherConfig && otherConfig["enableMultiWarehouse"]) {
			rowData = rowData.slice(0, 2).concat({
				content: items[i][config.showField.warehouseName.field] ? items[i][config.showField.warehouseName.field] : ""
			}, rowData.slice(2, rowData.length));
		}
		typeTableData.data.push(rowData);
	}
	var lastColData = [{
		content: "合计金额",
		numColumns: typeTableData.data[0].length - 1
	}];
	lastColData.push({
		content: details.total,
	});
	if(config.showField.productMemo && config.showField.productMemo.value) {
		lastColData[0]["numColumns"] = typeTableData.data[0].length - 2;
		lastColData.push({
			content: "",
		});
	}
	typeTableData.data.push(lastColData);
	printDataArray.push(typeTableData);
	var mutableContentArray = []; //可变内容
	if(config.showField.discount && config.showField.discount.value) {
		var contentType = "";
		var content = "";
		if(details.discountType == 1) {
			contentType = "折扣率  ：";
			content = details.discountRate + "%";
		} else {
			contentType = "折扣额  ：";
			content = details.discountTotal + "";
		}
		mutableContentArray.push({
			content: contentType,
			align: "right",
		});
		mutableContentArray.push({
			content: content,
		});
	}
	if(config.showField.taxTotal && config.showField.taxTotal.value) {
		mutableContentArray.push({
			content: "折后税额：",
			align: "right",
		});
		mutableContentArray.push({
			content: details.taxTotal + "",
		});
	}
	if(config.showField.otherFee && config.showField.otherFee.value) {
		mutableContentArray.push({
			align: "right",
			content: "其他费用：",
		});
		mutableContentArray.push({
			content: details.otherFee + "",
		});
	}
	if(config.showField.accountName && config.showField.accountName.value) {
		mutableContentArray.push({
			align: "right",
			content: "结算账户：",
		});
		mutableContentArray.push({
			content: details.accountName + "",
		});
	}
	mutableContentArray.push({
		align: "right",
		content: "总计金额：",
	});
	mutableContentArray.push({
		content: details.realTotal + "",
	});
	//判断单据类型
	var typeArr = details["no"].split("-");
	var titleName = "";
	if(typeArr.length > 0 && typeArr[0].toUpperCase() === "XS") {
		titleName = "实收金额："
	} else if(typeArr.length > 0 && typeArr[0].toUpperCase() === "XST") {
		titleName = "实退金额："
	}
	if(titleName != "") {
		mutableContentArray.push({
			align: "right",
			content: titleName,
		});
		mutableContentArray.push({
			content: (details.postTotal ? details.postTotal + "" : 0)
		});
	}
	//联系人信息
	if(config.showField["contactInfo"] && config.showField["contactInfo"].value) {
		mutableContentArray.push({
			align: "right",
			content: "联系人  ：",
		});
		mutableContentArray.push({
			content: details[config.showField["contactInfo"].field]
		});
	}
	if(config.showField.memo && config.showField.memo.value) {
		mutableContentArray.push({
			align: "right",
			content: "备注    ：",
		});
		mutableContentArray.push({
			content: details.memo?details.memo:"无"
		});
	}
	mutableContentArray.push({
		align: "right",
		content: "打印日期：",
	});
	mutableContentArray.push({
		content: getNowFormatDate(true) //使用预置函数tools.js
	});

	//一行就是一组
	groupData = {
		type: "group",
		data: []
	};
	//mutableContentArray必定是偶数个，6个为1行[10,24,10,24,10,22]
	var colWidthParams = [10, 24, 10, 24, 10, 22];
	for(var i = 0; i < mutableContentArray.length; i++) {
		mutableContentArray[i]["width"] = colWidthParams[i % colWidthParams.length];
		if(groupData.data.length >= colWidthParams.length) {
			printDataArray.push(groupData);
			groupData = {
				type: "group",
				data: []
			};
		}
		groupData.data.push(mutableContentArray[i]);
	}
	if(groupData.data.length > 0) {
		printDataArray.push(groupData);
	}

	if(config["pageFooter"]) {
		printDataArray.push({
			content: config["pageFooter"],
			align: "center",
		});
	}
	var printData = {
		"printData": printDataArray,
		"paperType": config["printSize"]["PrickBase"]["paperType"]
	};
	return printData;
}
var create58PrintData_SaleOrder = function(details, config, otherConfig) {
	return create58PrintData_Sale(details, config, otherConfig);
};
var create80PrintData_SaleOrder = function(details, config, otherConfig) {
	return create80PrintData_Sale(details, config, otherConfig);
};
var createPrickBasePrintData_SaleOrder = function(details, config, otherConfig) {
	otherConfig["enableMultiWarehouse"] = false;
	return createPrickBasePrintData_Sale(details, config, otherConfig);
};
var create58PrintData_SaleReturn = function(details, config, otherConfig) {
	return create58PrintData_Sale(details, config, otherConfig);
};
var create80PrintData_SaleReturn = function(details, config, otherConfig) {
	return create80PrintData_Sale(details, config, otherConfig);
};
var createPrickBasePrintData_SaleReturn = function(details, config, otherConfig) {
	return createPrickBasePrintData_Sale(details, config, otherConfig);
};
//-----------零售单
var create58PrintData_Retail = function(details, config, otherConfig) {
	var printDataArray = [];
	if(config["pageHead"]) {
		printDataArray.push({
			content: config["pageHead"],
			align: "center",
			fontSize: config["fontScale"] ? "middle" : "small"
		});
	}
	printDataArray.push({
		content: config["billName"],
		align: "center",
		fontSize: "middle"
	});
	printDataArray.push({
		type: "doubleLine"
	});
	printDataArray.push({
		content: details.customerName,
		fontSize: config["fontScale"] ? "middle" : "small"
	});
	if(config.showField.warehouseName && config.showField.warehouseName.value) {
		printDataArray.push({
			content: config.showField.warehouseName.text + "：" + details[config.showField.warehouseName.field],
		});
	}

	printDataArray.push({
		content: "经手人：" + details.employeeName,
	});
	printDataArray.push({
		content: "单号：" + details.no,
	});
	printDataArray.push({
		content: "日期：" + handleDate(details.businessDate), //使用预定义函数
	});
	printDataArray.push({
		type: "line"
	});

	//group
	printDataArray.push({
		"type": "group",
		"data": [{
				"width": 4,
				"content": "商品"
			},
			{
				"content": "数量",
				"width": 9,
				"align": "right"
			},
			{
				"content": "单位",
				"width": 6,
				"align": "right"
			},
			{
				"content": "单价",
				"width": 13,
				"align": "right"
			}
		]
	});
	var totalQty = 0; //总数量
	var items = details.details;
	for(var i = 0; i < items.length; i++) {
		printDataArray.push({
			type: "line"
		});
		totalQty += items[i].qty;
		var showName = items[i].name;
		if(config.showField.barcode && config.showField.barcode.value) {
			var barcode = (items[i]["barcode"] ? "/" + items[i]["barcode"] : "");
			showName = "【" + items[i]["no"] + barcode + "】" + items[i].name;
		}
		if(config.showField.propertySpec && config.showField.propertySpec.value) {
			items[i].specification ? (showName += ("/" + items[i].specification)) : "";
			items[i].property ? (showName += ("/" + items[i].property)) : "";
		}
		printDataArray.push({
			"content": showName
		});
		//group
		printDataArray.push({
			type: "group",
			data: [{
					"content": items[i].qty, //15字符
					"width": 13,
					"align": "right",
					"maxChar": 12 //12字符,留一个空格字符
				},
				{
					"content": items[i].unitName,
					"width": 6,
					"align": "right",
					"maxChar": 4
				},
				{
					"content": Number(numberFormat(items[i].price, priceDigit, ".", "")), //10字符,留一个空格字符
					"width": 13,
					"align": "right",
				}
			]
		});
		printDataArray.push({
			"type": "group",
			"data": [{
					"content": "小计金额",
					"width": 8
				},
				{
					"content": items[i].total, //8字符
					"width": 24,
					"align": "right"
				}
			]
		});
	}

	printDataArray.push({
		type: "doubleLine"
	});

	printDataArray.push({
		"type": "group",
		"data": [{
				"content": "合计",
				"width": 4
			},
			{
				"content": Number(numberFormat(totalQty, qtyDigit, ".", "")), //8字符
				"align": "center",
				"width": 15,
				"maxChar": 13
			},
			{
				"content": details.total,
				"align": "right",
				"width": 13
			}
		]
	});
	if(config.showField.discount && config.showField.discount.value) {
		printDataArray.push({
			"content": "折扣额：" + details.discountTotal
		});
	}
	if(config.showField.accountName && config.showField.accountName.value) {
		printDataArray.push({
			"content": "结算账户：" + details.accountName
		});
	}
	printDataArray.push({
		type: "line"
	});
	printDataArray.push({
		"content": "总计金额：" + details.realTotal
	});
	printDataArray.push({
		"content": "实收金额：" + (details.postTotal ? details.postTotal : 0)
	});
	//找零
	printDataArray.push({
		"content": "找零：" + numberFormat(details.postTotal - details.realTotal, 2, '.', '')
	});

	if(config.showField.memo && config.showField.memo.value) {
		printDataArray.push({
			"content": "备注：" + (details.memo?details.memo:"无")
		});
	}
	if(config.showField.inputeName && config.showField.inputeName.value) {
		printDataArray.push({
			"content": "制单人：" + details.inputeName
		});
	}
	//联系人信息
	if(config.showField["contactInfo"] && config.showField["contactInfo"].value) {
		printDataArray.push({
			"content": "联系人：" + details[config.showField["contactInfo"].field]
		});
	}
	printDataArray.push({
		"content": "打印日期：" + getNowFormatDate(true) //使用预置函数tools.js
	});
	if(config["pageFooter"]) {
		printDataArray.push({
			content: config["pageFooter"],
			align: "center",
		});
	}
	var printData = {
		"printData": printDataArray
	};
	return printData;
};

var create80PrintData_Retail = function(details, config, otherConfig) {
	var printDataArray = [];
	if(config["pageHead"]) {
		printDataArray.push({
			content: config["pageHead"],
			align: "center",
			fontSize: config["fontScale"] ? "middle" : "small"
		});
	}
	printDataArray.push({
		content: config["billName"],
		align: "center",
		fontSize: "middle"
	});
	printDataArray.push({
		type: "doubleLine"
	});
	printDataArray.push({
		content: details.customerName,
		fontSize: config["fontScale"] ? "middle" : "small"
	});
	//group48个char
	printDataArray.push({
		"type": "group",
		"data": [{
				"width": 24,
				"content": "单号：" + details.no,
				"maxChar": 24
			},
			{
				"content": "经手人：" + details.employeeName,
				"width": 24,
			}
		]
	});
	var groupData = {
		"type": "group",
		"data": [{
			"width": 24,
			"content": "日期：" + handleDate(details.businessDate), //使用预定义函数
		}]
	};
	if(config.showField.warehouseName && config.showField.warehouseName.value) {
		groupData.data.push({
			"width": 24,
			"content": config.showField.warehouseName.text + "：" + details[config.showField.warehouseName.field],
		});
	}
	printDataArray.push(groupData);

	printDataArray.push({
		type: "line"
	});

	//group
	printDataArray.push({
		"type": "group",
		"data": [{
				"width": 4,
				"content": "商品"
			},
			{
				"content": "数量",
				"width": 10,
				"align": "right"
			},
			{
				"content": "单位",
				"width": 6,
				"align": "right"
			},
			{
				"content": "单价",
				"width": 14,
				"align": "center"
			},
			{
				"content": "小计",
				"width": 14,
				"align": "right"
			}
		]
	});

	var totalQty = 0; //总数量
	var items = details.details;
	for(var i = 0; i < items.length; i++) {
		printDataArray.push({
			type: "line"
		});
		totalQty += items[i].qty;
		var showName = items[i].name;
		if(config.showField.barcode && config.showField.barcode.value) {
			var barcode = (items[i]["barcode"] ? "/" + items[i]["barcode"] : "");
			showName = "【" + items[i]["no"] + barcode + "】" + items[i].name;
		}
		if(config.showField.propertySpec && config.showField.propertySpec.value) {
			items[i].specification ? (showName += ("/" + items[i].specification)) : "";
			items[i].property ? (showName += ("/" + items[i].property)) : "";
		}
		printDataArray.push({
			"content": showName
		});
		//group
		printDataArray.push({
			type: "group",
			data: [{
					"content": items[i].qty, //15字符
					"width": 14,
					"align": "right",
				},
				{
					"content": items[i].unitName,
					"width": 6,
					"align": "right",
					"maxChar": 5
				},
				{
					"content": Number(numberFormat(items[i].price, priceDigit, ".", "")), //11字符,留一个空格字符
					"width": 14,
					"align": "center",
					"maxChar": 13
				},
				{
					"content": items[i].total,
					"width": 14,
					"align": "right",
					//"maxChar": 12//最后一个可以换行
				}
			]
		});
	}

	printDataArray.push({
		type: "doubleLine"
	});

	printDataArray.push({
		"type": "group",
		"data": [{
				"content": "合计",
				"width": 4,
				"align": "left"
			},
			{
				"content": Number(numberFormat(totalQty, qtyDigit, ".", "")), //8字符
				"align": "center",
				"width": 16
			},
			{
				"width": 28,
				"content": details.total,
				"align": "right",
			}
		]
	});
	var groupData2 = {
		"type": "group",
		"data": []
	};
	if(config.showField.discount && config.showField.discount.value) {
		groupData2.data.push({
			"width": 24,
			"content": "折扣额：" + details.discountTotal
		});
	}
	if(config.showField.accountName && config.showField.accountName.value) {
		groupData2.data.push({
			"width": 24,
			"content": "结算账户：" + (details.accountName ? details.accountName : "")
		});
	}
	if(groupData2.data.length > 0) {
		printDataArray.push(groupData2);
	}
	
	printDataArray.push({
		type: "line"
	});

	var groupData3 = {
		"type": "group",
		"data": [{
			"width": 24,
			"content": "总计金额：" + details.realTotal
		}]
	};
	groupData3.data.push({
		"width": 24,
		"content": "实收金额：" + (details.postTotal ? details.postTotal : 0)
	});
	printDataArray.push(groupData3);
	//找零
	printDataArray.push({
		"content": "找零：" + numberFormat(details.postTotal - details.realTotal, 2, '.', '')
	});

	if(config.showField.memo && config.showField.memo.value) {
		printDataArray.push({
			"content": "备注：" + (details.memo?details.memo:"无")
		});
	}
	if(config.showField.inputeName && config.showField.inputeName.value) {
		printDataArray.push({
			"content": "制单人：" + details.inputeName
		});
	}
	//联系人信息
	if(config.showField["contactInfo"] && config.showField["contactInfo"].value) {
		printDataArray.push({
			"content": "联系人：" + details[config.showField["contactInfo"].field]
		});
	}
	printDataArray.push({
		"content": "打印日期：" + getNowFormatDate(true) //使用预置函数tools.js
	});
	if(config["pageFooter"]) {
		printDataArray.push({
			content: config["pageFooter"],
			align: "center",
		});
	}
	var printData = {
		"printData": printDataArray
	};
	return printData;
};

var createPrickBasePrintData_Retail = function(details, config, otherConfig) {
	var printDataArray = [];
	if(config["pageHead"]) {
		printDataArray.push({
			content: config["pageHead"],
			align: "center",
			fontSize: config["fontScale"] ? "middle" : "small"
		});
	}
	printDataArray.push({
		content: config["billName"],
		align: "center",
		fontSize: "middle"
	});

	var groupData = {
		type: "group",
		data: []
	};
	groupData.data.push({
		content: "往来单位：",
		align: "right",
		width: 10,
	});
	groupData.data.push({
		content: details.customerName,
		fontSize: config["fontScale"] ? "middle" : "small",
		width: 24,
	});
	groupData.data.push({
		content: "  经手人：",
		align: "right",
		width: 10
	});
	groupData.data.push({
		content: details.employeeName,
		width: 24
	});
	groupData.data.push({
		content: "业务日期：",
		align: "right",
		width: 10
	});
	groupData.data.push({
		content: handleDate(details.businessDate),
		width: 22
	});
	printDataArray.push(groupData);
	//一行就是一组
	groupData = {
		type: "group",
		data: []
	};
	groupData.data.push({
		content: "单号    ：",
		align: "right",
		width: 10
	});
	groupData.data.push({
		content: details.no,
		width: 24
	});

	if(config.showField.inputeName && config.showField.inputeName.value) { //选择了制单人
		groupData.data.push({
			content: "  制单人：",
			width: 10,
			align: "right",
		});
		groupData.data.push({
			content: details.inputeName,
			width: 24,
		});
		groupData.data.push({
			content: "制单日期：",
			width: 10,
			align: "right",
		});
		groupData.data.push({
			content: details.createDate,
			width: 22,
		});
		printDataArray.push(groupData);

		if(config.showField.warehouseName && config.showField.warehouseName.value) {
			//一行就是一组
			groupData = {
				type: "group",
				data: []
			};
			groupData.data.push({
				content: config.showField.warehouseName.text + "：",
				align: "right",
				width: 10
			});
			groupData.data.push({
				content: details[config.showField.warehouseName.field],
				width: 90
			});
			printDataArray.push(groupData);
		}
	} else { //未选择制单人
		if(config.showField.warehouseName && config.showField.warehouseName.value) { //选择仓库
			groupData.data.push({
				content: config.showField.warehouseName.text + "：",
				align: "right",
				width: 10
			});
			groupData.data.push({
				content: details[config.showField.warehouseName.field],
				width: 56
			});
		}
		printDataArray.push(groupData);
	}

	//table
	var typeTableData = {
		type: "table",
		columnWidthRatio: [6, 46, 12, 10, 12, 14], //总数小于100，并且每一项最好为偶数
		data: [
			[{
				content: "序号"
			}, {
				content: "商品名称"
			}, {
				content: "数量"
			}, {
				content: "单位"
			}, {
				content: "单价"
			}, {
				content: "小计"
			}]
		]
	};
	var mutableWidthRatio = []; //可变列宽-标题部分
	var mutableTableData = []; //可变列数据-标题部分
	if(config.showField.barcode && config.showField.barcode.value) {
		mutableWidthRatio.push(14);
		mutableTableData.push({
			content: "编号/条码"
		});
	}
	if(config.showField.serial && config.showField.serial.value) {
		mutableWidthRatio.push(12);
		mutableTableData.push({
			content: "序列号"
		});
	}
	if(mutableWidthRatio.length > 0 && mutableWidthRatio.length == mutableTableData.length) {
		var usedLength = 0;
		for(var p = 0; p < mutableWidthRatio.length; p++) {
			usedLength += mutableWidthRatio[p];
			typeTableData.columnWidthRatio.splice((2 + p), 0, mutableWidthRatio[p]);
			typeTableData.data[0].splice((2 + p), 0, mutableTableData[p]);
		}
		typeTableData.columnWidthRatio[1] = 46 - usedLength;
	}
	//商品备注
	if(config.showField.productMemo && config.showField.productMemo.value) {
		typeTableData.columnWidthRatio.push(10);
		typeTableData.data[0].push({
			content: "商品备注"
		});
		typeTableData.columnWidthRatio[1] -= 10;
	}

	var items = details.details;
	for(var i = 0; i < items.length; i++) {
		var rowData = [];
		rowData.push({
			content: (i + 1) + ""
		}); //序号
		var showName = items[i].name;
		if(config.showField.propertySpec && config.showField.propertySpec.value) {
			items[i].specification ? (showName += ("/" + items[i].specification)) : "";
			items[i].property ? (showName += ("/" + items[i].property)) : "";
		}
		rowData.push({
			content: showName + ""
		}); //名称
		if(config.showField.barcode && config.showField.barcode.value) {
			//编号、条形码
			var showNoAndBarcode = "";
			showNoAndBarcode = items[i]["no"];
			showNoAndBarcode += (items[i]["barcode"] ? "/" + items[i]["barcode"] : "/-");
			rowData.push({
				content: showNoAndBarcode
			});
		}
		//序列号
		if(config.showField.serial && config.showField.serial.value) {
			var serialString = "";
			var snList = items[i][config.showField.serial.field];
			for(var o = 0; snList && o < snList.length; o++) {
				if(snList[o]["snNo"]) {
					serialString += snList[o]["snNo"] + ",";
				}
			}
			serialString.length > 0 ? serialString = serialString.substr(0, serialString.length - 1) : "";
			rowData.push({
				content: serialString
			});
		}
		//数量
		rowData.push({
			content: items[i].qty + ""
		});
		//单位
		rowData.push({
			content: items[i].unitName + ""
		});
		//单价
		rowData.push({
			content: Number(numberFormat(items[i].price, priceDigit, ".", "")) + ""
		});
		//小计
		rowData.push({
			content: items[i].total + ""
		});
		//商品备注
		if(config.showField.productMemo && config.showField.productMemo.value) {
			rowData.push({
				content: items[i][config.showField.productMemo.field]
			});
		}
		typeTableData.data.push(rowData);
	}
	var lastColData = [{
		content: "合计金额",
		numColumns: typeTableData.data[0].length - 1
	}];
	lastColData.push({
		content: details.total,
	});
	if(config.showField.productMemo && config.showField.productMemo.value) {
		lastColData[0]["numColumns"] = typeTableData.data[0].length - 2;
		lastColData.push({
			content: "",
		});
	}
	typeTableData.data.push(lastColData);
	printDataArray.push(typeTableData);
	var mutableContentArray = []; //可变内容
	if(config.showField.discount && config.showField.discount.value) {
		mutableContentArray.push({
			content: "折扣额  ：",
			align: "right",
		});
		mutableContentArray.push({
			content: details.discountTotal + "",
		});
	}
	if(config.showField.accountName && config.showField.accountName.value) {
		mutableContentArray.push({
			align: "right",
			content: "结算账户：",
		});
		mutableContentArray.push({
			content: details.accountName + "",
		});
	}
	mutableContentArray.push({
		align: "right",
		content: "总计金额：",
	});
	mutableContentArray.push({
		content: details.realTotal + "",
	});
	mutableContentArray.push({
		align: "right",
		content: "实收金额：",
	});
	mutableContentArray.push({
		content: details.postTotal + ""
	});
	mutableContentArray.push({
		align: "right",
		content: "找零：",
	});
	mutableContentArray.push({
		content: numberFormat(details.postTotal - details.realTotal, 2, '.', '')  + ""
	});
	//联系人信息
	if(config.showField["contactInfo"] && config.showField["contactInfo"].value) {
		mutableContentArray.push({
			align: "right",
			content: "联系人  ：",
		});
		mutableContentArray.push({
			content: details[config.showField["contactInfo"].field]
		});
	}
	if(config.showField.memo && config.showField.memo.value) {
		mutableContentArray.push({
			align: "right",
			content: "备注    ：",
		});
		mutableContentArray.push({
			content: details.memo?details.memo:"无"
		});
	}
	mutableContentArray.push({
		align: "right",
		content: "打印日期：",
	});
	mutableContentArray.push({
		content: getNowFormatDate(true) //使用预置函数tools.js
	});

	//一行就是一组
	groupData = {
		type: "group",
		data: []
	};
	//mutableContentArray必定是偶数个，6个为1行[10,24,10,24,10,22]
	var colWidthParams = [10, 24, 10, 24, 10, 22];
	for(var i = 0; i < mutableContentArray.length; i++) {
		mutableContentArray[i]["width"] = colWidthParams[i % colWidthParams.length];
		if(groupData.data.length >= colWidthParams.length) {
			printDataArray.push(groupData);
			groupData = {
				type: "group",
				data: []
			};
		}
		groupData.data.push(mutableContentArray[i]);
	}
	if(groupData.data.length > 0) {
		printDataArray.push(groupData);
	}

	if(config["pageFooter"]) {
		printDataArray.push({
			content: config["pageFooter"],
			align: "center",
		});
	}
	var printData = {
		"printData": printDataArray,
		"paperType": config["printSize"]["PrickBase"]["paperType"]
	};
	return printData;
}

//-----------采购58
var create58PrintData_Purchase = function(details, config, otherConfig) {
	var printDataArray = [];
	if(config["pageHead"]) {
		printDataArray.push({
			content: config["pageHead"],
			align: "center",
			fontSize: config["fontScale"] ? "middle" : "small"
		});
	}
	printDataArray.push({
		content: config["billName"],
		align: "center",
		fontSize: "middle"
	});
	printDataArray.push({
		type: "doubleLine"
	});
	printDataArray.push({
		content: details.customerName,
		fontSize: config["fontScale"] ? "middle" : "small"
	});
	if(config.showField.warehouseName && config.showField.warehouseName.value) {
		printDataArray.push({
			content: config.showField.warehouseName.text + "：" + details[config.showField.warehouseName.field],
		});
	}

	printDataArray.push({
		content: "经手人：" + details.employeeName,
	});
	printDataArray.push({
		content: "单号：" + details.no,
	});
	printDataArray.push({
		content: "日期：" + handleDate(details.businessDate), //使用预定义函数
	});
	printDataArray.push({
		type: "line"
	});

	//group
	printDataArray.push({
		"type": "group",
		"data": [{
				"width": 4,
				"content": "商品"
			},
			{
				"content": "数量",
				"width": 9,
				"align": "right"
			},
			{
				"content": "单位",
				"width": 6,
				"align": "right"
			},
			{
				"content": "单价",
				"width": 13,
				"align": "right"
			}
		]
	});

	var totalQty = 0; //总数量
	var items = details.details;
	for(var i = 0; i < items.length; i++) {
		printDataArray.push({
			type: "line"
		});
		totalQty += items[i].qty;
		var showName = items[i].name;
		if(config.showField.barcode && config.showField.barcode.value) {
			var barcode = (items[i]["barcode"] ? "/" + items[i]["barcode"] : "");
			showName = "【" + items[i]["no"] + barcode + "】" + items[i].name;
		}
		if(config.showField.propertySpec && config.showField.propertySpec.value) {
			items[i].specification ? (showName += ("/" + items[i].specification)) : "";
			items[i].property ? (showName += ("/" + items[i].property)) : "";
		}
		printDataArray.push({
			"content": showName
		});
		//group
		printDataArray.push({
			type: "group",
			data: [{
					"content": items[i].qty, //15字符
					"width": 13,
					"align": "right",
					"maxChar": 12
				},
				{
					"content": items[i].unitName,
					"width": 6,
					"align": "right",
					"maxChar": 4
				},
				{
					"content": otherConfig.showCostPrice?Number(numberFormat(items[i].price, priceDigit, ".", "")):"***", //10字符,留一个空格字符,
					"width": 13,
					"align": "right"
				}
			]
		});
		printDataArray.push({
			"type": "group",
			"data": [{
					"content": "小计金额",
					"width": 8
				},
				{
					"content": otherConfig.showCostPrice?items[i].total:"***", //8字符
					"width": 24,
					"align": "right"
				}
			]
		});
	}

	printDataArray.push({
		type: "doubleLine"
	});

	printDataArray.push({
		"type": "group",
		"data": [{
				"content": "合计",
				"width": 4
			},
			{
				"content": Number(numberFormat(totalQty, qtyDigit, ".", "")), //8字符
				"align": "center",
				"width": 15,
				"maxChar": 13
			},
			{
				"content": otherConfig.showCostPrice?details.total:"***",
				"align": "right",
				"width": 13
			}
		]
	});
	if(config.showField.discount && config.showField.discount.value) {
		var content = "";
		if(details.discountType == 1) {
			content = "折扣率：" + details.discountRate + "%";
		} else {
			content = "折扣额：" + details.discountTotal;
		}
		printDataArray.push({
			"content": content
		});
	}
	if(config.showField.taxTotal && config.showField.taxTotal.value) {
		printDataArray.push({
			"content": "折后税额：" + (otherConfig.showCostPrice?details.taxTotal:"***")
		});
	}
	if(config.showField.otherFee && config.showField.otherFee.value) {
		printDataArray.push({
			"content": "其他费用：" + details.otherFee
		});
	}
	if(config.showField.accountName && config.showField.accountName.value) {
		printDataArray.push({
			"content": "结算账户：" + (details.accountName ? details.accountName : "")
		});
	}
	printDataArray.push({
		type: "line"
	});
	printDataArray.push({
		"content": "总计金额：" + (otherConfig.showCostPrice?details.realTotal:"***")
	});
	//判断单据类型
	var typeArr = details["no"].split("-");
	if(typeArr.length > 0 && typeArr[0].toUpperCase() === "CG") {
		printDataArray.push({
			"content": "实付金额：" + (details.postTotal ? details.postTotal : 0)
		});
	} else if(typeArr.length > 0 && typeArr[0].toUpperCase() === "CGT") {
		printDataArray.push({
			"content": "实退金额：" + (details.postTotal ? details.postTotal : 0)
		});
	}
	if(config.showField.memo && config.showField.memo.value) {
		printDataArray.push({
			"content": "备注：" + (details.memo?details.memo:"无")
		});
	}
	if(config.showField.inputeName && config.showField.inputeName.value) {
		printDataArray.push({
			"content": "制单人：" + details.inputeName
		});
	}
	//联系人信息
	if(config.showField["contactInfo"] && config.showField["contactInfo"].value) {
		printDataArray.push({
			"content": "联系人：" + details[config.showField["contactInfo"].field]
		});
	}
	printDataArray.push({
		"content": "打印日期：" + getNowFormatDate(true) //使用预置函数tools.js
	});
	if(config["pageFooter"]) {
		printDataArray.push({
			content: config["pageFooter"],
			align: "center",
		});
	}
	var printData = {
		"printData": printDataArray
	};
	return printData;

};
//-----------采购80
var create80PrintData_Purchase = function(details, config, otherConfig) {
	var printDataArray = [];
	if(config["pageHead"]) {
		printDataArray.push({
			content: config["pageHead"],
			align: "center",
			fontSize: config["fontScale"] ? "middle" : "small"
		});
	}
	printDataArray.push({
		content: config["billName"],
		align: "center",
		fontSize: "middle"
	});
	printDataArray.push({
		type: "doubleLine"
	});
	printDataArray.push({
		content: details.customerName,
		fontSize: config["fontScale"] ? "middle" : "small"
	});
	//group48个char
	printDataArray.push({
		"type": "group",
		"data": [{
				"width": 24,
				"content": "单号：" + details.no,
				"maxChar": 24
			},
			{
				"content": "经手人：" + details.employeeName,
				"width": 24,
			}
		]
	});
	var groupData = {
		"type": "group",
		"data": [{
			"width": 24,
			"content": "日期：" + handleDate(details.businessDate), //使用预定义函数
		}]
	};
	if(config.showField.warehouseName && config.showField.warehouseName.value) {
		groupData.data.push({
			"width": 24,
			"content": config.showField.warehouseName.text + "：" + details[config.showField.warehouseName.field],
		});
	}
	printDataArray.push(groupData);

	printDataArray.push({
		type: "line"
	});

	//group
	printDataArray.push({
		"type": "group",
		"data": [{
				"width": 4,
				"content": "商品"
			},
			{
				"content": "数量",
				"width": 10,
				"align": "right"
			},
			{
				"content": "单位",
				"width": 6,
				"align": "right"
			},
			{
				"content": "单价",
				"width": 14,
				"align": "center"
			},
			{
				"content": "小计",
				"width": 14,
				"align": "right"
			}
		]
	});

	var totalQty = 0; //总数量
	var items = details.details;
	for(var i = 0; i < items.length; i++) {
		printDataArray.push({
			type: "line"
		});
		totalQty += items[i].qty;
		var showName = items[i].name;
		if(config.showField.barcode && config.showField.barcode.value) {
			var barcode = (items[i]["barcode"] ? "/" + items[i]["barcode"] : "");
			showName = "【" + items[i]["no"] + barcode + "】" + items[i].name;
		}
		if(config.showField.propertySpec && config.showField.propertySpec.value) {
			items[i].specification ? (showName += ("/" + items[i].specification)) : "";
			items[i].property ? (showName += ("/" + items[i].property)) : "";
		}
		printDataArray.push({
			"content": showName
		});
		//group
		printDataArray.push({
			type: "group",
			data: [{
					"content": items[i].qty, //15字符
					"width": 14,
					"align": "right"
				},
				{
					"content": items[i].unitName,
					"width": 6,
					"align": "right",
					"maxChar": 5
				},
				{
					"content": otherConfig.showCostPrice?Number(numberFormat(items[i].price, priceDigit, ".", "")):"***", //11字符,留一个空格字符
					"width": 14,
					"align": "center",
					"maxChar": 13
				},
				{
					"content": otherConfig.showCostPrice?items[i].total:"***",
					"width": 14,
					"align": "right",
					//"maxChar": 12//最后一个可以换行
				}
			]
		});
	}

	printDataArray.push({
		type: "doubleLine"
	});

	printDataArray.push({
		"type": "group",
		"data": [{
				"content": "合计",
				"width": 4,
				"align": "left"
			},
			{
				"content": Number(numberFormat(totalQty, qtyDigit, ".", "")), //8字符
				"align": "center",
				"width": 16
			},
			{
				"width": 28,
				"content": otherConfig.showCostPrice?details.total:"***",
				"align": "right",
			}
		]
	});
	var groupData2 = {
		"type": "group",
		"data": []
	};
	if(config.showField.discount && config.showField.discount.value) {
		var content = "";
		if(details.discountType == 1) {
			content = "折扣率：" + details.discountRate + "%";
		} else {
			content = "折扣额：" + details.discountTotal;
		}
		groupData2.data.push({
			"width": 24,
			"content": content
		});
	}
	if(config.showField.taxTotal && config.showField.taxTotal.value) {
		groupData2.data.push({
			"width": 24,
			"content": "折后税额：" + (otherConfig.showCostPrice?details.taxTotal:"***")
		});
	}
	if(groupData2.data.length > 0) {
		printDataArray.push(groupData2);
	}
	var groupData3 = {
		"type": "group",
		"data": []
	};
	if(config.showField.otherFee && config.showField.otherFee.value) {
		groupData3.data.push({
			"width": 24,
			"content": "其他费用：" + details.otherFee
		});
	}
	if(config.showField.accountName && config.showField.accountName.value) {
		groupData3.data.push({
			"width": 24,
			"content": "结算账户：" + (details.accountName ? details.accountName : "")
		});
	}
	if(groupData3.data.length > 0) {
		printDataArray.push(groupData3);
	}
	printDataArray.push({
		type: "line"
	});

	var groupData4 = {
		"type": "group",
		"data": [{
			"width": 24,
			"content": "总计金额：" + (otherConfig.showCostPrice?details.realTotal:"***")
		}]
	};
	//判断单据类型
	var typeArr = details["no"].split("-");
	if(typeArr.length > 0 && typeArr[0].toUpperCase() === "CG") {
		groupData4.data.push({
			"width": 24,
			"content": "实付金额：" + (details.postTotal ? details.postTotal : 0)
		});
	} else if(typeArr.length > 0 && typeArr[0].toUpperCase() === "CGT") {
		groupData4.data.push({
			"width": 24,
			"content": "实退金额：" + (details.postTotal ? details.postTotal : 0)
		});
	}

	printDataArray.push(groupData4);

	if(config.showField.memo && config.showField.memo.value) {
		printDataArray.push({
			"content": "备注：" + (details.memo?details.memo:"无")
		});
	}
	if(config.showField.inputeName && config.showField.inputeName.value) {
		printDataArray.push({
			"content": "制单人：" + details.inputeName
		});
	}
	//联系人信息
	if(config.showField["contactInfo"] && config.showField["contactInfo"].value) {
		printDataArray.push({
			"content": "联系人：" + details[config.showField["contactInfo"].field]
		});
	}
	printDataArray.push({
		"content": "打印日期：" + getNowFormatDate(true) //使用预置函数tools.js
	});
	if(config["pageFooter"]) {
		printDataArray.push({
			content: config["pageFooter"],
			align: "center",
		});
	}
	var printData = {
		"printData": printDataArray
	};
	return printData;

};
//-----------采购针式
var createPrickBasePrintData_Purchase = function(details, config, otherConfig) {
	var printDataArray = [];
	if(config["pageHead"]) {
		printDataArray.push({
			content: config["pageHead"],
			align: "center",
			fontSize: config["fontScale"] ? "middle" : "small"
		});
	}
	printDataArray.push({
		content: config["billName"],
		align: "center",
		fontSize: "middle"
	});

	var groupData = {
		type: "group",
		data: []
	};
	groupData.data.push({
		content: "往来单位：",
		align: "right",
		width: 10,
	});
	groupData.data.push({
		content: details.customerName,
		fontSize: config["fontScale"] ? "middle" : "small",
		width: 24,
	});
	groupData.data.push({
		content: "  经手人：",
		align: "right",
		width: 10
	});
	groupData.data.push({
		content: details.employeeName,
		width: 24
	});
	groupData.data.push({
		content: "业务日期：",
		align: "right",
		width: 10
	});
	groupData.data.push({
		content: handleDate(details.businessDate),
		width: 22
	});
	printDataArray.push(groupData);
	//一行就是一组
	groupData = {
		type: "group",
		data: []
	};
	groupData.data.push({
		content: "单号    ：",
		align: "right",
		width: 10
	});
	groupData.data.push({
		content: details.no,
		width: 24
	});

	if(config.showField.inputeName && config.showField.inputeName.value) { //选择了制单人
		groupData.data.push({
			content: "  制单人：",
			width: 10,
			align: "right",
		});
		groupData.data.push({
			content: details.inputeName,
			width: 24,
		});
		groupData.data.push({
			content: "制单日期：",
			width: 10,
			align: "right",
		});
		groupData.data.push({
			content: details.createDate,
			width: 22,
		});
		printDataArray.push(groupData);

		if(config.showField.warehouseName && config.showField.warehouseName.value) {
			//一行就是一组
			groupData = {
				type: "group",
				data: []
			};
			groupData.data.push({
				content: config.showField.warehouseName.text + "：",
				align: "right",
				width: 10
			});
			groupData.data.push({
				content: details[config.showField.warehouseName.field],
				width: 90
			});
			printDataArray.push(groupData);
		}
	} else { //未选择制单人
		if(config.showField.warehouseName && config.showField.warehouseName.value) { //选择仓库
			groupData.data.push({
				content: config.showField.warehouseName.text + "：",
				align: "right",
				width: 10
			});
			groupData.data.push({
				content: details[config.showField.warehouseName.field],
				width: 56
			});
		}
		printDataArray.push(groupData);
	}

	//table
	var typeTableData = {
		type: "table",
		columnWidthRatio: [6, 46, 12, 10, 12, 14], //总数小于100，并且每一项最好为偶数
		data: [
			[{
				content: "序号"
			}, {
				content: "商品名称"
			}, {
				content: "数量"
			}, {
				content: "单位"
			}, {
				content: "单价"
			}, {
				content: "小计"
			}]
		]
	};
	var mutableWidthRatio = [];
	var mutableTableData = [];
	if(config.showField.barcode && config.showField.barcode.value) {
		mutableWidthRatio.push(14);
		mutableTableData.push({
			content: "编号/条码"
		});
	}
	if(config.showField.serial && config.showField.serial.value) {
		mutableWidthRatio.push(12);
		mutableTableData.push({
			content: "序列号"
		});
	}
	if(mutableWidthRatio.length > 0 && mutableWidthRatio.length == mutableTableData.length) {
		var usedLength = 0;
		for(var p = 0; p < mutableWidthRatio.length; p++) {
			usedLength += mutableWidthRatio[p];
			typeTableData.columnWidthRatio.splice((2 + p), 0, mutableWidthRatio[p]);
			typeTableData.data[0].splice((2 + p), 0, mutableTableData[p]);
		}
		typeTableData.columnWidthRatio[1] = 46 - usedLength;
	}
	//商品备注
	if(config.showField.productMemo && config.showField.productMemo.value) {
		typeTableData.columnWidthRatio.push(10);
		typeTableData.data[0].push({
			content: "商品备注"
		});
		typeTableData.columnWidthRatio[1] -= 10;
	}
	//一单多仓库
	if(config.showField.warehouseName && config.showField.warehouseName.value && otherConfig && otherConfig["enableMultiWarehouse"]) {
		typeTableData.columnWidthRatio = typeTableData.columnWidthRatio.slice(0, 2).concat(10, typeTableData.columnWidthRatio.slice(2, typeTableData.columnWidthRatio.length));
		typeTableData.data[0] = typeTableData.data[0].slice(0, 2).concat({content: config.showField.warehouseName.text}, typeTableData.data[0].slice(2, typeTableData.data[0].length));
		typeTableData.columnWidthRatio[1] -= 10;
	}

	var items = details.details;
	for(var i = 0; i < items.length; i++) {
		var rowData = [];
		rowData.push({
			content: (i + 1) + ""
		}); //序号
		var showName = items[i].name;
		if(config.showField.propertySpec && config.showField.propertySpec.value) {
			items[i].specification ? (showName += ("/" + items[i].specification)) : "";
			items[i].property ? (showName += ("/" + items[i].property)) : "";
		}
		rowData.push({
			content: showName + ""
		}); //名称
		if(config.showField.barcode && config.showField.barcode.value) {
			//编号、条形码
			var showNoAndBarcode = "";
			showNoAndBarcode = items[i]["no"];
			showNoAndBarcode += (items[i]["barcode"] ? "/" + items[i]["barcode"] : "/-");
			rowData.push({
				content: showNoAndBarcode
			});
		}
		//序列号
		if(config.showField.serial && config.showField.serial.value) {
			var serialString = "";
			var snList = items[i][config.showField.serial.field];
			for(var o = 0; snList && o < snList.length; o++) {
				if(snList[o]["snNo"]) {
					serialString += snList[o]["snNo"] + ",";
				}
			}
			serialString.length > 0 ? serialString = serialString.substr(0, serialString.length - 1) : "";
			rowData.push({
				content: serialString
			});
		}
		//数量
		rowData.push({
			content: items[i].qty + ""
		});
		//单位
		rowData.push({
			content: items[i].unitName + ""
		});
		//单价
		rowData.push({
			content: otherConfig.showCostPrice?Number(numberFormat(items[i].price, priceDigit, ".", "")):"***"
		});
		//小计
		rowData.push({
			content: otherConfig.showCostPrice?items[i].total:"***"
		});
		//商品备注
		if(config.showField.productMemo && config.showField.productMemo.value) {
			rowData.push({
				content: items[i][config.showField.productMemo.field]
			});
		}
		//一单多仓库
		if(config.showField.warehouseName && config.showField.warehouseName.value && otherConfig && otherConfig["enableMultiWarehouse"]) {
			rowData = rowData.slice(0, 2).concat({
				content: items[i]["warehouseName"] ? items[i]["warehouseName"] : ""
			}, rowData.slice(2, rowData.length));
		}

		typeTableData.data.push(rowData);
	}
	var lastColData = [{
		content: "合计金额",
		numColumns: typeTableData.data[0].length - 1
	}];
	lastColData.push({
		content: otherConfig.showCostPrice?details.total:"***",
	});
	if(config.showField.productMemo && config.showField.productMemo.value) {
		lastColData[0]["numColumns"] = typeTableData.data[0].length - 2;
		lastColData.push({
			content: "",
		});
	}
	typeTableData.data.push(lastColData);
	printDataArray.push(typeTableData);

	var mutableContentArray = []; //可变内容
	if(config.showField.discount && config.showField.discount.value) {
		var contentType = "";
		var content = "";
		if(details.discountType == 1) {
			contentType = "折扣率  ：";
			content = details.discountRate + "%";
		} else {
			contentType = "折扣额  ：";
			content = details.discountTotal + "";
		}
		mutableContentArray.push({
			content: contentType,
			align: "right",
		});
		mutableContentArray.push({
			content: content,
		});
	}
	if(config.showField.taxTotal && config.showField.taxTotal.value) {
		mutableContentArray.push({
			content: "折后税额：",
			align: "right",
		});
		mutableContentArray.push({
			content: otherConfig.showCostPrice?details.taxTotal:"***",
		});
	}
	if(config.showField.otherFee && config.showField.otherFee.value) {
		mutableContentArray.push({
			align: "right",
			content: "其他费用：",
		});
		mutableContentArray.push({
			content: details.otherFee + "",
		});
	}
	if(config.showField.accountName && config.showField.accountName.value) {
		mutableContentArray.push({
			align: "right",
			content: "结算账户：",
		});
		mutableContentArray.push({
			content: (details.accountName ? details.accountName : ""),
		});
	}
	mutableContentArray.push({
		align: "right",
		content: "总计金额：",
	});
	mutableContentArray.push({
		content: otherConfig.showCostPrice?details.realTotal:"***",
	});
	//判断单据类型
	var typeArr = details["no"].split("-");
	var titleName = "";
	if(typeArr.length > 0 && typeArr[0].toUpperCase() === "CG") {
		titleName = "实付金额："
	} else if(typeArr.length > 0 && typeArr[0].toUpperCase() === "CGT") {
		titleName = "实退金额："
	}
	if(titleName != "") {
		mutableContentArray.push({
			align: "right",
			content: titleName,
		});
		mutableContentArray.push({
			content: (details.postTotal ? details.postTotal + "" : 0)
		});
	}
	//联系人信息
	if(config.showField["contactInfo"] && config.showField["contactInfo"].value) {
		mutableContentArray.push({
			align: "right",
			content: "联系人  ：",
		});
		mutableContentArray.push({
			content: details[config.showField["contactInfo"].field]
		});
	}
	if(config.showField.memo && config.showField.memo.value) {
		mutableContentArray.push({
			align: "right",
			content: "备注    ：",
		});
		mutableContentArray.push({
			content: details.memo?details.memo:"无"
		});
	}
	mutableContentArray.push({
		align: "right",
		content: "打印日期：",
	});
	mutableContentArray.push({
		content: getNowFormatDate(true) //使用预置函数tools.js
	});

	//一行就是一组
	groupData = {
		type: "group",
		data: []
	};
	//mutableContentArray必定是偶数个，6个为1行[10,24,10,24,10,22]
	var colWidthParams = [10, 24, 10, 24, 10, 22];
	for(var i = 0; i < mutableContentArray.length; i++) {
		mutableContentArray[i]["width"] = colWidthParams[i % colWidthParams.length];
		if(groupData.data.length >= colWidthParams.length) {
			printDataArray.push(groupData);
			groupData = {
				type: "group",
				data: []
			};
		}
		groupData.data.push(mutableContentArray[i]);
	}
	if(groupData.data.length > 0) {
		printDataArray.push(groupData);
	}

	if(config["pageFooter"]) {
		printDataArray.push({
			content: config["pageFooter"],
			align: "center",
		});
	}
	var printData = {
		"printData": printDataArray,
		"paperType": config["printSize"]["PrickBase"]["paperType"]
	};
	return printData;
};
//-----------采购订单58
var create58PrintData_PurchaseOrder = function(details, config, otherConfig) {
	otherConfig.showCostPrice = true;
	return create58PrintData_Purchase(details, config, otherConfig);
};
//-----------采购订单80
var create80PrintData_PurchaseOrder = function(details, config, otherConfig) {
	otherConfig.showCostPrice = true;
	return create80PrintData_Purchase(details, config, otherConfig);
};
//-----------采购订单针式
var createPrickBasePrintData_PurchaseOrder = function(details, config, otherConfig) {
	otherConfig["enableMultiWarehouse"] = false;
	otherConfig.showCostPrice = true;
	return createPrickBasePrintData_Purchase(details, config, otherConfig);
};
//-----------采购退货58
var create58PrintData_PurchaseReturn = function(details, config, otherConfig) {
	return create58PrintData_Purchase(details, config, otherConfig);
};
//-----------采购退货80
var create80PrintData_PurchaseReturn = function(details, config, otherConfig) {
	return create80PrintData_Purchase(details, config, otherConfig);
};
//-----------采购退货针式
var createPrickBasePrintData_PurchaseReturn = function(details, config, otherConfig) {
	return createPrickBasePrintData_Purchase(details, config, otherConfig);
};

//-----------库存盘点单
var create58PrintData_Stocktaking = function(details, config, otherConfig) {
	var printDataArray = [];
	if(config["pageHead"]) {
		printDataArray.push({
			content: config["pageHead"],
			align: "center",
			fontSize: config["fontScale"] ? "middle" : "small"
		});
	}
	printDataArray.push({
		content: config["billName"],
		align: "center",
		fontSize: "middle"
	});
	printDataArray.push({
		type: "doubleLine"
	});
	if(config.showField.warehouseName && config.showField.warehouseName.value) {
		printDataArray.push({
			content: config.showField.warehouseName.text + "：" + details[config.showField.warehouseName.field],
		});
	}

	printDataArray.push({
		content: "经手人：" + details.employeeName,
	});
	printDataArray.push({
		content: "单号：" + details.no,
	});
	printDataArray.push({
		content: "日期：" + handleDate(details.businessDate), //使用预定义函数
	});
	printDataArray.push({
		type: "line"
	});

	//group
	printDataArray.push({
		"type": "group",
		"data": [{
				"width": 4,
				"content": "商品"
			},
			{
				"content": "账面数量",
				"width": 12,
				"align": "center"
			},
			{
				"content": "实际数量",
				"width": 12,
				"align": "center"
			},
			{
				"content": "单位",
				"width": 4,
				"align": "right"
			}
		]
	});
	var items = details.details;
	var profitQty = 0;
	var lossesQty = 0;
	for(var i = 0; i < items.length; i++) {
		profitQty += items[i].profitQty;
		lossesQty += items[i].lossesQty;
		printDataArray.push({
			type: "line"
		});
		var showName = items[i].name;
		if(config.showField.barcode && config.showField.barcode.value) {
			var barcode = (items[i]["barcode"] ? "/" + items[i]["barcode"] : "");
			showName = "【" + items[i]["no"] + barcode + "】" + items[i].name;
		}
		if(config.showField.propertySpec && config.showField.propertySpec.value) {
			items[i].specification ? (showName += ("/" + items[i].specification)) : "";
			items[i].property ? (showName += ("/" + items[i].property)) : "";
		}
		printDataArray.push({
			"content": showName
		});
		//group
		printDataArray.push({
			type: "group",
			data: [{
					"content": items[i].realQty, //15字符
					"width": 16,
					"align": "center",
					"maxChar": 15
				},
				{
					"content": items[i].qty, //10字符,留一个空格字符
					"width": 12,
					"align": "center",
					"maxChar": 10
				},
				{
					"content": items[i].unitName,
					"width": 4,
					"align": "right"
				}
			]
		});
	}

	printDataArray.push({
		type: "doubleLine"
	});
	printDataArray.push({
		"content": "盘盈数量：" + Number(numberFormat(profitQty, 2, ".", ""))
	});
	printDataArray.push({
		"content": "盘盈金额：" + (otherConfig.showCostPrice?Number(numberFormat(details.profit, 2, ".", "")):"***")
	});
	printDataArray.push({
		"content": "盘亏数量：" + Number(numberFormat(lossesQty, 2, ".", ""))
	});
	printDataArray.push({
		"content": "盘亏金额：" + (otherConfig.showCostPrice?Number(numberFormat(details.losses, 2, ".", "")):"***")
	});
	printDataArray.push({
		type: "line"
	});

	if(config.showField.memo && config.showField.memo.value) {
		printDataArray.push({
			"content": "备注：" + (details.memo?details.memo:"无")
		});
	}
	if(config.showField.inputeName && config.showField.inputeName.value) {
		printDataArray.push({
			"content": "制单人：" + details.inputeName
		});
	}
	printDataArray.push({
		"content": "打印日期：" + getNowFormatDate(true) //使用预置函数tools.js
	});
	if(config["pageFooter"]) {
		printDataArray.push({
			content: config["pageFooter"],
			align: "center",
		});
	}
	var printData = {
		"printData": printDataArray
	};
	return printData;
};
var create80PrintData_Stocktaking = function(details, config, otherConfig) {
	var printDataArray = [];
	if(config["pageHead"]) {
		printDataArray.push({
			content: config["pageHead"],
			align: "center",
			fontSize: config["fontScale"] ? "middle" : "small"
		});
	}
	printDataArray.push({
		content: config["billName"],
		align: "center",
		fontSize: "middle"
	});
	printDataArray.push({
		type: "doubleLine"
	});
	//group48个char
	printDataArray.push({
		"type": "group",
		"data": [{
				"width": 24,
				"content": "单号：" + details.no,
				"maxChar": 24
			},
			{
				"content": "经手人：" + details.employeeName,
				"width": 24,
			}
		]
	});
	var groupData = {
		"type": "group",
		"data": [{
			"width": 24,
			"content": "日期：" + handleDate(details.businessDate), //使用预定义函数
		}]
	};
	if(config.showField.warehouseName && config.showField.warehouseName.value) {
		groupData.data.push({
			"width": 24,
			"content": config.showField.warehouseName.text + "：" + details[config.showField.warehouseName.field],
		});
	}
	printDataArray.push(groupData);

	printDataArray.push({
		type: "line"
	});

	//group
	printDataArray.push({
		"type": "group",
		"data": [{
				"width": 4,
				"content": "商品"
			},
			{
				"content": "账面数量",
				"width": 12,
				"align": "right"
			},
			{
				"content": "实际数量",
				"width": 14,
				"align": "center"
			},
			{
				"content": "单位",
				"width": 4,
				"align": "right"
			},
			{
				"content": "盘点结果",
				"width": 14,
				"align": "right"
			}
		]
	});
	var profitQty = 0;
	var lossesQty = 0;
	var items = details.details;
	for(var i = 0; i < items.length; i++) {
		profitQty += items[i].profitQty;
		lossesQty += items[i].lossesQty;
		printDataArray.push({
			type: "line"
		});
		var showName = items[i].name;
		if(config.showField.barcode && config.showField.barcode.value) {
			var barcode = (items[i]["barcode"] ? "/" + items[i]["barcode"] : "");
			showName = "【" + items[i]["no"] + barcode + "】" + items[i].name;
		}
		if(config.showField.propertySpec && config.showField.propertySpec.value) {
			items[i].specification ? (showName += ("/" + items[i].specification)) : "";
			items[i].property ? (showName += ("/" + items[i].property)) : "";
		}
		printDataArray.push({
			"content": showName
		});
		var stocktakingResult = "无盈亏";
		if(items[i].profitQty > 0) {
			stocktakingResult = "盘盈";
		} else if(items[i].lossesQty > 0) {
			stocktakingResult = "盘亏";
		}
		//group
		printDataArray.push({
			type: "group",
			data: [{
					"content": items[i].realQty, //15字符
					"width": 16,
					"align": "right",
					"maxChar": 15
				},
				{
					"content": items[i].qty, //11字符,留一个空格字符
					"width": 14,
					"align": "center",
					"maxChar": 12
				},
				{
					"content": items[i].unitName,
					"width": 4,
					"align": "center",
					"maxChar": 4
				},
				{
					"content": stocktakingResult,
					"width": 14,
					"align": "right",
					//"maxChar": 12//最后一个可以换行
				}
			]
		});
	}

	printDataArray.push({
		type: "doubleLine"
	});
	printDataArray.push({
		"type": "group",
		"data": [{
			"width": 24,
			"content": "盘盈数量：" + Number(numberFormat(profitQty, 2, ".", ""))
		}, {
			"width": 24,
			"content": "盘盈金额：" + (otherConfig.showCostPrice?Number(numberFormat(details.profit, 2, ".", "")):"***")
		}]
	});
	printDataArray.push({
		"type": "group",
		"data": [{
			"width": 24,
			"content": "盘亏数量：" + Number(numberFormat(lossesQty, 2, ".", ""))
		}, {
			"width": 24,
			"content": "盘亏金额：" + (otherConfig.showCostPrice?Number(numberFormat(details.losses, 2, ".", "")):"***")
		}]
	});
	printDataArray.push({
		type: "line"
	});
	if(config.showField.memo && config.showField.memo.value) {
		printDataArray.push({
			"content": "备注：" + (details.memo?details.memo:"无")
		});
	}
	if(config.showField.inputeName && config.showField.inputeName.value) {
		printDataArray.push({
			"content": "制单人：" + details.inputeName
		});
	}
	printDataArray.push({
		"content": "打印日期：" + getNowFormatDate(true) //使用预置函数tools.js
	});
	if(config["pageFooter"]) {
		printDataArray.push({
			content: config["pageFooter"],
			align: "center",
		});
	}
	var printData = {
		"printData": printDataArray
	};
	return printData;
}
var createPrickBasePrintData_Stocktaking = function(details, config, otherConfig) {
	var printDataArray = [];
	if(config["pageHead"]) {
		printDataArray.push({
			content: config["pageHead"],
			align: "center",
			fontSize: config["fontScale"] ? "middle" : "small"
		});
	}
	printDataArray.push({
		content: config["billName"],
		align: "center",
		fontSize: "middle"
	});
	var mutableContentArray = []; //可变内容
	if(config.showField.warehouseName && config.showField.warehouseName.value) {
		//一行就是一组
		mutableContentArray.push({
			content: config.showField.warehouseName.text + "：",
			align: "right",
		});
		mutableContentArray.push({
			content: details[config.showField.warehouseName.field] + "",
		});
	}
	mutableContentArray.push({
		content: "  经手人：",
		align: "right",
	});
	mutableContentArray.push({
		content: details.employeeName,
	});
	mutableContentArray.push({
		content: "盘点日期：",
		align: "right",
	});
	mutableContentArray.push({
		content: handleDate(details.businessDate),
	});

	//一行就是一组
	mutableContentArray.push({
		content: "单号    ：",
		align: "right",
	});
	mutableContentArray.push({
		content: details.no,
	});

	if(config.showField.inputeName && config.showField.inputeName.value) { //选择了制单人
		mutableContentArray.push({
			content: "  制单人：",
			align: "right",
		});
		mutableContentArray.push({
			content: details.inputeName,
		});
		mutableContentArray.push({
			content: "制单日期：",
			align: "right",
		});
		mutableContentArray.push({
			content: details.createDate,
		});
	}

	//一行就是一组
	var groupData = {
		type: "group",
		data: []
	};
	//mutableContentArray必定是偶数个，6个为1行[10,24,10,24,10,22]
	var colWidthParams = [10, 24, 10, 24, 10, 22];
	for(var i = 0; i < mutableContentArray.length; i++) {
		mutableContentArray[i]["width"] = colWidthParams[i % colWidthParams.length];
		if(groupData.data.length >= colWidthParams.length) {
			printDataArray.push(groupData);
			groupData = {
				type: "group",
				data: []
			};
		}
		groupData.data.push(mutableContentArray[i]);
	}
	if(groupData.data.length > 0) {
		printDataArray.push(groupData);
	}
	//table
	var typeTableData = {
		type: "table",
		columnWidthRatio: [6, 24, 10, 10, 10, 10, 10, 10, 10], //总数小于100，并且每一项最好为偶数
		data: [
			[{
				content: "序号"
			}, {
				content: "商品名称"
			}, {
				content: "单位"
			}, {
				content: "账面数量"
			}, {
				content: "实际数量"
			}, {
				content: "盘盈数量"
			}, {
				content: "盘盈金额"
			}, {
				content: "盘亏数量"
			}, {
				content: "盘亏金额"
			}]
		]
	};
	if(config.showField.barcode && config.showField.barcode.value) {
		typeTableData.columnWidthRatio.splice(2, 0, 12);
		typeTableData.data[0].splice(2, 0, {
			content: "编号/条码"
		});
		typeTableData.columnWidthRatio[1] = 12;
	}

	var profitQty = 0;
	var lossesQty = 0;
	var items = details.details;
	for(var i = 0; i < items.length; i++) {
		var rowData = [];
		rowData.push({
			content: (i + 1) + ""
		}); //序号
		profitQty += items[i].profitQty;
		lossesQty += items[i].lossesQty;
		var showName = items[i].name;
		if(config.showField.propertySpec && config.showField.propertySpec.value) {
			items[i].specification ? (showName += ("/" + items[i].specification)) : "";
			items[i].property ? (showName += ("/" + items[i].property)) : "";
		}
		rowData.push({ //名称
			content: showName
		});
		//编号
		if(config.showField.barcode && config.showField.barcode.value) {
			var showNoAndBarcode = "";
			showNoAndBarcode = items[i]["no"];
			showNoAndBarcode += (items[i]["barcode"] ? "/" + items[i]["barcode"] : "/-");
			rowData.push({
				content: showNoAndBarcode
			});
		}
		rowData.push({
			content: items[i].unitName
		});
		rowData.push({
			content: items[i].realQty+""
		});
		rowData.push({
			content: items[i].qty+""
		});
		rowData.push({
			content: items[i].profitQty+""
		});
		rowData.push({
			content: otherConfig.showCostPrice?numberFormat(items[i].profitAmount,2,".",""):"***"
		});
		rowData.push({
			content: items[i].lossesQty+""
		});
		rowData.push({
			content: otherConfig.showCostPrice?numberFormat(items[i].lossesAmount,2,".",""):"***"
		});
		typeTableData.data.push(rowData);
	}
	printDataArray.push(typeTableData);
	mutableContentArray = []; //可变内容
	mutableContentArray.push({
		content: "盘盈数量：",
		align: "right"
	});
	mutableContentArray.push({
		content: Number(numberFormat(profitQty, 2, ".", "")),
	});
	mutableContentArray.push({
		content: "盘盈金额：",
		align: "right"
	});
	mutableContentArray.push({
		content: otherConfig.showCostPrice?Number(numberFormat(details.profit, 2, ".", "")):"***",
	});
	mutableContentArray.push({
		content: "盘亏数量：",
		align: "right"
	});
	mutableContentArray.push({
		content: Number(numberFormat(lossesQty, 2, ".", "")),
	});
	mutableContentArray.push({
		content: "盘亏金额：",
		align: "right"
	});
	mutableContentArray.push({
		content: otherConfig.showCostPrice?Number(numberFormat(details.losses, 2, ".", "")):"***",
	});
	if(config.showField.memo && config.showField.memo.value) {
		mutableContentArray.push({
			content: "备注    ：",
			align: "right"
		});
		mutableContentArray.push({
			content: details.memo?details.memo:"无"
		});
	}
	mutableContentArray.push({
		content: "打印日期：",
		align: "right"
	});
	mutableContentArray.push({
		content: getNowFormatDate(true)
	});
	//处理group
	groupData = {
		type: "group",
		data: []
	};
	for(var i = 0; i < mutableContentArray.length; i++) {
		mutableContentArray[i]["width"] = colWidthParams[i % colWidthParams.length];
		if(groupData.data.length >= colWidthParams.length) {
			printDataArray.push(groupData);
			groupData = {
				type: "group",
				data: []
			};
		}
		groupData.data.push(mutableContentArray[i]);
	}
	if(groupData.data.length > 0) {
		printDataArray.push(groupData);
	}
	if(config["pageFooter"]) {
		printDataArray.push({
			content: config["pageFooter"],
			align: "center",
		});
	}
	var printData = {
		"printData": printDataArray,
		"paperType": config["printSize"]["PrickBase"]["paperType"]
	};
	return printData;
};
//-----------同价调拨单
var create58PrintData_StockTransfer = function(details, config, otherConfig) {
	var printDataArray = [];
	if(config["pageHead"]) {
		printDataArray.push({
			content: config["pageHead"],
			align: "center",
			fontSize: config["fontScale"] ? "middle" : "small"
		});
	}
	printDataArray.push({
		content: config["billName"],
		align: "center",
		fontSize: "middle"
	});
	printDataArray.push({
		type: "doubleLine"
	});
	printDataArray.push({
		content: "调出仓库：" + details.outWarehouseName,
	});
	printDataArray.push({
		content: "调入仓库：" + details.inWarehouseName,
	});

	printDataArray.push({
		content: "经手人：" + details.employeeName,
	});
	printDataArray.push({
		content: "单号：" + details.no,
	});
	printDataArray.push({
		content: "日期：" + handleDate(details.businessDate), //使用预定义函数
	});
	printDataArray.push({
		type: "line"
	});

	//group
	printDataArray.push({
		"type": "group",
		"data": [{
				"width": 4,
				"content": "商品"
			},
			{
				"content": "调拨数量",
				"width": 9,
				"align": "right"
			},
			{
				"content": "单位",
				"width": 6,
				"align": "right"
			},
			{
				"content": "调拨价格",
				"width": 13,
				"align": "right"
			}
		]
	});
	var items = details.details;
	var totalQty = 0; //总数量
	for(var i = 0; i < items.length; i++) {
		totalQty += items[i].qty;
		printDataArray.push({
			type: "line"
		});
		var showName = items[i].name;
		if(config.showField.barcode && config.showField.barcode.value) {
			var barcode = (items[i]["barcode"] ? "/" + items[i]["barcode"] : "");
			showName = "【" + items[i]["no"] + barcode + "】" + items[i].name;
		}
		if(config.showField.propertySpec && config.showField.propertySpec.value) {
			items[i].specification ? (showName += ("/" + items[i].specification)) : "";
			items[i].property ? (showName += ("/" + items[i].property)) : "";
		}
		printDataArray.push({
			"content": showName
		});
		//group
		printDataArray.push({
			type: "group",
			data: [{
					"content": items[i].qty, //15字符
					"width": 13,
					"align": "right",
					"maxChar": 12
				},
				{
					"content": items[i].unitName,
					"width": 6,
					"align": "right",
					"maxChar": 4
				},
				{
					"content": "同价", //10字符,留一个空格字符
					"width": 13,
					"align": "right"
				}
			]
		});
	}

	printDataArray.push({
		type: "doubleLine"
	});
	printDataArray.push({
		"type": "group",
		"data": [{
				"content": "合计",
				"width": 4
			},
			{
				"content": Number(numberFormat(totalQty, qtyDigit, ".", "")), //8字符
				"align": "center",
				"width": 15,
				"maxChar": 13
			},
			{
				"content": " ",
				"align": "right",
				"width": 13,
			}
		]
	});

	if(config.showField.accountName && config.showField.accountName.value) {
		printDataArray.push({
			"content": "结算账户：" + (details.accountName ? details.accountName : "")
		});
	}
	if(config.showField.otherFee && config.showField.otherFee.value) {
		printDataArray.push({
			"content": "其他费用：" + details.otherFee
		});
	}
	printDataArray.push({
		type: "line"
	});
	if(config.showField.inputeName && config.showField.inputeName.value) {
		printDataArray.push({
			"content": "制单人：" + details[config.showField.inputeName.field]
		});
	}
	if(config.showField.memo && config.showField.memo.value) {
		printDataArray.push({
			"content": "备注：" + (details.memo?details.memo:"无")
		});
	}
	printDataArray.push({
		"content": "打印日期：" + getNowFormatDate(true) //使用预置函数tools.js
	});
	if(config["pageFooter"]) {
		printDataArray.push({
			content: config["pageFooter"],
			align: "center",
		});
	}
	var printData = {
		"printData": printDataArray
	};
	return printData;

};
var create80PrintData_StockTransfer = function(details, config, otherConfig) {
	var printDataArray = [];
	if(config["pageHead"]) {
		printDataArray.push({
			content: config["pageHead"],
			align: "center",
			fontSize: config["fontScale"] ? "middle" : "small"
		});
	}
	printDataArray.push({
		content: config["billName"],
		align: "center",
		fontSize: "middle"
	});
	printDataArray.push({
		type: "doubleLine"
	});

	printDataArray.push({
		content: "经手人：" + details.employeeName,
	});
	printDataArray.push({
		"type": "group",
		"data": [{
				"width": 24,
				"content": "调出仓库：" + details.outWarehouseName,
			},
			{
				"width": 24,
				"content": "调入仓库：" + details.inWarehouseName,
			}
		]
	});
	printDataArray.push({
		"type": "group",
		"data": [{
				"width": 24,
				"content": "单号：" + details.no,
			},
			{
				"width": 24,
				"content": "日期：" + handleDate(details.businessDate), //使用预定义函数
			}
		]
	});
	printDataArray.push({
		type: "line"
	});
	//group
	printDataArray.push({
		"type": "group",
		"data": [{
				"width": 4,
				"content": "商品"
			},
			{
				"content": "调拨数量",
				"width": 17,
				"align": "right"
			},
			{
				"content": "单位",
				"width": 10,
				"align": "right"
			},
			{
				"content": "调拨价格",
				"width": 17,
				"align": "right"
			}
		]
	});
	var items = details.details;
	var totalQty = 0; //总数量
	for(var i = 0; i < items.length; i++) {
		totalQty += items[i].qty;
		printDataArray.push({
			type: "line"
		});
		var showName = items[i].name;
		if(config.showField.barcode && config.showField.barcode.value) {
			var barcode = (items[i]["barcode"] ? "/" + items[i]["barcode"] : "");
			showName = "【" + items[i]["no"] + barcode + "】" + items[i].name;
		}
		if(config.showField.propertySpec && config.showField.propertySpec.value) {
			items[i].specification ? (showName += ("/" + items[i].specification)) : "";
			items[i].property ? (showName += ("/" + items[i].property)) : "";
		}
		printDataArray.push({
			"content": showName
		});
		//group
		printDataArray.push({
			type: "group",
			data: [{
					"content": items[i].qty, //15字符
					"width": 21,
					"align": "right",
					"maxChar": 15
				},
				{
					"content": items[i].unitName,
					"width": 10,
					"align": "right"
				},
				{
					"content": "同价", //10字符,留一个空格字符
					"width": 17,
					"align": "right"
				}
			]
		});
	}

	printDataArray.push({
		type: "doubleLine"
	});
	printDataArray.push({
		"type": "group",
		"data": [{
				"content": "合计",
				"width": 4
			},
			{
				"content": Number(numberFormat(totalQty, qtyDigit, ".", "")), //8字符
				"align": "right",
				"width": 16,
			},
			{
				"content": " ",
				"align": "right",
				"width": 28,
			}
		]
	});
	var groupData2 = {
		"type": "group",
		"data": []
	}

	if(config.showField.otherFee && config.showField.otherFee.value) {
		groupData2.data.push({
			"width": 24,
			"content": "其他费用：" + details.otherFee
		});
	}
	if(config.showField.accountName && config.showField.accountName.value) {
		groupData2.data.push({
			"width": 24,
			"content": "结算账户：" + (details.accountName ? details.accountName : "")
		});
	}
	if(groupData2.data.length > 0) {
		printDataArray.push(groupData2);
	}
	printDataArray.push({
		type: "line"
	});
	if(config.showField.inputeName && config.showField.inputeName.value) {
		printDataArray.push({
			"content": "制单人：" + details[config.showField.inputeName.field]
		});
	}
	if(config.showField.memo && config.showField.memo.value) {
		printDataArray.push({
			"content": "备注：" + (details.memo?details.memo:"无")
		});
	}
	printDataArray.push({
		"content": "打印日期：" + getNowFormatDate(true) //使用预置函数tools.js
	});
	if(config["pageFooter"]) {
		printDataArray.push({
			content: config["pageFooter"],
			align: "center",
		});
	}
	var printData = {
		"printData": printDataArray
	};
	return printData;
}
var createPrickBasePrintData_StockTransfer = function(details, config, otherConfig) {
	var printDataArray = [];
	if(config["pageHead"]) {
		printDataArray.push({
			content: config["pageHead"],
			align: "center",
			fontSize: config["fontScale"] ? "middle" : "small"
		});
	}
	printDataArray.push({
		content: config["billName"],
		align: "center",
		fontSize: "middle"
	});
	var mutableContentArray = [];
	mutableContentArray.push({
		content: "调出仓库：",
		align: "right"
	});
	mutableContentArray.push({
		content: details.outWarehouseName,
	});
	mutableContentArray.push({
		content: "调入仓库：",
		align: "right"
	});
	mutableContentArray.push({
		content: details.inWarehouseName,
	});
	mutableContentArray.push({
		content: "",
		align: "right"
	});
	mutableContentArray.push({
		content: "",
	});
	mutableContentArray.push({
		content: "单号：",
		align: "right"
	});
	mutableContentArray.push({
		content: details.no,
	});
	mutableContentArray.push({
		content: "经手人：",
		align: "right"
	});
	mutableContentArray.push({
		content: details.employeeName,
	});
	mutableContentArray.push({
		content: "日期：", //使用预定义函数
		align: "right"
	});
	mutableContentArray.push({
		content: handleDate(details.businessDate), //使用预定义函数
	});

	//一行就是一组
	var groupData = {
		type: "group",
		data: []
	};
	//mutableContentArray必定是偶数个，6个为1行[10,24,10,24,10,22]
	var colWidthParams = [10, 24, 10, 24, 10, 22];
	for(var i = 0; i < mutableContentArray.length; i++) {
		mutableContentArray[i]["width"] = colWidthParams[i % colWidthParams.length];
		if(groupData.data.length >= colWidthParams.length) {
			printDataArray.push(groupData);
			groupData = {
				type: "group",
				data: []
			};
		}
		groupData.data.push(mutableContentArray[i]);
	}
	if(groupData.data.length > 0) {
		printDataArray.push(groupData);
	}

	//table
	var typeTableData = {
		type: "table",
		columnWidthRatio: [6, 60, 12, 10, 12], //总数小于100，并且每一项最好为偶数
		data: [
			[{
				content: "序号"
			}, {
				content: "商品名称"
			}, {
				content: "调拨数量"
			}, {
				content: "单位"
			}, {
				content: "调拨价格"
			}]
		]
	};
	var mutableWidthRatio = [];
	var mutableTableData = [];
	if(config.showField.barcode && config.showField.barcode.value) {
		mutableWidthRatio.push(14);
		mutableTableData.push({
			content: "编号"
		});
	}
	if(config.showField.serial && config.showField.serial.value) {
		mutableWidthRatio.push(12);
		mutableTableData.push({
			content: "序列号"
		});
	}
	if(mutableWidthRatio.length > 0 && mutableWidthRatio.length == mutableTableData.length) {
		var usedLength = 0;
		for(var p = 0; p < mutableWidthRatio.length; p++) {
			usedLength += mutableWidthRatio[p];
			typeTableData.columnWidthRatio.splice((2 + p), 0, mutableWidthRatio[p]);
			typeTableData.data[0].splice((2 + p), 0, mutableTableData[p]);
		}
		typeTableData.columnWidthRatio[1] = 60 - usedLength;
	}

	var items = details.details;
	var totalQty = 0; //总数量
	for(var i = 0; i < items.length; i++) {
		totalQty += items[i].qty;
		var rowData = [];
		rowData.push({
			content: (i + 1) + ""
		}); //序号
		var showName = items[i].name;
		if(config.showField.propertySpec && config.showField.propertySpec.value) {
			items[i].specification ? (showName += ("/" + items[i].specification)) : "";
			items[i].property ? (showName += ("/" + items[i].property)) : "";
		}
		rowData.push({
			"content": showName
		});
		if(config.showField.barcode && config.showField.barcode.value) {
			//编号、条形码
			var showNoAndBarcode = "";
			showNoAndBarcode = items[i]["no"];
			showNoAndBarcode += (items[i]["barcode"] ? "/" + items[i]["barcode"] : "");
			rowData.push({
				content: showNoAndBarcode
			});
		}
		//序列号
		if(config.showField.serial && config.showField.serial.value) {
			var serialString = "";
			var snList = items[i][config.showField.serial.field];
			for(var o = 0; snList && o < snList.length; o++) {
				if(snList[o]["snNo"]) {
					serialString += snList[o]["snNo"] + ",";
				}
			}
			serialString.length > 0 ? serialString = serialString.substr(0, serialString.length - 1) : "";
			rowData.push({
				content: serialString
			});
		}
		//数量
		rowData.push({
			content: items[i].qty + ""
		});
		//单位
		rowData.push({
			content: items[i].unitName + ""
		});
		//价格
		rowData.push({
			content: "同价调拨"
		});
		typeTableData.data.push(rowData);
	}

	typeTableData.data.push([{
		content: "合计调拨数量",
		numColumns: 2
	}, {
		content: totalQty,
		numColumns: typeTableData.data[0].length - 2
	}]);
	printDataArray.push(typeTableData);

	mutableContentArray = []; //可变内容
	if(config.showField.accountName && config.showField.accountName.value) {
		mutableContentArray.push({
			content: "结算账户：",
			align: "right"
		});
		mutableContentArray.push({
			content: (details.accountName ? details.accountName : "")
		});
	}
	if(config.showField.otherFee && config.showField.otherFee.value) {
		mutableContentArray.push({
			content: "其他费用：",
			align: "right"
		});
		mutableContentArray.push({
			content: details.otherFee
		});
	}
	if(config.showField.inputeName && config.showField.inputeName.value) {
		mutableContentArray.push({
			content: "制单人：",
			align: "right"
		});
		mutableContentArray.push({
			content: details[config.showField.inputeName.field]
		});
	}
	if(config.showField.memo && config.showField.memo.value) {
		mutableContentArray.push({
			content: "备注：",
			align: "right"
		});
		mutableContentArray.push({
			content: details.memo?details.memo:"无"
		});
	}
	mutableContentArray.push({
		content: "打印日期：",
		align: "right"
	});
	mutableContentArray.push({
		content: getNowFormatDate(true) //使用预置函数tools.js
	});
	//一行就是一组
	groupData = {
		type: "group",
		data: []
	};
	for(var i = 0; i < mutableContentArray.length; i++) {
		mutableContentArray[i]["width"] = colWidthParams[i % colWidthParams.length];
		if(groupData.data.length >= colWidthParams.length) {
			printDataArray.push(groupData);
			groupData = {
				type: "group",
				data: []
			};
		}
		groupData.data.push(mutableContentArray[i]);
	}
	if(groupData.data.length > 0) {
		printDataArray.push(groupData);
	}
	if(config["pageFooter"]) {
		printDataArray.push({
			content: config["pageFooter"],
			align: "center",
		});
	}
	var printData = {
		"printData": printDataArray,
		"paperType": config["printSize"]["PrickBase"]["paperType"]
	};
	return printData;
};
//-----------变价调拨单
var create58PrintData_StockTransferAdjust = function(details, config, otherConfig) {
	var printDataArray = [];
	if(config["pageHead"]) {
		printDataArray.push({
			content: config["pageHead"],
			align: "center",
			fontSize: config["fontScale"] ? "middle" : "small"
		});
	}
	printDataArray.push({
		content: config["billName"],
		align: "center",
		fontSize: "middle"
	});
	printDataArray.push({
		type: "doubleLine"
	});
	printDataArray.push({
		content: "调出仓库：" + details.outWarehouseName,
	});
	printDataArray.push({
		content: "调入仓库：" + details.inWarehouseName,
	});

	printDataArray.push({
		content: "经手人：" + details.employeeName,
	});
	printDataArray.push({
		content: "单号：" + details.no,
	});
	printDataArray.push({
		content: "日期：" + handleDate(details.businessDate), //使用预定义函数
	});
	printDataArray.push({
		type: "line"
	});

	//group
	printDataArray.push({
		"type": "group",
		"data": [{
				"width": 4,
				"content": "商品"
			},
			{
				"content": "调拨数量",
				"width": 9,
				"align": "right"
			},
			{
				"content": "单位",
				"width": 6,
				"align": "right"
			},
			{
				"content": "调拨价格",
				"width": 13,
				"align": "right"
			}
		]
	});
	var items = details.details;
	var totalQty = 0; //总数量
	var totalAmount = 0; //合计金额
	for(var i = 0; i < items.length; i++) {
		totalQty += items[i].qty;
		totalAmount += items[i].total;
		printDataArray.push({
			type: "line"
		});
		var showName = items[i].name;
		if(config.showField.barcode && config.showField.barcode.value) {
			var barcode = (items[i]["barcode"] ? "/" + items[i]["barcode"] : "");
			showName = "【" + items[i]["no"] + barcode + "】" + items[i].name;
		}
		if(config.showField.propertySpec && config.showField.propertySpec.value) {
			items[i].specification ? (showName += ("/" + items[i].specification)) : "";
			items[i].property ? (showName += ("/" + items[i].property)) : "";
		}
		printDataArray.push({
			"content": showName
		});
		//group
		printDataArray.push({
			type: "group",
			data: [{
					"content": items[i].qty, //15字符
					"width": 13,
					"align": "right",
					"maxChar": 12
				},
				{
					"content": items[i].unitName,
					"width": 6,
					"align": "right",
					"maxChar": 4
				},
				{
					"content": otherConfig.showCostPrice?items[i].price:"***", //10字符,留一个空格字符
					"width": 13,
					"align": "right"
				}
			]
		});
	}

	printDataArray.push({
		type: "doubleLine"
	});
	printDataArray.push({
		"type": "group",
		"data": [{
				"content": "合计",
				"width": 4
			},
			{
				"content": Number(numberFormat(totalQty, qtyDigit, ".", "")), //8字符
				"align": "center",
				"width": 15,
				"maxChar": 13
			},
			{
				"content": otherConfig.showCostPrice?Number(numberFormat(totalAmount, 2, ".", "")):"***",
				"align": "right",
				"width": 13,
			}
		]
	});

	if(config.showField.accountName && config.showField.accountName.value) {
		printDataArray.push({
			"content": "结算账户：" + (details.accountName ? details.accountName : "")
		});
	}
	if(config.showField.otherFee && config.showField.otherFee.value) {
		printDataArray.push({
			"content": "其他费用：" + details.otherFee
		});
	}
	printDataArray.push({
		type: "line"
	});
	if(config.showField.inputeName && config.showField.inputeName.value) {
		printDataArray.push({
			"content": "制单人：" + details[config.showField.inputeName.field]
		});
	}
	if(config.showField.memo && config.showField.memo.value) {
		printDataArray.push({
			"content": "备注：" + (details.memo?details.memo:"无")
		});
	}
	printDataArray.push({
		"content": "打印日期：" + getNowFormatDate(true) //使用预置函数tools.js
	});
	if(config["pageFooter"]) {
		printDataArray.push({
			content: config["pageFooter"],
			align: "center",
		});
	}
	var printData = {
		"printData": printDataArray
	};
	return printData;

};
var create80PrintData_StockTransferAdjust = function(details, config, otherConfig) {
	var printDataArray = [];
	if(config["pageHead"]) {
		printDataArray.push({
			content: config["pageHead"],
			align: "center",
			fontSize: config["fontScale"] ? "middle" : "small"
		});
	}
	printDataArray.push({
		content: config["billName"],
		align: "center",
		fontSize: "middle"
	});
	printDataArray.push({
		type: "doubleLine"
	});

	printDataArray.push({
		content: "经手人：" + details.employeeName,
	});
	printDataArray.push({
		"type": "group",
		"data": [{
				"width": 24,
				"content": "调出仓库：" + details.outWarehouseName,
			},
			{
				"width": 24,
				"content": "调入仓库：" + details.inWarehouseName,
			}
		]
	});
	printDataArray.push({
		"type": "group",
		"data": [{
				"width": 24,
				"content": "单号：" + details.no,
			},
			{
				"width": 24,
				"content": "日期：" + handleDate(details.businessDate), //使用预定义函数
			}
		]
	});
	printDataArray.push({
		type: "line"
	});
	//group
	printDataArray.push({
		"type": "group",
		"data": [{
				"width": 4,
				"content": "商品"
			},
			{
				"content": "调拨数量",
				"width": 17,
				"align": "right"
			},
			{
				"content": "单位",
				"width": 10,
				"align": "right"
			},
			{
				"content": "调拨价格",
				"width": 17,
				"align": "right"
			}
		]
	});
	var items = details.details;
	var totalQty = 0; //总数量
	var totalAmount = 0; //合计金额
	for(var i = 0; i < items.length; i++) {
		totalQty += items[i].qty;
		totalAmount += items[i].total;
		printDataArray.push({
			type: "line"
		});
		var showName = items[i].name;
		if(config.showField.barcode && config.showField.barcode.value) {
			var barcode = (items[i]["barcode"] ? "/" + items[i]["barcode"] : "");
			showName = "【" + items[i]["no"] + barcode + "】" + items[i].name;
		}
		if(config.showField.propertySpec && config.showField.propertySpec.value) {
			items[i].specification ? (showName += ("/" + items[i].specification)) : "";
			items[i].property ? (showName += ("/" + items[i].property)) : "";
		}
		printDataArray.push({
			"content": showName
		});
		//group
		printDataArray.push({
			type: "group",
			data: [{
					"content": items[i].qty, //15字符
					"width": 21,
					"align": "right",
					"maxChar": 15
				},
				{
					"content": items[i].unitName,
					"width": 10,
					"align": "right"
				},
				{
					"content": otherConfig.showCostPrice?items[i].price:"***", //10字符,留一个空格字符
					"width": 17,
					"align": "right"
				}
			]
		});
	}

	printDataArray.push({
		type: "doubleLine"
	});
	printDataArray.push({
		"type": "group",
		"data": [{
				"content": "合计",
				"width": 4
			},
			{
				"content": Number(numberFormat(totalQty, qtyDigit, ".", "")), //8字符
				"align": "right",
				"width": 16,
			},
			{
				"content": otherConfig.showCostPrice?Number(numberFormat(totalAmount, 2, ".", "")):"***",
				"align": "right",
				"width": 28,
			}
		]
	});
	var groupData2 = {
		"type": "group",
		"data": []
	}

	if(config.showField.otherFee && config.showField.otherFee.value) {
		groupData2.data.push({
			"width": 24,
			"content": "其他费用：" + details.otherFee
		});
	}
	if(config.showField.accountName && config.showField.accountName.value) {
		groupData2.data.push({
			"width": 24,
			"content": "结算账户：" + (details.accountName ? details.accountName : "")
		});
	}
	if(groupData2.data.length > 0) {
		printDataArray.push(groupData2);
	}
	printDataArray.push({
		type: "line"
	});
	if(config.showField.inputeName && config.showField.inputeName.value) {
		printDataArray.push({
			"content": "制单人：" + details[config.showField.inputeName.field]
		});
	}
	if(config.showField.memo && config.showField.memo.value) {
		printDataArray.push({
			"content": "备注：" + (details.memo?details.memo:"无")
		});
	}
	printDataArray.push({
		"content": "打印日期：" + getNowFormatDate(true) //使用预置函数tools.js
	});
	if(config["pageFooter"]) {
		printDataArray.push({
			content: config["pageFooter"],
			align: "center",
		});
	}
	var printData = {
		"printData": printDataArray
	};
	return printData;
}
var createPrickBasePrintData_StockTransferAdjust = function(details, config, otherConfig) {
	var printDataArray = [];
	if(config["pageHead"]) {
		printDataArray.push({
			content: config["pageHead"],
			align: "center",
			fontSize: config["fontScale"] ? "middle" : "small"
		});
	}
	printDataArray.push({
		content: config["billName"],
		align: "center",
		fontSize: "middle"
	});
	var mutableContentArray = [];
	mutableContentArray.push({
		content: "调出仓库：",
		align: "right"
	});
	mutableContentArray.push({
		content: details.outWarehouseName,
	});
	mutableContentArray.push({
		content: "调入仓库：",
		align: "right"
	});
	mutableContentArray.push({
		content: details.inWarehouseName,
	});
	mutableContentArray.push({
		content: "",
		align: "right"
	});
	mutableContentArray.push({
		content: "",
	});
	mutableContentArray.push({
		content: "单号：",
		align: "right"
	});
	mutableContentArray.push({
		content: details.no,
	});
	mutableContentArray.push({
		content: "经手人：",
		align: "right"
	});
	mutableContentArray.push({
		content: details.employeeName,
	});
	mutableContentArray.push({
		content: "日期：", //使用预定义函数
		align: "right"
	});
	mutableContentArray.push({
		content: handleDate(details.businessDate), //使用预定义函数
	});

	//一行就是一组
	var groupData = {
		type: "group",
		data: []
	};
	//mutableContentArray必定是偶数个，6个为1行[10,24,10,24,10,22]
	var colWidthParams = [10, 24, 10, 24, 10, 22];
	for(var i = 0; i < mutableContentArray.length; i++) {
		mutableContentArray[i]["width"] = colWidthParams[i % colWidthParams.length];
		if(groupData.data.length >= colWidthParams.length) {
			printDataArray.push(groupData);
			groupData = {
				type: "group",
				data: []
			};
		}
		groupData.data.push(mutableContentArray[i]);
	}
	if(groupData.data.length > 0) {
		printDataArray.push(groupData);
	}

	//table
	var typeTableData = {
		type: "table",
		columnWidthRatio: [6, 48, 10, 12, 12, 12], //总数小于100，并且每一项最好为偶数
		data: [
			[{
				content: "序号"
			}, {
				content: "商品名称"
			}, {
				content: "调拨数量"
			}, {
				content: "单位"
			}, {
				content: "调拨价格"
			}, {
				content: "小计"
			}]
		]
	};
	var mutableWidthRatio = [];
	var mutableTableData = [];
	if(config.showField.barcode && config.showField.barcode.value) {
		mutableWidthRatio.push(14);
		mutableTableData.push({
			content: "编号"
		});
	}
	if(config.showField.serial && config.showField.serial.value) {
		mutableWidthRatio.push(12);
		mutableTableData.push({
			content: "序列号"
		});
	}
	if(mutableWidthRatio.length > 0 && mutableWidthRatio.length == mutableTableData.length) {
		var usedLength = 0;
		for(var p = 0; p < mutableWidthRatio.length; p++) {
			usedLength += mutableWidthRatio[p];
			typeTableData.columnWidthRatio.splice((2 + p), 0, mutableWidthRatio[p]);
			typeTableData.data[0].splice((2 + p), 0, mutableTableData[p]);
		}
		typeTableData.columnWidthRatio[1] = 48 - usedLength;
	}

	var items = details.details;
	var totalQty = 0; //总数量
	var totalAmount = 0; //合计金额
	for(var i = 0; i < items.length; i++) {
		totalQty += items[i].qty;
		totalAmount += items[i].total;
		var rowData = [];
		rowData.push({
			content: (i + 1) + ""
		}); //序号
		var showName = items[i].name;
		if(config.showField.propertySpec && config.showField.propertySpec.value) {
			items[i].specification ? (showName += ("/" + items[i].specification)) : "";
			items[i].property ? (showName += ("/" + items[i].property)) : "";
		}
		rowData.push({
			"content": showName
		});
		if(config.showField.barcode && config.showField.barcode.value) {
			//编号、条形码
			var showNoAndBarcode = "";
			showNoAndBarcode = items[i]["no"];
			showNoAndBarcode += (items[i]["barcode"] ? "/" + items[i]["barcode"] : "");
			rowData.push({
				content: showNoAndBarcode
			});
		}
		//序列号
		if(config.showField.serial && config.showField.serial.value) {
			var serialString = "";
			var snList = items[i][config.showField.serial.field];
			for(var o = 0; snList && o < snList.length; o++) {
				if(snList[o]["snNo"]) {
					serialString += snList[o]["snNo"] + ",";
				}
			}
			serialString.length > 0 ? serialString = serialString.substr(0, serialString.length - 1) : "";
			rowData.push({
				content: serialString
			});
		}
		//数量
		rowData.push({
			content: items[i].qty + ""
		});
		//单位
		rowData.push({
			content: items[i].unitName + ""
		});
		//价格
		rowData.push({
			content: otherConfig.showCostPrice?items[i].price:"***"
		});
		//小计
		rowData.push({
			content: otherConfig.showCostPrice?items[i].total:"***"
		});
		typeTableData.data.push(rowData);
	}

	typeTableData.data.push([{
		content: "合计",
		numColumns: typeTableData.data[0].length - 3
	}, {
		content: totalQty,
		numColumns: 1
	}, {
		content: otherConfig.showCostPrice?totalAmount:"***",
		numColumns: 2
	}]);
	printDataArray.push(typeTableData);

	mutableContentArray = []; //可变内容
	if(config.showField.accountName && config.showField.accountName.value) {
		mutableContentArray.push({
			content: "结算账户：",
			align: "right"
		});
		mutableContentArray.push({
			content: (details.accountName ? details.accountName : "")
		});
	}
	if(config.showField.otherFee && config.showField.otherFee.value) {
		mutableContentArray.push({
			content: "其他费用：",
			align: "right"
		});
		mutableContentArray.push({
			content: details.otherFee
		});
	}
	if(config.showField.inputeName && config.showField.inputeName.value) {
		mutableContentArray.push({
			content: "制单人：",
			align: "right"
		});
		mutableContentArray.push({
			content: details[config.showField.inputeName.field]
		});
	}
	if(config.showField.memo && config.showField.memo.value) {
		mutableContentArray.push({
			content: "备注：",
			align: "right"
		});
		mutableContentArray.push({
			content: details.memo?details.memo:"无"
		});
	}
	mutableContentArray.push({
		content: "打印日期：",
		align: "right"
	});
	mutableContentArray.push({
		content: getNowFormatDate(true) //使用预置函数tools.js
	});
	//一行就是一组
	groupData = {
		type: "group",
		data: []
	};
	for(var i = 0; i < mutableContentArray.length; i++) {
		mutableContentArray[i]["width"] = colWidthParams[i % colWidthParams.length];
		if(groupData.data.length >= colWidthParams.length) {
			printDataArray.push(groupData);
			groupData = {
				type: "group",
				data: []
			};
		}
		groupData.data.push(mutableContentArray[i]);
	}
	if(groupData.data.length > 0) {
		printDataArray.push(groupData);
	}
	if(config["pageFooter"]) {
		printDataArray.push({
			content: config["pageFooter"],
			align: "center",
		});
	}
	var printData = {
		"printData": printDataArray,
		"paperType": config["printSize"]["PrickBase"]["paperType"]
	};
	return printData;
};

//-----------付款单
var create58PrintData_Payments = function(details, config, otherConfig) {
	var printDataArray = [];
	if(config["pageHead"]) {
		printDataArray.push({
			content: config["pageHead"],
			align: "center",
			fontSize: config["fontScale"] ? "middle" : "small"
		});
	}
	printDataArray.push({
		content: config["billName"],
		align: "center",
		fontSize: "middle"
	});
	printDataArray.push({
		type: "doubleLine"
	});
	var typeName = (details.type == 8 ? "付款" : "收款");
	printDataArray.push({
		content: typeName + "方：" + details.contactsName,
		fontSize: config["fontScale"] ? "middle" : "small"
	});

	printDataArray.push({
		content: "经手人：" + details.employeeName,
	});
	printDataArray.push({
		content: "单号：" + details.no,
	});
	printDataArray.push({
		content: (details.type == 8 ? "收款" : "付款") + "日期：" + handleDate(details.businessDate), //使用预定义函数
	});
	printDataArray.push({
		type: "line"
	});

	printDataArray.push({
		"content": (details.type == 8 ? "收款" : "付款") + "金额：" + details.amount
	});
	if(config.showField.accountName && config.showField.accountName.value) {
		printDataArray.push({
			"content": "结算账户：" + details[config.showField.accountName.field]
		});
	}
	if(config.showField.discountAmount && config.showField.discountAmount.value) {
		printDataArray.push({
			"content": "优惠：" + details[config.showField.discountAmount.field]
		});
	}
	if(config.showField.memo && config.showField.memo.value) {
		printDataArray.push({
			"content": "备注：" + (details.memo?details.memo:"无")
		});
	}
	if(config.showField.inputeName && config.showField.inputeName.value) {
		printDataArray.push({
			"content": "制单人：" + details[config.showField.inputeName.field]
		});
	}
	printDataArray.push({
		"content": "打印日期：" + getNowFormatDate(true) //使用预置函数tools.js
	});
	if(config["pageFooter"]) {
		printDataArray.push({
			content: config["pageFooter"],
			align: "center",
		});
	}
	var printData = {
		"printData": printDataArray
	};
	return printData;
};
var create80PrintData_Payments = function(details, config, otherConfig) {
	var printDataArray = [];
	if(config["pageHead"]) {
		printDataArray.push({
			content: config["pageHead"],
			align: "center",
			fontSize: config["fontScale"] ? "middle" : "small"
		});
	}
	printDataArray.push({
		content: config["billName"],
		align: "center",
		fontSize: "middle"
	});
	printDataArray.push({
		type: "doubleLine"
	});
	var typeName = (details.type == 8 ? "付款" : "收款");
	printDataArray.push({
		content: typeName + "方：" + details.contactsName,
		fontSize: config["fontScale"] ? "middle" : "small"
	});
	printDataArray.push({
		content: "经手人：" + details.employeeName,
	});
	printDataArray.push({
		"type": "group",
		"data": [{
			"width": 24,
			"content": "单号：" + details.no,
		}, {
			"width": 24,
			"content": (details.type == 8 ? "收款" : "付款") + "日期：" + handleDate(details.businessDate), //使用预定义函数
		}]
	});
	printDataArray.push({
		type: "line"
	});
	var groupData = {
		"type": "group",
		"data": [{
			"width": 24,
			"content": (details.type == 8 ? "收款" : "付款") + "金额：" + details.amount
		}]
	};
	if(config.showField.discountAmount && config.showField.discountAmount.value) {
		groupData.data.push({
			"width": 24,
			"content": "优惠：" + details[config.showField.discountAmount.field]
		});
	}
	printDataArray.push(groupData);
	if(config.showField.accountName && config.showField.accountName.value) {
		printDataArray.push({
			"content": "结算账户：" + details[config.showField.accountName.field]
		});
	}
	if(config.showField.inputeName && config.showField.inputeName.value) {
		printDataArray.push({
			"content": "制单人：" + details[config.showField.inputeName.field]
		});
	}
	if(config.showField.memo && config.showField.memo.value) {
		printDataArray.push({
			"content": "备注：" + (details.memo?details.memo:"无")
		});
	}
	printDataArray.push({
		"content": "打印日期：" + getNowFormatDate(true) //使用预置函数tools.js
	});
	if(config["pageFooter"]) {
		printDataArray.push({
			content: config["pageFooter"],
			align: "center",
		});
	}
	var printData = {
		"printData": printDataArray
	};
	return printData;
};
var createPrickBasePrintData_Payments = function(details, config, otherConfig) {
	var printDataArray = [];
	if(config["pageHead"]) {
		printDataArray.push({
			content: config["pageHead"],
			align: "center",
			fontSize: config["fontScale"] ? "middle" : "small"
		});
	}
	printDataArray.push({
		content: config["billName"],
		align: "center",
		fontSize: "middle"
	});
	var typeName = (details.type == 8 ? "付款" : "收款");
	//一行就是一组
	var mutableContentArray = [];
	mutableContentArray.push({
		content: "单号    ：",
		align: "right"
	});
	mutableContentArray.push({
		content: details.no,
	});
	mutableContentArray.push({
		content: typeName + "方：",
		align: "right"
	});
	mutableContentArray.push({
		content: details.contactsName,
		fontSize: config["fontScale"] ? "middle" : "small"
	});
	mutableContentArray.push({
		content: (details.type == 8 ? "收款" : "付款") + "日期：", //使用预定义函数
		align: "right"
	});
	mutableContentArray.push({
		content: handleDate(details.businessDate), //使用预定义函数
	});
	//一行就是一组
	var groupData = {
		type: "group",
		data: []
	};
	//mutableContentArray必定是偶数个，6个为1行[10,24,10,24,10,22]
	var colWidthParams = [10, 24, 10, 24, 10, 22];
	for(var i = 0; i < mutableContentArray.length; i++) {
		mutableContentArray[i]["width"] = colWidthParams[i % colWidthParams.length];
		if(groupData.data.length >= colWidthParams.length) {
			printDataArray.push(groupData);
			groupData = {
				type: "group",
				data: []
			};
		}
		groupData.data.push(mutableContentArray[i]);
	}
	if(groupData.data.length > 0) {
		printDataArray.push(groupData);
	}
	var typeTableData = {
		type: "table",
		columnWidthRatio: [20, 30, 20, 30], //总数小于100，并且每一项最好为偶数
		data: [
			[{
				content: (details.type == 8 ? "收款" : "付款") + "金额"
			}, {
				content: details.amount
			}, {
				content: "经手人"
			}, {
				content: details.employeeName
			}]
		]
	};

	if(config.showField.accountName && config.showField.accountName.value) {
		typeTableData.data.push([{
			content: "结算账户",
			numColumns: 2
		}, {
			content: details[config.showField.accountName.field],
			numColumns: 2
		}]);
	}
	if(config.showField.discountAmount && config.showField.discountAmount.value) {
		typeTableData.data.push([{
			content: "优惠",
			numColumns: 2
		}, {
			content: details[config.showField.discountAmount.field],
			numColumns: 2
		}]);
	}
	if(config.showField.memo && config.showField.memo.value) {
		typeTableData.data.push([{
			content: "备注",
			numColumns: 2
		}, {
			content: details.memo?details.memo:"无",
			numColumns: 2
		}]);
	}
	printDataArray.push(typeTableData);
	mutableContentArray = [];
	if(config.showField.inputeName && config.showField.inputeName.value) {
		mutableContentArray.push({
			content: "制单人  ：",
			align: "right"
		});
		mutableContentArray.push({
			content: details[config.showField.inputeName.field]
		});
		mutableContentArray.push({
			content: "制单日期：",
			align: "right"
		});
		mutableContentArray.push({
			content: details.createDate
		});
	}
	mutableContentArray.push({
		content: "打印日期："
	});
	mutableContentArray.push({
		content: getNowFormatDate(true) //使用预置函数tools.js
	});

	//一行就是一组
	var groupData = {
		type: "group",
		data: []
	};
	//mutableContentArray必定是偶数个，6个为1行[10,24,10,24,10,22]
	for(var i = 0; i < mutableContentArray.length; i++) {
		mutableContentArray[i]["width"] = colWidthParams[i % colWidthParams.length];
		if(groupData.data.length >= colWidthParams.length) {
			printDataArray.push(groupData);
			groupData = {
				type: "group",
				data: []
			};
		}
		groupData.data.push(mutableContentArray[i]);
	}
	if(groupData.data.length > 0) {
		printDataArray.push(groupData);
	}
	if(config["pageFooter"]) {
		printDataArray.push({
			content: config["pageFooter"],
			align: "center",
		});
	}
	var printData = {
		"printData": printDataArray,
		"paperType": config["printSize"]["PrickBase"]["paperType"]
	};
	return printData;
};
//-----------收款单
var create58PrintData_Receipt = function(details, config, otherConfig) {
	return create58PrintData_Payments(details, config, otherConfig);
}
var create80PrintData_Receipt = function(details, config, otherConfig) {
	return create80PrintData_Payments(details, config, otherConfig);
}
var createPrickBasePrintData_Receipt = function(details, config, otherConfig) {
	return createPrickBasePrintData_Payments(details, config, otherConfig);
};

//-----------其他出入库单58
var create58PrintData_StockOther = function(details, config, otherConfig) {
	var printDataArray = [];
	if(config["pageHead"]) {
		printDataArray.push({
			content: config["pageHead"],
			align: "center",
			fontSize: config["fontScale"] ? "middle" : "small"
		});
	}
	printDataArray.push({
		content: config["billName"],
		align: "center",
		fontSize: "middle"
	});
	printDataArray.push({
		type: "doubleLine"
	});
	printDataArray.push({
		content: details.contactName ? details.contactName : '-',
		fontSize: config["fontScale"] ? "middle" : "small"
	});
	if(config.showField.warehouseName && config.showField.warehouseName.value) {
		printDataArray.push({
			content: config.showField.warehouseName.text + "：" + details[config.showField.warehouseName.field],
		});
	}

	printDataArray.push({
		content: "经手人：" + details.employeeName,
	});
	printDataArray.push({
		content: "单号：" + details.no,
	});
	printDataArray.push({
		content: "日期：" + handleDate(details.businessDate), //使用预定义函数
	});
	printDataArray.push({
		type: "line"
	});

	//group
	printDataArray.push({
		"type": "group",
		"data": [{
				"width": 4,
				"content": "商品"
			},
			{
				"content": "数量",
				"width": 9,
				"align": "right"
			},
			{
				"content": "单位",
				"width": 6,
				"align": "right"
			},
			{
				"content": "单价",
				"width": 13,
				"align": "right"
			}
		]
	});

	var totalQty = 0; //总数量
	var items = details.details;
	for(var i = 0; i < items.length; i++) {
		printDataArray.push({
			type: "line"
		});
		totalQty += items[i].qty;
		var showName = items[i].name;
		if(config.showField.barcode && config.showField.barcode.value) {
			var barcode = (items[i]["barcode"] ? "/" + items[i]["barcode"] : "");
			showName = "【" + items[i]["no"] + barcode + "】" + items[i].name;
		}
		if(config.showField.propertySpec && config.showField.propertySpec.value) {
			items[i].specification ? (showName += ("/" + items[i].specification)) : "";
			items[i].property ? (showName += ("/" + items[i].property)) : "";
		}
		printDataArray.push({
			"content": showName
		});
		//group
		printDataArray.push({
			type: "group",
			data: [{
					"content": items[i].qty, //15字符
					"width": 13,
					"align": "right",
					"maxChar": 12
				},
				{
					"content": items[i].unitName,
					"width": 6,
					"align": "right",
					"maxChar": 4
				},
				{
					"content": otherConfig.showCostPrice ? Number(numberFormat(items[i].price, priceDigit, ".", "")) : "***", //10字符,留一个空格字符,
					"width": 13,
					"align": "right"
				}
			]
		});
		printDataArray.push({
			"type": "group",
			"data": [{
					"content": "小计金额",
					"width": 8
				},
				{
					"content": otherConfig.showCostPrice ? items[i].total : "***", //8字符
					"width": 24,
					"align": "right"
				}
			]
		});
	}

	printDataArray.push({
		type: "doubleLine"
	});

	printDataArray.push({
		"type": "group",
		"data": [{
				"content": "合计",
				"width": 4
			},
			{
				"content": Number(numberFormat(totalQty, qtyDigit, ".", "")), //8字符
				"align": "center",
				"width": 15,
				"maxChar": 13
			},
			{
				"content": otherConfig.showCostPrice ? details.total : "***",
				"align": "right",
				"width": 13
			}
		]
	});
	
	printDataArray.push({
		type: "line"
	});
	printDataArray.push({
		"content": "总计金额：" + (otherConfig.showCostPrice ? details.total : "***")
	});
	
	if(config.showField.memo && config.showField.memo.value) {
		printDataArray.push({
			"content": "备注：" + (details.memo ? details.memo : "无")
		});
	}
	if(config.showField.inputeName && config.showField.inputeName.value) {
		printDataArray.push({
			"content": "制单人：" + details.inputeName
		});
	}
	//联系人信息
	if(config.showField["contactInfo"] && config.showField["contactInfo"].value) {
		printDataArray.push({
			"content": "联系人：" + details[config.showField["contactInfo"].field]
		});
	}
	printDataArray.push({
		"content": "打印日期：" + getNowFormatDate(true) //使用预置函数tools.js
	});
	if(config["pageFooter"]) {
		printDataArray.push({
			content: config["pageFooter"],
			align: "center",
		});
	}
	var printData = {
		"printData": printDataArray
	};
	return printData;
};

//-----------其他出入库单80
var create80PrintData_StockOther = function(details, config, otherConfig) {
	var printDataArray = [];
	if(config["pageHead"]) {
		printDataArray.push({
			content: config["pageHead"],
			align: "center",
			fontSize: config["fontScale"] ? "middle" : "small"
		});
	}
	printDataArray.push({
		content: config["billName"],
		align: "center",
		fontSize: "middle"
	});
	printDataArray.push({
		type: "doubleLine"
	});
	printDataArray.push({
		content: details.contactName ? details.contactName : '-',
		fontSize: config["fontScale"] ? "middle" : "small"
	});
	//group48个char
	printDataArray.push({
		"type": "group",
		"data": [{
				"width": 24,
				"content": "单号：" + details.no,
				"maxChar": 24
			},
			{
				"content": "经手人：" + details.employeeName,
				"width": 24,
			}
		]
	});
	var groupData = {
		"type": "group",
		"data": [{
			"width": 24,
			"content": "日期：" + handleDate(details.businessDate), //使用预定义函数
		}]
	};
	if(config.showField.warehouseName && config.showField.warehouseName.value) {
		groupData.data.push({
			"width": 24,
			"content": config.showField.warehouseName.text + "：" + details[config.showField.warehouseName.field],
		});
	}
	printDataArray.push(groupData);

	printDataArray.push({
		type: "line"
	});

	//group
	printDataArray.push({
		"type": "group",
		"data": [{
				"width": 4,
				"content": "商品"
			},
			{
				"content": "数量",
				"width": 10,
				"align": "right"
			},
			{
				"content": "单位",
				"width": 6,
				"align": "right"
			},
			{
				"content": "单价",
				"width": 14,
				"align": "center"
			},
			{
				"content": "小计",
				"width": 14,
				"align": "right"
			}
		]
	});

	var totalQty = 0; //总数量
	var items = details.details;
	for(var i = 0; i < items.length; i++) {
		printDataArray.push({
			type: "line"
		});
		totalQty += items[i].qty;
		var showName = items[i].name;
		if(config.showField.barcode && config.showField.barcode.value) {
			var barcode = (items[i]["barcode"] ? "/" + items[i]["barcode"] : "");
			showName = "【" + items[i]["no"] + barcode + "】" + items[i].name;
		}
		if(config.showField.propertySpec && config.showField.propertySpec.value) {
			items[i].specification ? (showName += ("/" + items[i].specification)) : "";
			items[i].property ? (showName += ("/" + items[i].property)) : "";
		}
		printDataArray.push({
			"content": showName
		});
		//group
		printDataArray.push({
			type: "group",
			data: [{
					"content": items[i].qty, //15字符
					"width": 14,
					"align": "right"
				},
				{
					"content": items[i].unitName,
					"width": 6,
					"align": "right",
					"maxChar": 5
				},
				{
					"content": otherConfig.showCostPrice ? Number(numberFormat(items[i].price, priceDigit, ".", "")) : "***", //11字符,留一个空格字符
					"width": 14,
					"align": "center",
					"maxChar": 13
				},
				{
					"content": otherConfig.showCostPrice ? items[i].total : "***",
					"width": 14,
					"align": "right",
					//"maxChar": 12//最后一个可以换行
				}
			]
		});
	}

	printDataArray.push({
		type: "doubleLine"
	});

	printDataArray.push({
		"type": "group",
		"data": [{
				"content": "合计",
				"width": 4,
				"align": "left"
			},
			{
				"content": Number(numberFormat(totalQty, qtyDigit, ".", "")), //8字符
				"align": "center",
				"width": 16
			},
			{
				"width": 28,
				"content": otherConfig.showCostPrice ? details.total : "***",
				"align": "right",
			}
		]
	});

	printDataArray.push({
		type: "line"
	});

	var groupData4 = {
		"type": "group",
		"data": [{
			"width": 24,
			"content": "总计金额：" + (otherConfig.showCostPrice ? details.total : "***")
		}]
	};

	printDataArray.push(groupData4);

	if(config.showField.memo && config.showField.memo.value) {
		printDataArray.push({
			"content": "备注：" + (details.memo ? details.memo : "无")
		});
	}
	if(config.showField.inputeName && config.showField.inputeName.value) {
		printDataArray.push({
			"content": "制单人：" + details.inputeName
		});
	}
	//联系人信息
	if(config.showField["contactInfo"] && config.showField["contactInfo"].value) {
		printDataArray.push({
			"content": "联系人：" + details[config.showField["contactInfo"].field]
		});
	}
	printDataArray.push({
		"content": "打印日期：" + getNowFormatDate(true) //使用预置函数tools.js
	});
	if(config["pageFooter"]) {
		printDataArray.push({
			content: config["pageFooter"],
			align: "center",
		});
	}
	var printData = {
		"printData": printDataArray
	};
	return printData;
};

//-----------其他出入库单针式
var createPrickBasePrintData_StockOther = function(details, config, otherConfig) {
	var printDataArray = [];
	if(config["pageHead"]) {
		printDataArray.push({
			content: config["pageHead"],
			align: "center",
			fontSize: config["fontScale"] ? "middle" : "small"
		});
	}
	printDataArray.push({
		content: config["billName"],
		align: "center",
		fontSize: "middle"
	});

	var groupData = {
		type: "group",
		data: []
	};
	groupData.data.push({
		content: "往来单位：",
		align: "right",
		width: 10,
	});
	groupData.data.push({
		content: details.contactName ? details.contactName : '-',
		fontSize: config["fontScale"] ? "middle" : "small",
		width: 24,
	});
	groupData.data.push({
		content: "  经手人：",
		align: "right",
		width: 10
	});
	groupData.data.push({
		content: details.employeeName,
		width: 24
	});
	groupData.data.push({
		content: "业务日期：",
		align: "right",
		width: 10
	});
	groupData.data.push({
		content: handleDate(details.businessDate),
		width: 22
	});
	printDataArray.push(groupData);
	//一行就是一组
	groupData = {
		type: "group",
		data: []
	};
	groupData.data.push({
		content: "单号    ：",
		align: "right",
		width: 10
	});
	groupData.data.push({
		content: details.no,
		width: 24
	});

	if(config.showField.inputeName && config.showField.inputeName.value) { //选择了制单人
		groupData.data.push({
			content: "  制单人：",
			width: 10,
			align: "right",
		});
		groupData.data.push({
			content: details.inputeName,
			width: 24,
		});
		groupData.data.push({
			content: "制单日期：",
			width: 10,
			align: "right",
		});
		groupData.data.push({
			content: details.createDate,
			width: 22,
		});
		printDataArray.push(groupData);

		if(config.showField.warehouseName && config.showField.warehouseName.value) {
			//一行就是一组
			groupData = {
				type: "group",
				data: []
			};
			groupData.data.push({
				content: config.showField.warehouseName.text + "：",
				align: "right",
				width: 10
			});
			groupData.data.push({
				content: details[config.showField.warehouseName.field],
				width: 90
			});
			printDataArray.push(groupData);
		}
	} else { //未选择制单人
		if(config.showField.warehouseName && config.showField.warehouseName.value) { //选择仓库
			groupData.data.push({
				content: config.showField.warehouseName.text + "：",
				align: "right",
				width: 10
			});
			groupData.data.push({
				content: details[config.showField.warehouseName.field],
				width: 56
			});
		}
		printDataArray.push(groupData);
	}

	//table
	var typeTableData = {
		type: "table",
		columnWidthRatio: [6, 46, 12, 10, 12, 14], //总数小于100，并且每一项最好为偶数
		data: [
			[{
				content: "序号"
			}, {
				content: "商品名称"
			}, {
				content: "数量"
			}, {
				content: "单位"
			}, {
				content: "单价"
			}, {
				content: "小计"
			}]
		]
	};
	var mutableWidthRatio = [];
	var mutableTableData = [];
	if(config.showField.barcode && config.showField.barcode.value) {
		mutableWidthRatio.push(14);
		mutableTableData.push({
			content: "编号/条码"
		});
	}
	if(config.showField.serial && config.showField.serial.value) {
		mutableWidthRatio.push(12);
		mutableTableData.push({
			content: "序列号"
		});
	}
	if(mutableWidthRatio.length > 0 && mutableWidthRatio.length == mutableTableData.length) {
		var usedLength = 0;
		for(var p = 0; p < mutableWidthRatio.length; p++) {
			usedLength += mutableWidthRatio[p];
			typeTableData.columnWidthRatio.splice((2 + p), 0, mutableWidthRatio[p]);
			typeTableData.data[0].splice((2 + p), 0, mutableTableData[p]);
		}
		typeTableData.columnWidthRatio[1] = 46 - usedLength;
	}
	//商品备注
	if(config.showField.productMemo && config.showField.productMemo.value) {
		typeTableData.columnWidthRatio.push(10);
		typeTableData.data[0].push({
			content: "商品备注"
		});
		typeTableData.columnWidthRatio[1] -= 10;
	}

	var items = details.details;
	for(var i = 0; i < items.length; i++) {
		var rowData = [];
		rowData.push({
			content: (i + 1) + ""
		}); //序号
		var showName = items[i].name;
		if(config.showField.propertySpec && config.showField.propertySpec.value) {
			items[i].specification ? (showName += ("/" + items[i].specification)) : "";
			items[i].property ? (showName += ("/" + items[i].property)) : "";
		}
		rowData.push({
			content: showName + ""
		}); //名称
		if(config.showField.barcode && config.showField.barcode.value) {
			//编号、条形码
			var showNoAndBarcode = "";
			showNoAndBarcode = items[i]["no"];
			showNoAndBarcode += (items[i]["barcode"] ? "/" + items[i]["barcode"] : "/-");
			rowData.push({
				content: showNoAndBarcode
			});
		}
		//序列号
		if(config.showField.serial && config.showField.serial.value) {
			var serialString = "";
			var snList = items[i][config.showField.serial.field];
			for(var o = 0; snList && o < snList.length; o++) {
				if(snList[o]["snNo"]) {
					serialString += snList[o]["snNo"] + ",";
				}
			}
			serialString.length > 0 ? serialString = serialString.substr(0, serialString.length - 1) : "";
			rowData.push({
				content: serialString
			});
		}
		//数量
		rowData.push({
			content: items[i].qty + ""
		});
		//单位
		rowData.push({
			content: items[i].unitName + ""
		});
		//单价
		rowData.push({
			content: otherConfig.showCostPrice ? Number(numberFormat(items[i].price, priceDigit, ".", "")) : "***"
		});
		//小计
		rowData.push({
			content: otherConfig.showCostPrice ? items[i].total : "***"
		});
		//商品备注
		if(config.showField.productMemo && config.showField.productMemo.value) {
			rowData.push({
				content: items[i][config.showField.productMemo.field]
			});
		}

		typeTableData.data.push(rowData);
	}
	var lastColData = [{
		content: "合计金额",
		numColumns: typeTableData.data[0].length - 1
	}];
	lastColData.push({
		content: otherConfig.showCostPrice ? details.total : "***",
	});
	if(config.showField.productMemo && config.showField.productMemo.value) {
		lastColData[0]["numColumns"] = typeTableData.data[0].length - 2;
		lastColData.push({
			content: "",
		});
	}
	typeTableData.data.push(lastColData);
	printDataArray.push(typeTableData);

	var mutableContentArray = []; //可变内容
	
	mutableContentArray.push({
		align: "right",
		content: "总计金额：",
	});
	mutableContentArray.push({
		content: otherConfig.showCostPrice ? details.total : "***",
	});
	//联系人信息
	if(config.showField["contactInfo"] && config.showField["contactInfo"].value) {
		mutableContentArray.push({
			align: "right",
			content: "联系人  ：",
		});
		mutableContentArray.push({
			content: details[config.showField["contactInfo"].field]
		});
	}
	if(config.showField.memo && config.showField.memo.value) {
		mutableContentArray.push({
			align: "right",
			content: "备注    ：",
		});
		mutableContentArray.push({
			content: details.memo ? details.memo : "无"
		});
	}
	mutableContentArray.push({
		align: "right",
		content: "打印日期：",
	});
	mutableContentArray.push({
		content: getNowFormatDate(true) //使用预置函数tools.js
	});

	//一行就是一组
	groupData = {
		type: "group",
		data: []
	};
	//mutableContentArray必定是偶数个，6个为1行[10,24,10,24,10,22]
	var colWidthParams = [10, 24, 10, 24, 10, 22];
	for(var i = 0; i < mutableContentArray.length; i++) {
		mutableContentArray[i]["width"] = colWidthParams[i % colWidthParams.length];
		if(groupData.data.length >= colWidthParams.length) {
			printDataArray.push(groupData);
			groupData = {
				type: "group",
				data: []
			};
		}
		groupData.data.push(mutableContentArray[i]);
	}
	if(groupData.data.length > 0) {
		printDataArray.push(groupData);
	}

	if(config["pageFooter"]) {
		printDataArray.push({
			content: config["pageFooter"],
			align: "center",
		});
	}
	var printData = {
		"printData": printDataArray,
		"paperType": config["printSize"]["PrickBase"]["paperType"]
	};
	return printData;
};

var createTplFuncCfg = {
	"销售单": {
		"tpl_58mm": create58PrintData_Sale,
		"tpl_80mm": create80PrintData_Sale,
		"tpl_prickbase": createPrickBasePrintData_Sale
	},
	"销售订单": {
		"tpl_58mm": create58PrintData_SaleOrder,
		"tpl_80mm": create80PrintData_SaleOrder,
		"tpl_prickbase": createPrickBasePrintData_SaleOrder
	},
	"销售退货单": {
		"tpl_58mm": create58PrintData_SaleReturn,
		"tpl_80mm": create80PrintData_SaleReturn,
		"tpl_prickbase": createPrickBasePrintData_SaleReturn
	},
	"零售单": {
		"tpl_58mm": create58PrintData_Retail,
		"tpl_80mm": create80PrintData_Retail,
		"tpl_prickbase": createPrickBasePrintData_Retail
	},
	"采购单": {
		"tpl_58mm": create58PrintData_Purchase,
		"tpl_80mm": create80PrintData_Purchase,
		"tpl_prickbase": createPrickBasePrintData_Purchase
	},
	"采购订单": {
		"tpl_58mm": create58PrintData_PurchaseOrder,
		"tpl_80mm": create80PrintData_PurchaseOrder,
		"tpl_prickbase": createPrickBasePrintData_PurchaseOrder
	},
	"采购退货单": {
		"tpl_58mm": create58PrintData_PurchaseReturn,
		"tpl_80mm": create80PrintData_PurchaseReturn,
		"tpl_prickbase": createPrickBasePrintData_PurchaseReturn
	},
	"库存盘点单": {
		"tpl_58mm": create58PrintData_Stocktaking,
		"tpl_80mm": create80PrintData_Stocktaking,
		"tpl_prickbase": createPrickBasePrintData_Stocktaking
	},
	"同价调拨单": {
		"tpl_58mm": create58PrintData_StockTransfer,
		"tpl_80mm": create80PrintData_StockTransfer,
		"tpl_prickbase": createPrickBasePrintData_StockTransfer
	},
	"变价调拨单": {
		"tpl_58mm": create58PrintData_StockTransferAdjust,
		"tpl_80mm": create80PrintData_StockTransferAdjust,
		"tpl_prickbase": createPrickBasePrintData_StockTransferAdjust
	},
	"付款单": {
		"tpl_58mm": create58PrintData_Payments,
		"tpl_80mm": create80PrintData_Payments,
		"tpl_prickbase": createPrickBasePrintData_Payments
	},
	"收款单": {
		"tpl_58mm": create58PrintData_Receipt,
		"tpl_80mm": create80PrintData_Receipt,
		"tpl_prickbase": createPrickBasePrintData_Receipt
	},
	"其他入库单": {
		"tpl_58mm": create58PrintData_StockOther,
		"tpl_80mm": create80PrintData_StockOther,
		"tpl_prickbase": createPrickBasePrintData_StockOther
	},
	"其他出库单": {
		"tpl_58mm": create58PrintData_StockOther,
		"tpl_80mm": create80PrintData_StockOther,
		"tpl_prickbase": createPrickBasePrintData_StockOther
	},
}