//打印插件接口定义
document.addEventListener("plusready", function() {
	var _BARCODE = "H5PluginPrint",
		B = window.plus.bridge;
	var H5PluginPrint = {
		//打印测试
		PluginPrintTest: function(data, successCallback, errorCallback) {
			var success = typeof successCallback !== 'function' ? null : function(args) {
				successCallback(args);
			};
			var fail = typeof errorCallback !== 'function' ? null : function(error) { //error是一个错误JSON对象
				errorCallback(error);
			};
			callbackID = B.callbackId(success, fail);
			return B.exec(_BARCODE, "pluginPrintTest", [callbackID, data]);
		},
		//扫描设备
		PluginPrintScanPeripherals: function(successCallback, errorCallback) {
			var success = typeof successCallback !== 'function' ? null : function(args) {
				successCallback(args);
			};
			var fail = typeof errorCallback !== 'function' ? null : function(error) { //error是一个错误JSON对象
				errorCallback(error);
			};
			callbackID = B.callbackId(success, fail);

			return B.exec(_BARCODE, "pluginPrintScanPeripheralsCallback", [callbackID]);
		},
		//连接设备
		PluginPrintConnectPeripherals: function(peripheralUUID, successCallback, errorCallback) {
			var success = typeof successCallback !== 'function' ? null : function(args) {
				successCallback(args);
			};
			var fail = typeof errorCallback !== 'function' ? null : function(error) { //error是一个错误JSON对象
				errorCallback(error);
			};
			callbackID = B.callbackId(success, fail);

			return B.exec(_BARCODE, "pluginPrintConnectPeripherialCallback", [callbackID, peripheralUUID]);
		},
		//打印数据type:58mm,80mm,PrickBase,tag
		PluginPrintData: function(type,printData, successCallback, errorCallback) {
			var success = typeof successCallback !== 'function' ? null : function(args) {
				successCallback(args);
			};
			var fail = typeof errorCallback !== 'function' ? null : function(error) { //error是一个错误JSON对象
				errorCallback(error);
			};
			callbackID = B.callbackId(success, fail);

			return B.exec(_BARCODE, "pluginPrintData", [callbackID,type, printData]);
		},
		//设置为当前连接设备
		PluginSetDefaultPrinter: function(uuidString) {
			return B.execSync(_BARCODE, "pluginPrintSetDefaultPrinter", [uuidString]);
		},
		//获取设备连接情况，已连接，未连接
		PluginGetAllPeripherals: function() {
			return B.execSync(_BARCODE, "pluginGetPeripheralDic", []);
		},
		//终止扫描
		PluginStopScanPeripheral: function() {
			return B.execSync(_BARCODE, "pluginPrintStopScanPeripheral", []);
		},
		//离开设备配对页面触发事件
		PluginPrintAwayFromConnect: function() {
			return B.execSync(_BARCODE, "pluginPrintAwayFromConnect", []);
		},
	};
	window.plus.H5PluginPrint = H5PluginPrint;
}, true);