/**
 * 获取订单状态
 * @param {Object} flag
 */
function getOrderStatus(flag) {
	var stateText = '待审核'
	switch(flag) {
		case 1:
			stateText = '待审核'
			break;
		case 2:
			stateText = '进行中'
			break;
		case 3:
			stateText = '已完成'
			break;
		case 4:
			stateText = '已中止'
			break;
		case 5:
			stateText = '已作废'
			break;
		default:
			stateText = ''
			break;
	}
	return stateText
}

/**
 * 获取订单待付款状态
 * @param {Object} flag
 */
function getOrderPaymentStatus(flag) {
	var stateText = '未付款'
	switch(flag) {
		case 0:
			stateText = '未付款'
			break;
		case 1:
			stateText = '待确认'
			break;
		case 2:
			stateText = '部分付款'
			break;
		case 3:
			stateText = '已付款'
			break;
		default:
			stateText = '未付款'
			break;
	}
	return stateText
}

/**
 * 获取发货状态
 * @param {Object} flag
 */
function getOrderDeliverStatus(flag) {
	var stateText = '待发货'
	switch(flag) {
		case 1:
			stateText = '未发货'
			break;
		case 2:
			stateText = '部分发货'
			break;
		case 3:
			stateText = '已发货'
			break;
		case 4:
			stateText = '已收货'
			break;
		case 5:
			stateText = '待收货'
			break;
		default:
			stateText = ''
			break;
	}
	return stateText
}
/**
 * 获取开发票类型
 * @param {Object} flag
 */
function getInvoiceType(flag) {
	var stateText = '不开票'
	switch(flag) {
		case 1:
			stateText = '不开票'
			break;
		case 2:
			stateText = '普通发票'
			break;
		case 3:
			stateText = '增值税发票'
			break;
		default:
			stateText = '不开票'
			break;
	}
	return stateText
}
/**
 * 获取订单运输类型
 * @param {Object} flag
 */
function getOrderShippingType(flag) {
	var stateText = '商户送货'
	switch(flag) {
		case 1:
			stateText = '商户送货'
			break;
		case 2:
			stateText = '快递'
			break;
		case 3:
			stateText = '货运'
			break;
		case 4:
			stateText = '上门自取'
			break;
		default:
			stateText = '商户送货'
			break;
	}
	return stateText
}

function getPaymentStatus(flag, channel) {
	var stateText = '待收款'
	switch(flag) {
		case 1:
			if(channel == 8) {
				stateText = '待支付';
			}
			break;
		case 2:
			stateText = '已收款';
			break;
		default:
			stateText = '待收款';
			break;
	}
	return stateText
}

/**
 * 获取退货状态
 * @param {Object} flag
 */
function getGoodsReturnStatus(flag) {
    var stateText = '待审核';
    switch(flag) {
        case 1:
            stateText = '待审核';
            break;
        case 2:
            stateText = '待客户发货';
            break;
        case 3:
            stateText = '待收货';
            break;
        case 4:
            stateText = '已完成';
            break;
        case 5:
            stateText = '已中止';
            break;
        case 6:
            stateText = '已作废';
            break;
        default:
            break;
    }
    return stateText
}

/**
 * 获取退货操作日志
 * @param {Object} flag
 */
function getGoodsReturnLogs(flag) {
	var stateText = '创建退货单';
	switch(flag) {
		case 1:
			stateText = '创建退货单';
			break;
		case 2:
			stateText = '审核通过';
			break;
		case 3:
			stateText = '审核失败';
			break;
		case 4:
			stateText = '已收货';
			break;
		case 5:
			stateText = '已完成';
			break;
		case 6:
			stateText = '客户端取消';
			break;
		case 7:
			stateText = '管理端取消';
			break;
		default:
			break;
	}
	return stateText
}

/**
 * 获取退货运输类型
 * @param {Object} flag
 */
function getGoodsReturnShippingType(flag) {
	var stateText = '上门退回';
	switch(flag) {
		case 1:
			stateText = '上门退回';
			break;
		case 2:
			stateText = '邮寄退回';
			break;
		case 4:
			stateText = '货运';
			break;
		case 8:
			stateText = '上门自取';
			break;
		default:
			stateText = '上门退回';
			break;
	}
	return stateText
}

/**
 *促销类型 
 */
function getPromotionTypeText(flag){
	var stateText = '打折';
	switch(flag) {
		case 1:
			stateText = '打折';
			break;
		case 2:
			stateText = '满赠';
			break;
		case 3:
			stateText = '组合';
			break;
		case 4:
			stateText = '满减';
			break;
		default:
			break;
	}
	return stateText
}
/**
 *促销类样式
 */
function getPromotionTypeClass(flag){
	var stateText = 'promotion-suit';
	switch(flag) {
		case 1:
			stateText = 'promotion-discount';
			break;
		case 2:
			stateText = 'promotion-gift';
			break;
		case 3:
			stateText = 'promotion-full-price-down';
			break;
		case 4:
			stateText = 'promotion-suit';
			break;
		case 5:
			stateText = 'promotion-combination';
			break;
		default:
			break;
	}
	return stateText
}
