var eventListener;
var Build;
var main ;
var receiver;
var Bundle ;
var Intent;
var IntentFilter ;

var ACTION_BARCODE_DATA = "com.honeywell.sample.action.BARCODE_DATA";
/**
 * Honeywell DataCollection Intent API
 * Claim scanner
 * Permissions:
 * "com.honeywell.decode.permission.DECODE"
 */
var ACTION_CLAIM_SCANNER = "com.honeywell.aidc.action.ACTION_CLAIM_SCANNER";
/**
 * Honeywell DataCollection Intent API
 * Release scanner claim
 * Permissions:
 * "com.honeywell.decode.permission.DECODE"
 */
var ACTION_RELEASE_SCANNER = "com.honeywell.aidc.action.ACTION_RELEASE_SCANNER";
/**
 * Honeywell DataCollection Intent API
 * Optional. Sets the scanner to claim. If scanner is not available or if extra is not used,
 * DataCollection will choose an available scanner. * Values : String
 * "dcs.scanner.imager" : Uses the internal scanner
 * "dcs.scanner.ring" : Uses the external ring scanner
 */
var EXTRA_SCANNER = "com.honeywell.aidc.extra.EXTRA_SCANNER";
/**
 * Honeywell DataCollection Intent API
 * Optional. Sets the profile to use. If profile is not available or if extra is not used, * the scanner will use factory default properties (not "DEFAULT" profile properties).
 * Values : String
 */
var EXTRA_PROFILE = "com.honeywell.aidc.extra.EXTRA_PROFILE";
/**
 * Honeywell DataCollection Intent API
 * Optional. Overrides the profile properties (non-persistent) until the next scanner claim. * Values : Bundle
 */
var EXTRA_PROPERTIES = "com.honeywell.aidc.extra.EXTRA_PROPERTIES";

document.addEventListener("plusready", function() {
    console.log("plusready begin");
    if(window.plus && mui.os.android){
        console.log("registerReceiver begin");
        Build= plus.android.importClass("android.os.Build");
        if(Build.BRAND==="Honeywell"){/*霍尼韦尔的设备都有扫描头*/
            Bundle = plus.android.importClass("android.os.Bundle");
            IntentFilter = plus.android.importClass('android.content.IntentFilter');
            Intent=plus.android.importClass("android.content.Intent");
            main = plus.android.runtimeMainActivity();
            console.log(main);
            receiver = plus.android.implements('io.dcloud.android.content.BroadcastReceiver', {
                onReceive: function(context, intent) { //实现onReceiver回调函数
                    console.log("onReceive"); //获取action
                    var action = intent.getAction();
                    console.log("action："+action); //获取action
                    switch (intent.getAction()) {
                        case ACTION_BARCODE_DATA://扫描头扫描
                            console.log("扫描头扫描结果返回");
                            var displayWebviews=plus.webview.getDisplayWebview();
                            for (var index in displayWebviews) {
                                if(displayWebviews[index]==plus.webview.currentWebview()){
                                    var version = intent.getIntExtra("version", 0);
                                    if (version >= 1) {
                                        var aimId = intent.getStringExtra("aimId");
                                        var charset = intent.getStringExtra("charset");
                                        var codeId = intent.getStringExtra("codeId");
                                        var data = intent.getStringExtra("data");
                                        var dataBytes = intent.getByteArrayExtra("dataBytes");
                                        var dataBytesStr = "";//bytesToHexString(dataBytes);
                                        var timestamp = intent.getStringExtra("timestamp");
                                        var text ="Data:"+data+",Charset:"+charset+",Bytes:"+dataBytesStr+",AimId:"+aimId+",CodeId:"+codeId+",Timestamp:"+timestamp;
                                        console.log("text:"+text);
                                        eventListener ? '' : eventListener = 'codeScanSuccessListener'; //如果没有传入监听器，则使用默认监听器
                                        console.log("eventListener:"+eventListener);
                                        window.plus ? mui.fire(plus.webview.currentWebview(), eventListener, {
                                            'result': data
                                        }) : '';
                                    }
                                }
                            }

                            break;
                    }
                }
            });
            main.registerReceiver(receiver, new IntentFilter(ACTION_BARCODE_DATA));
            var  properties = new Bundle();
            properties.putBoolean("DPR_DATA_INTENT", true);
            properties.putString("DPR_DATA_INTENT_ACTION", ACTION_BARCODE_DATA);
            main.sendBroadcast(new Intent(ACTION_CLAIM_SCANNER).putExtra(EXTRA_SCANNER, "dcs.scanner.imager")
                .putExtra(EXTRA_PROFILE, "DEFAULT").putExtra(EXTRA_PROPERTIES, properties)
            );
            // main.onResume = function(){
            //     main.super.onResume();
            //     console.log("onResume"); //获取action
            //     if(receiver!=null){
            //         main.registerReceiver(receiver, new IntentFilter(ACTION_BARCODE_DATA));
            //         var  properties = new Bundle();
            //         properties.putBoolean("DPR_DATA_INTENT", true);
            //         properties.putString("DPR_DATA_INTENT_ACTION", ACTION_BARCODE_DATA);
            //         main.sendBroadcast(new Intent(ACTION_CLAIM_SCANNER).putExtra(EXTRA_SCANNER, "dcs.scanner.imager")
            //             .putExtra(EXTRA_PROFILE, "DEFAULT").putExtra(EXTRA_PROPERTIES, properties)
            //         );
            //     }
            // };
            // main.onPause = function(){
            //     main.super.onPause();
            //     console.log("onPause"); //获取action
            //     main.unregisterReceiver(receiver);
            //     main.sendBroadcast(new Intent(ACTION_RELEASE_SCANNER));
            //     receiver=null;
            // };
            console.log("registerReceiver end");
        }
    }
    console.log("plusready end");
    // // 声明的JS“扩展插件别名”
    // var ddhPluginAndroid =
    //     {
    //
    //         // 声明同步返回方法 获取获取已匹配设备
    //         isHoneywell : function (Argus)
    //         {
    //
    //             return window.plus.bridge.execSync('ddhPluginAndroid', "isHoneywell", [Argus]);
    //         },
    //     };
    // window.plus.ddhPluginAndroid = ddhPluginAndroid;
    //
    //
}, true);

/**
 * 撤销广播监听 发送结束扫描头广播
 */
function unregisterScan() {
    if(window.plus && mui.os.android &&Build!=null&& Build.BRAND==="Honeywell"){
        main.unregisterReceiver(receiver);
        main.sendBroadcast(new Intent(ACTION_RELEASE_SCANNER));
    }
}