/**
 * @copyright HK
 * @author HK.D
 * @description.This class is written by HK used for build a map object in JS file.The prototype implements serval methods to operate the map.
 */
function HashMap() {
	this.map = {};
}
HashMap.prototype = {
	constructor: HashMap,
	put: function(key, value) {
		this.map[key] = value;
	},
	set: function(key, value) {
		this.map[key] = value;
	},
	get: function(key) {
		if(this.map.hasOwnProperty(key)) {
			return this.map[key];
		}
		return null;
	},
	size: function() {
		return Object.getOwnPropertyNames(this.map).length;
	},
	remove: function(key) {
		if(this.map.hasOwnProperty(key)) {
			return delete this.map[key];
		}
		return false;
	},
	has: function(key) {
		return this.map.hasOwnProperty(key);
	},
	delete: function(key) {
		if(this.map.hasOwnProperty(key)) {
			return delete this.map[key];
		}
		return false;
	},
	removeAll: function() {
		this.map = {};
	},
	clear: function() {
		this.map = {};
	},
	keySet: function() {
		var _keys = [];
		for(var i in this.map) {
			_keys.push(i);
		}
		return _keys;
	},
	forEach: function(callback) {
		for(var k in this.map) {
			if(this.map.hasOwnProperty(k)) {
				callback(this.map[k], k);
			}
		}
	}
};