//********************Demo HTML constructor
//<div class="hk-numberbox">
//<button class="hk-numberbox-minus-btn"></button>
//<input type="number" value="0" data-numberbox-max='0' data-numberbox-min='8' data-numberbox-step='{{i}}'/>
//<button class="hk-numberbox-plus-btn"></button>
//</div>
/**
 * @copyright HK.D
 * @description This library is written by HK and used for build a input numberbox with plus and minus button.
 */

function __HKNumberbox() {}
__HKNumberbox.prototype.formatNumber = function(v, digits) {
	var m = Math.pow(10, digits);
	return Math.round(v * m) / m;
}
__HKNumberbox.prototype.triggerEvent = function(el, eventName) {
	var nodeName = el.nodeName,
		safari_chrome = /webkit/.test(navigator.userAgent.toLowerCase());
	if(safari_chrome && (nodeName != 'INPUT' || nodeName != 'BUTTON')) {
		try {
			var evt = document.createEvent('Event');
			evt.initEvent(eventName, true, true);
			el.dispatchEvent(evt);
		} catch(e) {
			console.log(e)
		};
	}
}
// init all
__HKNumberbox.prototype.InitNumberbox = function() {
	var _self = this;
	var myStyleNode = document.querySelector('style');
	if(!myStyleNode) {
		myStyleNode = document.createElement('style');
	}
	var textNode = document.createTextNode('.hk-numberbox {height: 40px;position: relative;border: none;min-width: 150px;}' +
		'.hk-numberbox>button {border: none;width: 22px;height: 28px;padding: 0;color: #666;position: absolute;top: 6px;border-color: #999;line-height:1;z-index:99;background-color: #F2F2F2;}' +
		'.hk-numberbox>button:active {opacity:0.4;}' +
		'.hk-numberbox>input {width: 100%;position: absolute;left: 0;margin: 0;padding: 2px 24px !important;height: 30px !important;top: 5px;font-size: 14px;color: #333;font-weight: 500;border: 1px solid #dbdbdb !important;text-align: center;}' +
		'.hk-numberbox-minus-btn {left: 1px;border-right: 1px solid #dbdbdb !important;border-top-right-radius: 0;border-bottom-right-radius: 0;}' +
		'.hk-numberbox-minus-btn:before {content:"﹣";}' +
		'.hk-numberbox-plus-btn {right: 1px;border-left: 1px solid #dbdbdb !important;border-top-left-radius: 0;border-bottom-left-radius: 0;}' +
		'.hk-numberbox-plus-btn:before {content:"＋";}'
	);
	myStyleNode.appendChild(textNode);
	//	document.querySelector('head').appendChild(myStyleNode);
	document.querySelector('body').addEventListener('tap', function(e) {
		//minus button
		if(e.target.classList.contains('hk-numberbox-minus-btn')) {
			var inputBox = e.target.parentNode.querySelector('input');
			var _stepNumber = inputBox.getAttribute('data-numberbox-step');
			if(_stepNumber && !isNaN(_stepNumber) && Number(_stepNumber) > 0) {
				_stepNumber = Number(_stepNumber);
			} else {
				_stepNumber = 1;
			}
			var _minVal = inputBox.getAttribute('data-numberbox-min');
			if(_minVal && !isNaN(_minVal)) {
				_minVal = Number(_minVal);
			} else {
				_minVal = 0;
			}
			var _v = Number(inputBox.value);
			_v = _self.formatNumber(_v - _stepNumber, 4);
			if(_v < 0 || _v < _minVal) {
				_v = _minVal;
			}
			inputBox.value = _v;
			_self.triggerEvent(inputBox,'change');
		} else if(e.target.classList.contains('hk-numberbox-plus-btn')) { //plus button
			var inputBox = e.target.parentNode.querySelector('input');
			var _stepNumber = inputBox.getAttribute('data-numberbox-step');
			if(_stepNumber && !isNaN(_stepNumber) && Number(_stepNumber) > 0) {
				_stepNumber = Number(_stepNumber);
			} else {
				_stepNumber = 1;
			}
			var _maxValStr = inputBox.getAttribute('data-numberbox-max');
			var _maxVal;
			if(_maxValStr && !isNaN(_maxValStr)) {
				_maxVal = Number(_maxValStr);
			} else {
				_maxVal = 0;
			}
			var _v = Number(inputBox.value);
			_v = _self.formatNumber(_v + _stepNumber, 4);
			if(_maxValStr && _v > _maxVal) {
				_v = _maxVal;
			}
			inputBox.value = _v;
			_self.triggerEvent(inputBox,'change');
		}
	}, false);
	//keydown event
	document.querySelector('body').addEventListener('keydown', function(e) {
		if(e.target.parentNode.classList.contains('hk-numberbox')) {
			if(isNaN(parseInt(String.fromCharCode(e.keyCode), 10)) && e.keyCode != 8 && e.keyCode != 190) {
				e.returnValue = false;
			}
		}
	}, false);
	//change event
	document.querySelector('body').addEventListener('change', function(e) {
		if(e.target.parentNode.classList.contains('hk-numberbox')) {
			var inputBox = e.target;
			if(!/^\d+(.\d{0,100})?$/.test(inputBox.value)) {
				inputBox.value = inputBox.defaultValue;
			}
			var _maxValStr = inputBox.getAttribute('data-numberbox-max');
			var _maxVal;
			if(_maxValStr && !isNaN(_maxValStr)) {
				_maxVal = Number(_maxValStr);
			} else {
				_maxVal = 0;
			}
			var _minVal = inputBox.getAttribute('data-numberbox-min');
			if(_minVal && !isNaN(_minVal)) {
				_minVal = Number(_minVal);
			} else {
				_minVal = 0;
			}
			var _v = Number(inputBox.value);
			if(_maxValStr && _v >= _maxVal) {
				inputBox.value = _maxVal;
				e.target.parentNode.children[2].setAttribute('disabled','disabled')//disable +
				e.target.parentNode.children[0].removeAttribute('disabled')//enable -
			}else if(_v <= 0 || _v <= _minVal) {
				inputBox.value = _minVal;
				e.target.parentNode.children[0].setAttribute('disabled','disabled')//disable _
				e.target.parentNode.children[2].removeAttribute('disabled')//enable +
			}else{
				e.target.parentNode.children[0].removeAttribute('disabled')//enable -
				e.target.parentNode.children[2].removeAttribute('disabled')//enable +
			}
		}
	}, true);
};
!(function() {
	//batch init
	new __HKNumberbox().InitNumberbox();
})();